;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;							
;		*1228063 Disassembly*			
;							
;	By Adam "Dimented24x7" Headley		
;		
;	This was intended from the start to be working compilable 
;	source code so its from my latest 'bin' at the time so that I could 
;	compile and put it to use with as little modification as possible. 
;	If something looks odd, that's probably because I changed it. I can't
;	make any guarantees as to the accuracy of the information here so use
;	at your own risk. 
;
;	I'd like to thank Robert Rauscher for his dissasembly of the '8746. 
;	Alot of the code from the '8063 was present in the '8746 ECMs of the 
;	following years so it was a big help.
;	 
;							
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
;-RAM addr.
;
;~~~~~~~~~~~~~~~~~~~~~~~
;
L0000   EQU    $0000		;Status word
				 ;b7 = diag, EST err.
				 ;b6 = diag, EST ok
				 ;b5 = Very low batt. volts, force shutdown in effect
				 ;b4 = Engine shutdown
				 ;b3 = used in EST diag. engine is off.
				 ;b2 = Stack overflow err.
				 ;b1 = Do HU
				 ;b0 = stack err.
; 
L0001   EQU    $0001		;Status word
				 ;b7 = Engine is running
				 ;b6 =
				 ;b5 =
				 ;b4 =
				 ;b3 = 
				 ;b2 =
				 ;b1 =
				 ;b0 = SA < 0
;
L0002   EQU    $0002		;Status word
				 ;b7 = Idling, Non-ALDL mode
				 ;b6 =
				 ;b5 = > 2 volts, ALDL mode
				 ;b4 = < .8 volts, field service mode
				 ;b3 = < 2 volts, backup mode
				 ;b2 =
				 ;b1 =
				 ;b0 =
			        ;Normal mode     res>= 20 kOhm
		                ;ALDL mode       res = 10 kOhm
		                ;Backup mode     res = 3.9 kOhm
		                ;Field Service   res<= 500 Ohm 
;
L0003   EQU    $0003		;Status word
			         ;b7 = Idle speed is higher then desired idle speed
				 ;b6 = Eng cool >= -5 deg C
				 ;b5 = Eng cool < -5 deg C
				 ;b4 = Use stay in closed loop quals
				 ;b3 = In P/N
				 ;b2 = A/C idle compensation in effect
				 ;b1 =
				 ;b0 = Forced to open loop
;
L0005   EQU    $0005		;Status word
				 ;b7 = Command TCC/SL
				 ;b6 = MPH thresh for EGR on met
				 ;b5 = TPS thresh for EGR on met
				 ;b4 = 
				 ;b3 = CCP in progress
				 ;b2 = Temp thresh for EGR on met
				 ;b1 = CCP has changed state
				 ;b0 = Vac thresh for EGR on met
;
L0006   EQU    $0006		;Status word
				 ;b7 =
				 ;b6 = Used in field service mode
				 ;b5 =
				 ;b4 = Cross count occured
				 ;b3 =
				 ;b2 =
				 ;b1 = 
				 ;b0 = do factory diags.
;
L0007   EQU    $0007		;Status word
				 ;b7 =
				 ;b6 =	
				 ;b5 =
				 ;b4 =
				 ;b3 = DFCO flag
				 ;b2 = 
				 ;b1 = Air select on
				 ;b0 = Air divert off
;
L0008   EQU    $0008		;Status word
				 ;b7 = MAP test failed, low MAP err.
				 ;b6 = MAP test failed, high MAP err.
				 ;b5 = TPS low err
				 ;b4 =
				 ;b3 = Diag. routine, one second has elapsed
				 ;b2 = TPS high err
				 ;b1 =
				 ;b0 = In clr flood mode
;
L0009   EQU    $0009		;Status word
				 ;b7 = knock detected
				 ;b6 = Runaway knock in progress
				 ;b5 = ESC failure
				 ;b4 = ESC test, Add in addl. spark to force knock
				 ;b3 =
				 ;b2 = Do not perform fuel pump volts low test
				 ;b1 = Fuel pump volts low, relay failure
				 ;b0 =
;
				
L000A   EQU    $000A		;Status word
				 ;b7 = Field service mode in effect
				 ;b6 =
				 ;b5 = run CTS high test
				 ;b4 = run CTS low test
				 ;b3 = CTS failure
				 ;b2 =
				 ;b1 = O2 err
				 ;b0 =
;
L000B   EQU    $000B		;Status word
				 ;b7 =
				 ;b6 = IAT bit, used in diag. test
				 ;b5 = IAT bit, used in diag. test
				 ;b4 = EGR err timer elapsed
				 ;b3 =
				 ;b2 =
				 ;b1 =
				 ;b0 = EGR test failed
;
L000C   EQU    $000C		;Status word, field service alg.
				 ;b7 =
				 ;b6 = xmitting err code via SES 
				 ;b5 = xmitting 1's portion of code
				 ;b4 = SES off next pass
				 ;b3 =
				 ;b2 =
				 ;b1 =
				 ;b0 -
;
L000D   EQU    $000D		;Status word
				 ;b7 = In PE
				 ;b6 = Reset INT on AE
				 ;b5 = async fuel in eff.
				 ;b4 = Decel enlean underway
				 ;b3 =
				 ;b2 =
				 ;b1 =
				 ;b0 =
;		
L000E   EQU    $000E		;A/F mode flag
				 ;b7 = closed loop flag
				 ;b6 = rich/lean ind.
				 ;b5 = low/high gear status on last pass
				 ;b4 = async fuel in effect
				 ;b3 = post downshift TCC lockup delay in effect
				 ;b2 = low battery
				 ;b1 = blm store enable
				 ;b0 = 
;		
L000F   EQU    $000F		;Status word
				 ;b7 =
				 ;b6 =
				 ;b5 =
				 ;b4 =
				 ;b3 =
				 ;b2 =
				 ;b1 =
				 ;b0 = High speed fuel cutoff in effect
;
L0010   EQU    $0010		;Status word
				 ;b7 = Stall saver in effect
				 ;b6 =
				 ;b5 = Engine speed is lower then target idle speed
				 ;b4 = In P/N
				 ;b3 = A/C req.
				 ;b2 = PSPS closed
				 ;b1 =
				 ;b0 =
;
L0011   EQU    $0011		;
L0012   EQU    $0012		;Error flag 1
L0013   EQU    $0013		;Error flag 2
L0014   EQU    $0014		;Error flag 3
L0015   EQU    $0015		;
L0016   EQU    $0016		;Checksum, MSB
L0017   EQU    $0017		;Checksum, LSB
L0018   EQU    $0018		;DRP's, MSB
L0019	EQU    $0019		;DRP's, LSB
L001A   EQU    $001A		;Scaled RPM, 400-2400 in 12.5 rpm inc., 2400-4800 in 25 rpm inc.
L001B   EQU    $001B		;RPM/25
L001C   EQU    $001C		;RPM/25, one delayed
L001D   EQU    $001D		;RPM/12.5, filtered
L001E   EQU    $001E		;
L001F   EQU    $001F		;RPM/12.5, one delayed
L0020   EQU    $0020		;Coolant, inv., A/D counts
L0021   EQU    $0021		;Startup cool temp, A/D counts
L0022   EQU    $0022		;defaulted coolant, inv. A/D counts
L0023   EQU    $0023		;IAT, inv. A/D counts
L0024   EQU    $0024		;SD MAP
L0025   EQU    $0025            ;SD MAP, one delayed
L0026   EQU    $0026		;SD map, two delayed
L0027   EQU    $0027		;Raw filtered MAP, MSB
L0028   EQU    $0028		;Raw fitlered MAP, LSB
L0029   EQU    $0029		;A/D map
L002A   EQU    $002A		;MAP term for grms/sec & BPW calc
L002B   EQU    $002B		;S/D MAP, slow filterd
L002C	EQU    $002C		;
L002D   EQU    $002D		;Vacuum
L002E   EQU    $002E		;Delta MAP for AE
L002F   EQU    $002F		;Baro factor for %VE lookup
L0030   EQU    $0030		;MPH, filtered, MSB
L0031	EQU    $0031		;MPH, filtered, LSB
L0032   EQU    $0032		;VSS interval counter
L0033   EQU    $0033		;
L0034   EQU    $0034		;
L0035   EQU    $0035		;
L0036   EQU    $0036		;
L0037   EQU    $0037		;
L0038	EQU    $0038		;
L0039   EQU    $0039		;02 counts
L003A   EQU    $003A		;02, minor loop filtered, MSB
L003B   EQU    $003B		;02, minor loop filtered, LSB
L003C   EQU    $003C		;
L003E   EQU    $003E		;
L003F	EQU    $003F		;
L0040   EQU    $0040		;Batt volts x 10, A/D counts
L0041   EQU    $0041		;Fuel pump volts x 10, A/D counts
L0042   EQU    $0042		;TPS counts, A/D counts, volts = X * .0196
L0043   EQU    $0043		;%TPS
L0044   EQU    $0044		;%TPS, one delayed	
L0045   EQU    $0045		;%TPS, Slow filtered, MSB
L0046   EQU    $0046  		;%TPS, slow filtered, LSB
L0047   EQU    $0047		;TPS min position, MSB
L0048   EQU    $0048		;TPS min position, LSB
L0049   EQU    $0049		;tmp storage
L004A   EQU    $004A		;tmp storage
L004B   EQU    $004B		;tmp storage
L004C   EQU    $004C		;tmp storage
L004D   EQU    $004D		;tmp storage
L004E   EQU    $004E		;tmp storage
L004F   EQU    $004F		;tmp storage
L0050   EQU    $0050		;tmp storage
L0051   EQU    $0051		;DRPs, engine run timed out
L0052   EQU    $0052		;Fuel pump volts test timer
L0055   EQU    $0055		;
L0056   EQU    $0056		;VATS err. timer
L0057   EQU    $0057		;DRP, one delayed, MSB
L0058   EQU    $0058		;DRP, one delayed, LSB
L0059   EQU    $0059		;dynamic dwell, MSB
L005A   EQU    $005A		;dynamic dwell, LSB
L005B   EQU    $005B		;Dwell to ecm, MSB
L005C   EQU    $005C		;Dwell to ecm, LSB
L005D   EQU    $005D		;EGR active SA, MSB
L005E   EQU    $005E		;EGR active SA, LSB
L005F   EQU    $005F		;Cool comp. SA 
L0060   EQU    $0060		;TCC locked spark retard
L0061   EQU    $0061		;Stored SA, MSB
L0062   EQU    $0062            ;Stored SA, LSB
L0063   EQU    $0063		;DRP info, MSB
L0064   EQU    $0064		;DRP info, LSB
L0065   EQU    $0065		;
L0066   EQU    $0066		;Real time subroutine counter
L0067   EQU    $0067		;For A/D hardware
L0068   EQU    $0068		;
L0069   EQU    $0069		;Pulse acc. counts (from knock counter), MSB
L006A   EQU    $006A		;Pulse acc. counts (from knock counter), LSB
L006B   EQU    $006B		;
L006C   EQU    $006C		;Timer for knock retard alg.
L006D   EQU    $006D		;Timer to test for runaway knock
L006E   EQU    $006E		;Accumulated knock retard
L006F   EQU    $006F		;HW mode timer, MSB
L0070   EQU    $0070		;HW mode timer, LSB
L0071   EQU    $0071		;ALDL
L0072   EQU    $0072		;ALDL byte count, 20
L0073   EQU    $0073		;ALDL byte count
L0074   EQU    $0074		;RPMs over limit timer, AIR
L0075   EQU    $0075		;RTS O2 rich timer, AIR
L0076   EQU    $0076		;O2 lean in closed loop timer, AIR
L0077   EQU    $0077		;One delayed SD MAP, AIR
L0078   EQU    $0078		;Hard accel timer, AIR
L0079   EQU    $0079		;Forced to open loop timer, AIR
L007A   EQU    $007A		;In PE timer, AIR
L007B   EQU    $007B		;
L007C   EQU    $007C		;
L007D   EQU    $007D		;rpm/drive ratio
L007E   EQU    $007E		;Filtered rpm/drive ratio, MSB
L007F   EQU    $007F		;Filtered rpm/drive ratio, LSB	
L0080   EQU    $0080		;
L0081   EQU    $0081		;
L0082   EQU    $0082		;
L0083   EQU    $0083		;10's counter, blink SES routine
L0084   EQU    $0084		;1's counter, blink SES routine
L0085   EQU    $0085		;Cycle counter, blink SES routine
L0086   EQU    $0086		;Stored malf flag value, blink SES routine
L0087   EQU    $0087		;Delay timer to change state, blink SES routine
L0088   EQU    $0088		;TPS err. timer
L0089   EQU    $0089		;O2 lean err timer
L008A   EQU    $008A		;O2 rich err timer
L008B   EQU    $008B		;O2 window err. timer
L008C   EQU    $008C		;MAP high err timer
L008D   EQU    $008D		;MAP low err timer
L008E   EQU    $008E		;EGR err timer
L008F   EQU    $008F		;
L0091   EQU    $0091		;Delta pressure from egr diag. routine
L0092   EQU    $0092		;timer from EGR diag routine
L0093   EQU    $0093		;ESC counter
L0094   EQU    $0094		;VSS error timer
L0095   EQU    $0095		;
L0096   EQU    $0096		;EST curcuit data
L0098   EQU    $0098		;
L0099   EQU    $0099		;Delay timer for fuel pump volts test
L009A   EQU    $009A		;tmp async fuel, MSB
L009B   EQU    $009B		;tmp async fuel, LSB
L009C   EQU    $009C		;AE cool correction factor
L009D   EQU    $009D		;transient fuel calc interval timer
L009E   EQU    $009E		;
L009F   EQU    $009F		;Decel enlean cool. factor
L00A0   EQU    $00A0		;
L00A1   EQU    $00A1		;Post DFCO timer
L00A2   EQU    $00A2		;DFCO timer
L00A3   EQU    $00A3
L00A4   EQU    $00A4		;BLM, bin value
L00A5   EQU    $00A5		;INTegrator
L00A6   EQU    $00A6		;Desired AFR, stoich
L00A7   EQU    $00A7		;Delay timer, used in force open loop alg.
L00A8   EQU    $00A8		;HW mode timer
L00A9   EQU    $00A9		;
L00AA   EQU    $00AA		;
L00AB	EQU    $00AB		;
L00AC   EQU    $00AC		;%VE
L00AD   EQU    $00AD		;
L00AE   EQU    $00AE		;sync BPW, MSB
L00AF   EQU    $00AF		;sync BPW, LSB
L00B0   EQU    $00B0		;Async fuel acc., MSB
L00B1   EQU    $00B1		;Async fuel acc., LSB
L00B2   EQU    $00B2		;
L00B3   EQU    $00B3		;
L00B4   EQU    $00B4		;
L00B5   EQU    $00B5		;
L00B6   EQU    $00B6		;
L00B7   EQU    $00B7		;Crank AFR
L00B8   EQU    $00B8		;AFR mult. vs cool temp.
L00B9   EQU    $00B9		;
L00BA   EQU    $00BA		;
L00BB   EQU    $00BB		;
L00BC   EQU    $00BC		;
L00BD   EQU    $00BD		;02, minor loop filtered, one delayed
L00BE   EQU    $00BE		;
L00BF   EQU    $00BF		;
L00C0   EQU    $00C0		;startup choke adj. to AFR
L00C1   EQU    $00C1		;startup choke decay delay timer
L00C2   EQU    $00C2		;IAC steps, lag filtered
L00C3   EQU    $00C3		;IAC steps, filtered
L00C4   EQU    $00C4		;
L00C5   EQU    $00C5		;Stall saver IAC steps
L00C7   EQU    $00C7		;Filtered throttle follower steps, MSB
L00C8	EQU    $00C8		;Filtered throttle follower steps, LSB
L00C9   EQU    $00C9		;Stored throttle follower steps, raw
L00CA   EQU    $00CA		;Idle adj delay timer
L00CB   EQU    $00CB		;IAC steps, used in IAC output
L00CC   EQU    $00CC		;Added IAC steps if A/C on
L00CD   EQU    $00CD		;IAC trim (-)
L00CE   EQU    $00CE		;IAC trim (+)
L00CF   EQU    $00CF		;IAC steps vs. coolant
L00D0   EQU    $00D0		;Target idle speed
L00D1   EQU    $00D1		;
L00D2	EQU    $00D2		;
L00D3	EQU    $00D3		; stack check word
L00D4	EQU    $00D4		; stack
L00D5	EQU    $00D5		; stack
L00D6	EQU    $00D6		; stack
L00D7	EQU    $00D7		; stack
L00D8	EQU    $00D8		; stack
L00D9	EQU    $00D9		; stack
L00DA   EQU    $00DA		; stack
L00DB	EQU    $00DB		; stack
L00DC	EQU    $00DC		; stack start
L00DD   EQU    $00DD		;
L00DE   EQU    $00DE		;Status word
         			 ;b7 =  
				 ;b6 = VSS error
				 ;b5 =
				 ;b4 =
				 ;b3 =
				 ;b2 = Perform fuel pump volts low test 
				 ;b1 = Time thresh for closed loop met
				 ;b0 =
;
L00DF   EQU    $00DF		;Status word
				 ;b7 =
				 ;b6 = VATS, engine start ok
				 ;b5 = Set on EGR failure
				 ;b4 = IAC kickdown occured
				 ;b3 =
				 ;b2 = Hot restart in effect
				 ;b1 = EGR active?
				 ;b0 =	
;	
L00E0   EQU    $00E0		;Status word
         			 ;b7 = IAC I/O control for IAC-A
				 ;b6 = IAC I/O control for IAC-B
				 ;b5 = MCU1 enable/disable 
				 ;b4 = Skip min tps thresh for delta TPS AE
				 ;b3 =
				 ;b2 = IAC enabled bit
				 ;b1 =
				 ;b0 = IAC retract in effect?
;				
L00E1   EQU    $00E1		;Malf flag 1
L00E2   EQU    $00E2		;Malf flag 2
L00E3   EQU    $00E3		;Malf flag 3
L00E4   EQU    $00E4		;IAC pos, lookup vs. baro, idle control
L00E5   EQU    $00E5		;Choke adj. to AFR
L00E6   EQU    $00E6		;
L00E7   EQU    $00E7		;Choke SA vs. temp.
L00E8   EQU    $00E8		;Choke SA delay timer
L00E9   EQU    $00E9		;
L00EA   EQU    $00EA		;Err flag, Checksum	
L00EB   EQU    $00EB		;Eng run time, MSB
L00EC   EQU    $00EC		;Eng run time, LSB
;
;~~~~~~~~~~~~~~~~~~~~~~
;
;BLM cells, 4x4 array
;
;~~~~~~~~~~~~~~~~~~~~~~  
;  
L00ED   EQU    $00ED  		;blm cell 0
L00EE   EQU    $00EE		;blm cell 1
L00EF   EQU    $00EF		;blm cell 2
L00F0   EQU    $00F0		;blm cell 3
;
L00F1   EQU    $00F1		;blm cell 4
L00F2   EQU    $00F2		;blm cell 5
L00F3	EQU    $00F3		;blm cell 6
L00F4   EQU    $00F4		;blm cell 7
;
L00F5   EQU    $00F5		;blm cell 8
L00F6   EQU    $00F6		;blm cell 9
L00F7   EQU    $00F7		;blm cell 10
L00F8   EQU    $00F8		;blm cell 11
;
L00F9   EQU    $00F9 		;blm cell 12
L00FA   EQU    $00FA		;blm cell 13
L00FB   EQU    $00FB		;blm cell 14
L00FC   EQU    $00FC		;blm cell 15
;
L00FD   EQU    $00FD		;Current IAC pos.
L00FE   EQU    $00FE		;Baro pressure, A/D counts, MSB
L00FF   EQU    $00FF		;Baro pressure, A/D counts, LSB
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-HU RAM
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L040D	EQU    $040D		;
L0447	EQU    $0447		;
L0453   EQU    $0453		;
L0454   EQU    $0454		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-HU addr.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
L5800   EQU    $5800		;		
L5803   EQU    $5803		;
L5806   EQU    $5806		;
L5809   EQU    $5809		;
L580C   EQU    $580C		;
L580F   EQU    $580F		;
L5812   EQU    $5812		;
L5815   EQU    $5815		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-ECM hardware addresses 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
;
;-I/O
;
L0801	 EQU	$0801		; MCU2 I/O 
;
				; In:
				;   b7 ~A/C Request
				;   b6 P/S switch
				;   b5 High Gear
				;   b4 Park/Neutral
				; 
				; Out:
				;   b3 TCC/Shift Light
				;   b2 A/C Drive
				;   b1 Air Divert
				;   b0 Air Select
;
L0880	 EQU	$0880		; Monitor BatV loss (b7)
;
L0881	 EQU	$0881		; MCU1 I/O

				; In:
				;   b7 gnd
				;   b6 cal12
				;   b5 ~cranking
				;   b4 b9in
				; 
				; Out:
				;   b3 sentry, distributor bypass
				;   b2 iac-enable
				;   b1 iac-b
				;   b0 iac-a

;
LC000   EQU    $C000		;A/D converter
LC002   EQU    $C002		;A/D converter
;
;-Counters
;
LBC00   EQU    $BC00		;DRP counter
LBC02   EQU    $BC02		;VSS counter
LBC04   EQU    $BC04		;MAF/VATS freq
LBC06   EQU    $BC06		;EST circuit
LBC08	EQU    $BC08		;Cam sens.
LBC0A   EQU    $BC0A		;Knock counter
LBC0C   EQU    $BC0C		;
LBC0E   EQU    $BC0E		;sync bpw
LBC10   EQU    $BC10		;
LBC12   EQU    $BC12		;ALDL serial data		
LBC14   EQU    $BC14		;egr
LBC16   EQU    $BC16		;CCP
LBC18   EQU    $BC18		;
LBC1A   EQU    $BC1A		;
LBC1C   EQU    $BC1C		;Spark dwell counter, pw
LBC1E   EQU    $BC1E            ;
LBC20   EQU    $BC20		;EST fall counter, time from pulse to coil fire
LBC22	EQU    $BC22		;
LBC24   EQU    $BC24		;EST
LBC26   EQU    $BC26		;Last EST fall counter
LBC28   EQU    $BC28		;EST fall  -last est counter
LBC2A   EQU    $BC2A		;
LBC2C   EQU    $BC2C		;EST
LBC2E   EQU    $BC2C		;
LBC30   EQU    $BC2E		;
LBC32   EQU    $BC32		;
LBC34   EQU    $BC34		;EST fall counter
LBC36   EQU    $BC36		;
LBC38   EQU    $BC38		;ecm, high speed rts counter
LBC3A   EQU    $BC38		;
LBC3C   EQU    $BC3C		;PWM control register:
				;    0000 0000 0000 1010 - powerup
				;    1111 1001 0010 1010 - init
				;    0000 0000 0000 0100 - watchdog bit
				;    0000 0000 0000 1000 - SES light
				;    0000 0000 0001 0000 - est
				;    0000 0000 1000 0000 - async bpw
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Addresses of constant & source code org
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LPROM_START  EQU  $D000
LCODE_START  EQU  $D531  
LCHKSM_END   EQU  $E000
;          
;       
                                    ORG    LPROM_START
;          
;          
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Some conversion stuff...
;>SPARK
; -SA           = X * .351653
; -Slope SA     = X * .109863
;>RPM
; -RPM	        = X / 25
; -Scaled RPM   = X / 12.5, 25
;>TPS
; -TPS		= X * .0039 
;>MAP/VAC
; -SdMap        = ((ADC - 26) x 151 ) / 128
; -kPa          = (SD map x .3125) + 20
; -kPa          = (ADC x 0.369) + 10.415
; -VACkPa       = .313(256-Vac counts)
;
;>Coolant counts conversion table
;
;	 A/D 	degrees		A/D
; 	counts     C		Inv
; 	------- -------		---
; 	255	    -40		  0
; 	251	    -30		  4
; 	250	    -25		  5
; 	247	    -20		  8
; 	245	    -15		 10
; 	241	    -10		 14
; 	237	    - 5		 18
; 	231	      0		 24
; 	225	      5		 30
; 	218	     10		 37
; 	209	     15		 46
; 	199	     20		 56
; 	189	     25		 66
; 	177	     30		 78
; 	165	     35		 90
; 	152	     40		103
; 	139	     45		116
; 	126	     50		129
; 	114	     55		141
; 	102	     60		153
; 	92	     65		163
; 	81	     70		174
; 	72	     75		183
; 	64	     80		191
; 	56	     85		199
; 	50	     90		205
; 	44	     95		211
; 	39	    100		216
; 	34	    105		221
; 	30	    110		225
; 	26	    115		229
; 	23	    120		232
; 	21	    125		234
; 	18	    130		237
; 	16	    135		239
; 	14	    140		241
; 	13	    145		242
; 	12	    150		243
; 	0	    200		255
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD000 	 FDB     $7F2A		;Checksum
LD002 	 FDB     $024F		;Prom ID		
;
LD004 	 FCB     $4D		;Mask ID
;
;~~~~~~~~~~~~~~
;-Option bytes
;~~~~~~~~~~~~~~
; 
; 1 = enable option
; 0 = disable option
;
LD005 	 FCB     $63		;opt byte = 0110 0011
				 ;b7 =
				 ;b6 = Clamp BLM cell values on restart
				 ;b5 = Use IAT for lookups
				 ;b4 =
				 ;b3 =
				 ;b2 =
				 ;b1 = Unlock TCC when in DFCO
				 ;b0 = Use MPH for AIR thresholds
;  		
LD006 	 FCB     $21		;opt byte = 0010 0001
				 ;b7 =
				 ;b6 =
			   	 ;b5 = Reset INT if AE in effect
				 ;b4 = Reset INT if changing BLM cells
				 ;b3 = do baro fuel corr.
				 ;b2 =
				 ;b1 = Use RPM instead of MPH for TCC lookups
				 ;b0 = 
;				 
LD007 	 FCB     $04		;opt byte = 0000 0100
				 ;b7 =Shift lite enabled (0=TCC)
				 ;b6 =VATS enable
				 ;b5 =High gear switch polarity
				 ;b4 =
				 ;b3 =
				 ;b2 = state for PSPS closed
				 ;b1 =
				 ;b0 = use coolant for cool SA comp.
;		
LD008 	 FCB       0		;CCP flag
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD009 	 FCB       6		;Base SA, SA = 2.1 deg
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
LD00A 	 FCB     192		;Max rpm for slope SA, RPM = 4800
LD00B	 FCB       1		;slope, degrees SA per rpm, SA = .1 deg/rpm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD00C    FCB     240		;Map filter coeff.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD00D 	 FCB      57		;Main SA bias, bias = 20 deg
LD00E 	 FCB      57		;Cool comp. SA, bias = 20 deg
LD00F	 FCB       8		;Cyl. count
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~			
LD010 	 FDB    2458		;Startup DRP, threshold for engine on, 400 rpm		
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD012 	 FCB       6		;Engine run time out, DRPs 
LD013 	 FCB      40		;Timer thresh, 4 secs.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD014    FDB     114		;Max SA, SA = 40.1 deg, ... 
				;...max allowable commanded timing.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD016	 FDB   65525		;Min SA, signed double byte, -3.5 deg
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD018	 FCB       6		;Filter coeff for startup SA?
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
LD019	 FCB      12		;SA for egr active, 4.2 deg
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD01A	 FCB     240		;Filter coeff. for stored rpm / 12.5
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD01B	 FCB     200		;Max scaled RPM for pseudo-baro, 2500 rpm
LD01C	 FCB     128		;Max tps% for pseudo-baro, 50% tps
LD01D	 FCB      10		;Max delta-tps% for pseudo baro 3.9% tps
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD01E	 FCB     192		;Baro filter coef.
;
LD01F	 FCB      23		;ALDL SA?
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Hyst. pairs used in trans tps/RPM SA tables
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD020	 FCB       3		;delta %tps opening, 1.2%
LD021	 FCB       3		;delta %tps closing, 1.2%
LD022	 FCB     128		;50% tps%, closing
LD023	 FCB      26		;10% tps%, opening
LD024	 FCB       9		;delta rpm/25 val, opening tps%
LD025	 FCB       7		;delta rpm/25 val, closing tps%
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD026	 FCB      13		;delta rpm/25 
LD027	 FCB       3		;delta rpm/25
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD028	 FCB     254		;vAC, hw mode SA + fuel threshold
LD029	 FCB     255		;mph, hw mode SA threshold
LD02A	 FDB    4800  		;delay timer for hwm, val/80= 60 secs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD02C	 FCB       2		;choke SA decay delay mult.
LD02D	 FCB     241		;choke SA decay mult		
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD02E	 FCB      57		;TCC locked SA spark bias, 20 deg
;
;-Quals for knock retard
;
LD02F 	 FCB      10		;10 MPH, threshold for knock retard
LD030 	 FCB      80		;rpm/12.5, 1000 RPM, threshold for knock retard
LD031 	 FCB     126		;Cool temp, thresh for knock retard
LD032    FCB     255		;
LD033  	 FCB       0		;
LD034    FCB     255		;
LD035    FCB       2		;Delta rpm/drive ratio
LD036    FCB       0		;
LD037    FCB       2		;Counts, threshold for knock to be set
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Main SA table, Val = SA + Bias * (256/90)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD038    FCB       1		;Flag, use map
;
         FCB       0		;row offset	
         FCB      32		;col offset
	 FCB      15		;columns per row
;
;	 MAP: 30   35   40   45   50   55   60   65   70   75   80   85   90   95   100 ; RPM
;        
	 FCB 128, 128, 128, 128, 126, 121, 115, 111, 105,  97,  93,  87,  85,  85,   85 ; 400 
         FCB 128, 128, 128, 128, 126, 122, 119, 115, 108, 102,  98,  92,  85,  85,   85 ; 600
         FCB 128, 128, 128, 128, 127, 124, 122, 120, 116, 112, 107,  99,  90,  85,   85 ; 800
         FCB 128, 130, 131, 131, 130, 128, 127, 125, 123, 120, 117, 114, 107, 102,   95 ;1000
         FCB 129, 133, 134, 134, 134, 133, 132, 131, 130, 127, 124, 120, 117, 114,  114 ;1200                          FCB     114
         FCB 131, 137, 138, 138, 138, 137, 136, 135, 134, 132, 129, 126, 123, 120,  120 ;1400
         FCB 132, 139, 141, 141, 142, 141, 140, 138, 137, 135, 133, 129, 126, 124,  123 ;1600
         FCB 132, 141, 144, 145, 144, 144, 143, 141, 140, 137, 134, 130, 128, 126,  125 ;1800
         FCB 134, 143, 147, 147, 147, 146, 145, 143, 142, 140, 136, 132, 129, 128,  127 ;2000
         FCB 137, 146, 149, 149, 149, 148, 147, 146, 143, 140, 136, 133, 130, 129,  128 ;2200
	 FCB 137, 146, 149, 149, 149, 149, 148, 147, 145, 142, 137, 134, 132, 130,  129 ;2400
         FCB 137, 144, 149, 149, 149, 149, 149, 149, 146, 143, 137, 135, 134, 132,  131 ;2800
         FCB 137, 142, 149, 149, 149, 149, 148, 145, 142, 138, 135, 133, 132, 131,  130 ;3200
         FCB 137, 142, 144, 145, 145, 143, 142, 141, 137, 135, 133, 131, 131, 130,  130 ;3600
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~       
;-Cool comp. SA, Added SA = (val - bias) * (90/256)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD10E    FCB       0		;Flag, use vac
       
         FCB       0		;Col offset
         FCB      64		;row offset
         FCB       5		;Num of rows
;
;	 Vac: 40   30   20   10    0 ;Cool temp/IAT
;
         FCB  57,  57,  57,  57,  57 ;Cold
         FCB  57,  57,  57,  57,  57 ;5
         FCB  57,  57,  57,  57,  57 ;25
         FCB  57,  57,  57,  57,  57 ;38
         FCB  57,  57,  57,  57,  57 ;50
         FCB  57,  57,  57,  57,  57 ;64
         FCB  57,  57,  57,  57,  57 ;80
         FCB  57,  57,  57,  57,  57 ;110
         FCB  57,  57,  57,  57,  57 ;Hot
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-HW mode SA SA = val * (90/256)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;              Spark ;Vac	 
;
LD13F    FCB       7 ;50
         FCB       7 ;40
         FCB       0 ;30
         FCB       0 ;20
         FCB       0 ;10
         FCB       0 ;0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TCC locked SA, SA = (val - bias) * (90/256) 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD145    FCB       0 		;Flag, use vac

         FCB      32		;Row offset, rpm
         FCB      64		;Col offset, vac
	 FCB       5
;
;	 Vac  40   30   20   10    0 ; RPM
;
         FCB  57,  57,  57,  57,  51 ; 800
         FCB  46,  57,  57,  57,  51 ;1200
         FCB  46,  57,  57,  57,  51 ;1600
         FCB  46,  57,  57,  54,  51 ;2000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-PE SA table-SA = val * .351
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
;		  SA ;kPa  	
;
LD15D    FCB       0 ; 75
         FCB       0 ; 85
         FCB       0 ; 95
         FCB       0 ;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke SA vs cool temp.
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LD161   FCB       4		;5 line table
;
;	  SA = val x .351	;Deg C
;
        FCB      14		;-40
        FCB       0		; 24
        FCB      14		; 49
        FCB      14		; 80
        FCB      14		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke SA delay timer table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD167   FCB       4		;5 lines
;
;				;Deg C
;
        FCB      10		;-40
        FCB       0		; 24
        FCB      10		; 49
        FCB      20		; 80
        FCB      20		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-PE max knock retard table, rpm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD16D   FCB      80		;UL, 4000 rpm
;
;Deg = Val. x .352     		; RPM
;
        FCB      63		; 800 
        FCB      63		;1600 
        FCB      63		;2400
        FCB      52		;3200
        FCB      85		;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Non-PE max knock retard table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD173   FCB     128		;Upper limit, offset Vac
;
;Deg = Val x .352
;				; Vac
;
        FCB      85		; 40
        FCB      68		; 30
        FCB      68		; 20
        FCB      68		; 10
        FCB      80		;  0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Knock SA retard mult vs IAT
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		%Retard =	;Deg C
;		Val/128	
;
LD179   FCB     128		; -4
        FCB     128		;  0
        FCB     128		; 14
        FCB     128		; 30 
        FCB     128		; 48
        FCB     141		; 63
        FCB     154		; 85
        FCB     154		; 96
        FCB     154		;110
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Table used in spark latency correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD182   FCB     192		;UL, 4800 RPM
;
;				;rpm
;
        FCB       0		;   0
        FCB       0		; 400
        FCB       0		; 800
        FCB       3		;1200
        FCB       6		;1600
        FCB       9		;2000
        FCB       9		;2400
        FCB      12		;2800
        FCB      11		;3200
        FCB       9		;3600
        FCB      10		;4000
        FCB      10		;4400
        FCB       9		;4800
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-PE knock attack rates, by rpm
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD190   FCB      80		;UL, 4000 rpm	
;
;-Val. x .000625 = [deg/(knock count*msec)]
;
;                               ; RPM
; 
        FCB      16		; 800
        FCB      22		;1600
        FCB      29		;2400
        FCB      36		;3200
        FCB      40		;4000
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Non-PE knock attack rates, by Vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD196   FCB     128		;UL, 0 kpa
;
;-Val. x .000625 = [deg/(knock count*msec)]
;
;		                ;Vac, kPa
;
        FCB      13		;40
        FCB      13		;30
        FCB      13		;20
        FCB      16		;10
        FCB      18		; 0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Retard recovery rate vs. RPM, in PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Val x (5/256) x 100 = %Rec/sec 
;
LD19C   FCB      64		;RPM, 3200, UL for lookup 
;
        FCB      64		; 800
        FCB      64		;1600
        FCB      64		;2400
        FCB      64		;3200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Retard recovery rate vs. Vac, not in PE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Val x (5/256) x 100 = %Rec/sec 
;
LD1A1   FCB     120		;Vac, 5 kPa, UL for lookup
;
        FCB      64		;35
        FCB      64		;25
        FCB      64		;15
        FCB      64		; 5 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Table of delta RPM SA factors
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		Factor		;Delta RPM
;				;
LD1A6   FCB     240		;  0
        FCB     243		; 25
        FCB     246		; 50
        FCB     248		; 75
        FCB     250		;100
        FCB     250		;125
        FCB     250		;150
        FCB     250		;175
        FCB       0		;200
        FCB     247		;225
        FCB       6		;250
        FCB       8		;275
        FCB      10		;300
        FCB      13		;325
        FCB      16		;350
        FCB      18		;375
        FCB      20		;400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Table for delta RPM SA multiplier for above table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD1B7   FCB     128		;UL, 3200 rpm
;
        FCB      96		; 400
        FCB      96		; 800
        FCB      96		;1600
        FCB      64		;2000
        FCB      48		;2400
        FCB      32		;2800
        FCB      24		;3200
        FCB      18		;3600
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Pseudo baro factor vs. %TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;                     (factor x ([RPM]/25 - 16)
;Added baro counts = --------------------------- 
;				256
;
;
;Added kPa / 1k rpm = factor x .058
;
;       
LD1C0   FCB       4		;5 line table
;
;				;%TPS
;
        FCB     100		;  0
        FCB     100		; 25
        FCB      95		; 50
        FCB      30		; 75
        FCB       5		;100
;
;~~~~~~~~~~~~~~~~~~~
;-EGR thresholds
;~~~~~~~~~~~~~~~~~~~
;
LD1C6   FCB     152		;40 deg C EGR off temp
LD1C7   FCB     139		;45 deg C, EGR on temp	
LD1C8   FCB       0		;0 mph EGR off speed
LD1C9   FCB     255		;255 MPH, EGR on speed
LD1CA   FCB      52		;20.3% TPS thresh for EGR off
LD1CB   FCB     253		;99.2% TPS thresh for EGR on
LD1CC   FCB     128		;50% TPS, max TPS for EGR
LD1CD   FCB     210		;14.3 kPa, Vac thresh for EGR on
LD1CE   FCB     220		;11.2 kPa, Vac thresh for EGR off
LD1CF   FCB      24		;Filter coeff for egr inactive
LD1D0   FCB      12		;Filter coeff for EGR active
LD1D1   FDB   $04FF		;Used in EGR output
;
;~~~~~~~~~~~~~
;-TPS params.
;~~~~~~~~~~~~~
;
LD1D3    FCB     117		;Scaler for TPS conv.
LD1D4    FCB      51		;Default min tps pos., ~1 volt 
LD1D5    FCB       1		;TPS lag filter coeff.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD1D6   FCB     240		;02 minor loop filter coeff
LD1D7   FCB     138		;599 mV, 02 val, used for init.
;
;~~~~~~~~~~~
;-AE params
;~~~~~~~~~~~
;
LD1D8   FCB      32		;7.1 kPa, delta MAP counts, thresh of AE enrich
LD1D9   FCB      48		;19% TPS, used in MAP AE
LD1DA   FCB     128		;50% tps, used in MAP AE
LD1DB   FCB       4		;Delta TPS val., thresh for TPS AE	
LD1DC   FCB       6		;IAC opening addl. PW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD1DD   FCB       0		;Value loaded for transient fuel cal. interval timer
LD1DE   FCB      16		;slow tps filter coeff.
LD1DF   FCB      64		;
LD1E0   FCB      20		;SD MAP filt. coeff, used if cool <=80
LD1E1   FCB      36		;slow SD MAP filt coeff, used if cool temp >80 deg C
LD1E2   FCB     199		;20 deg C, thresh for HW mode & cold start closed loop delay timer 
;
;~~~~~~~~~~~~~~~~~~~
;-Closed loop quals
;~~~~~~~~~~~~~~~~~~~
;
LD1E3   FCB      15		;30 secs, delay after warm start for closed loop
LD1E4   FCB     200		;400 secs, delay after cold start for closed loop
LD1E5   FCB     152		;40 deg C
LD1E6   FCB      50		;Counter val, thresh to exit closed loop
LD1E7   FCB     189		;25 deg C, min cool temp for learn enable
LD1E8   FCB       0		;140+ deg C, max cool temp for learn enable
LD1E9   FCB      16		;SD MAP, 22 kPa, min SD MAP for learn enable
LD1EA   FCB     255		;SD MAP, 99.6 kPa, max SD MAP for learn enable
LD1EB   FCB     240		;rpm/25, 6000 RPM, max rpm for learn enable
LD1EC   FCB     147		;14.7 AFR
;
;~~~~~~~~~~~~~~~~
;-HW mode quals.
;~~~~~~~~~~~~~~~~
;
LD1ED   FCB      52		;MPH thresh for HW fuel
LD1EE   FCB     166		;CCP val. to enter HW mode
LD1EF   FCB      60		;Timer thresh to enter HW mode
LD1F0   FCB     255		;Timer thresh for mand. exit of HW mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Used in force open loop
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD1F1   FCB       5		;
LD1F2   FCB       6		;
LD1F3   FCB      26		;
LD1F4   FCB      28		;
LD1F5   FCB       4		;
LD1F6   FCB       2		;
LD1F7   FCB       0		;
LD1F8   FCB      40		;timer val
LD1F9   FCB       5		;
LD1FA   FCB     140		;
LD1FB   FCB     132		;

LD1FC   FCB      12		;Block learn timer val
;
;~~~~~~~~~~~~~~~~~~~
;-BLM RPM boundries
;~~~~~~~~~~~~~~~~~~~
;
;		RPM =		     
;		val x 25
;
LD1FD   FCB      32		;Lower boundry	
LD1FE   FCB      64		;mid boundry
LD1FF   FCB      96		;upper boundry
;
;~~~~~~~~~~~~~~~~~~
;-BLM MAP boudries
;~~~~~~~~~~~~~~~~~~
;
;	MAP counts
;
LD200   FCB      40		;Lower boundry
LD201   FCB      94		;Mid boundry
LD202   FCB     135		;Upper boundry
;
;-BLM hyst. 
;
LD203   FCB       2		;BLM RPM hyst., 50 rpm
LD204   FCB       6		;BLM MAP hyst., 1.8 kPa
;
;~~~~~~~~~~~~
;-Inj const.
;~~~~~~~~~~~~
;
LD205   FCB     134		;Inj const.
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Addl. params for BLMs
;~~~~~~~~~~~~~~~~~~~~~~~
;
LD206   FCB       3		;Delta int thresh to adjust BLMs
LD207   FCB       1		;BLM movement step
LD208   FCB     185		;Maximum allow. BLM
LD209   FCB      95		;Minimum allow. BLM
LD20A   FCB     128		;Upper limit on init, BLM val.
LD20B   FCB     128		;Lower limit on init, BLM val.	
;
;-O2 thresholds to remain in closed loop
;	
LD20C   FCB     157		;02 val., 682 mV
LD20D   FCB      69		;02 val., 299 mV
;
;-O2 thresholds to enter closed loop
;
LD20E   FCB     157		;O2 val., 682 mV
LD20F   FCB      69		;O2 val., 299 mV
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Integrater thresh. and limits
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD210   FCB      24		;27.5 kPa, tresh for closed loop
LD211   FCB      40		;1000 RPM, thresh for closed loop if SD map is < 27.5 kPa
LD212   FCB      40		;min INT value
LD213   FCB     158		;max INT value
;
LD214   FCB     200		;20.0:1 AFR, max allow AFR
;
;~~~~~~~~~~~~~
;-Clear flood 
;~~~~~~~~~~~~~
;
LD215   FCB     230		;90.1%, clr flood TPS thresh.
LD216   FCB     200		;20.0:1 Clr flood AFR
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD217   FCB     231		;0 deg C, Temp thresh for cold crank AFR correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD218   FCB       8		;TPS hyst., used in baro correction of TPS
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Cold PE AFR enrichment 
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LD219   FCB     231		;0 deg C, temp thresh for cold PE enrich
LD21A   FCB      10		;1.0:1 AFR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Some stuff for cold AFR choke adj.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD21B   FCB       9		;2 sec delay timer val to decay choke
LD21C   FCB      25		;5 sec delay timer val to decay choke
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD21D   FCB     152		;40 deg C, threshold to set hot restart in effect if low batt volts
LD21E   FCB      72		;Hot restart thresh., inv A/D counts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD21F   FCB       2		;2 secs, IAC kickdown delay
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD220   FCB      50		;5.0 AFR, added in on hot restart
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD221   FCB     255		;Fuel cutoff speed
LD222   FCB     255		;Fuel resume speed
;
;~~~~~~~~~~~~~~~
;-Async fueling
;~~~~~~~~~~~~~~~
;
LD223   FDB      72		;1098 usecs, min sync. BPW to exit async fueling
LD225   FDB      59		;900 usecs, min sync. BPW to enter async fueling
LD227   FDB      26		;396, inj bias
LD229   FDB     786		;11.994 msecs, largest async PW
LD22B   FDB      45		;237 usecs, smallest async PW
;
;~~~~~~~~~~~~~~~~~~~~~
;-Decel enlean params
;~~~~~~~~~~~~~~~~~~~~~
;
LD22D   FCB       3		;1.2%, Diff %TPS limit for decel enlean
LD22E   FCB       8		;22.5 kPa, Delta MAP limit for decel enlean
LD22F   FCB     224		;MAP Mult. for decel enlean
; 
;~~~~~~~~~~~~
;-DFCO quals
;~~~~~~~~~~~~
;
LD230   FCB      47		;1175 RPM, not in DFCO, lower lim for DFCO
LD231   FCB      38		;950 RPM, in DFCO, lower lim for DFCO
LD232   FCB      40		;40 MPH, not in DFCO, lower lim for DFCO
LD233   FCB      35		;35 MPH, in DFCO, lower lim for DFCO
LD234   FCB      34		;23 kPa, Lower limit for DFCO
LD235   FCB      53		;30 kPa, upper limit for DFCO
LD236   FCB       4		;50 RPM, delta RPM limit for DFCO
LD237   FCB      10		;23 kPa, rise in delta SD map limit for DFCO
LD238   FDB     262		;PW added upon exiting DFCO
LD23A   FCB      80		;DFCO timer, 1 sec
LD23B   FCB     160		;Post DFCO timer, 2 secs
LD23C   FCB       8		;3.1% tps limit for DFCO
LD23D   FCB       1		;# by which DFCO mult. is deincremented by
LD23E   FCB     231		;0 dec C, min temp for DFCO
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD23F   FCB      36		;156 mV, window for R/L
LD240   FCB       0		;0, thresh for O2 err.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD241   FCB     128		;used in calc. of gms/sec
LD242   FCB      15		;used in calc of grms/sec airflow
LD243   FCB     164		;max rpm for airflow term calc, 2050 rpm
LD244   FCB     100		;Max value, used in calc of gms/sec airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD245   FCB       3		;3 mph, min speed for vehicle moving, idle logic
LD246   FCB       8		;02 bias term for idling		
LD247   FCB       1		;Airflow factor for idling
LD248   FCB      12		;Idling adj. bias for INT delay timer
LD249   FCB     232		;
LD24A   FCB     224		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Startup choke adj. to AFR params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD24B   FCB     239		;cool counts, -5 deg C, thresh to set cold eng. temp status bit
LD24C   FCB      20		;2:1 AFR, startup choke, sub. from AFR on cold start
LD24D   FCB       0		;Startup choke decay delay timer
LD24E   FCB      13		;1.3:1 AFR/sec, rate at which startup choke is decayed out
;
;~~~~~~~~~~~~~~~~~~
;-VATS freq window
;~~~~~~~~~~~~~~~~~~
;
LD24F   FDB     65535		;Upper threshold for vats freq
LD251   FDB     65535		;Lower threshold for vats freq
;
;~~~~~~~~~~~~~~~~~
;Inj. bias vs BPW
;~~~~~~~~~~~~~~~~~
;
;Used when sync BPW < 1950 usecs
;
;	       Bias=	      
;	       val x 15.23 	;usecs
;
LD253   FCB      26		; 609		
        FCB	 26           	; 731 
        FCB      26		; 852
        FCB      20		; 975
        FCB      28		;1096 
        FCB      31		;1218	
        FCB      28		;1340
        FCB      28		;1462
        FCB      28		;1583
        FCB      28		;1705
        FCB      28		;1827
        FCB      26		;1950
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-AE vs. delta MAP AE
;~~~~~~~~~~~~~~~~~~~~~~~~
;                        
LD25F   FCB       4		;5 line table
;
;	    usec =  
;	    val x 60.98    	;kpa			
;
        FCB       3		; 0
        FCB       7		;20 
        FCB      16		;40 
        FCB      18		;60
        FCB      32		;80
;
;~~~~~~~~~~~~~~~~~~
;-AE vs delta %TPS
;~~~~~~~~~~~~~~~~~~
;
LD265   FCB       4		;5 line table
;
;           usec =  		
;	    val x 60.98		;delta %TPS
;				
        FCB      11		;   0
        FCB      13		; 3.1
        FCB      16		; 6.3
        FCB      26		; 9.4
        FCB      36		;12.5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-EGR inj const. vs. manifold press
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD26B   FCB     176		;UL for lookup
;
;	      Inj const		;kPa, man. press (?)
;
        FCB     134		; 0
        FCB     134		; 3
        FCB     134		; 5
        FCB     134		; 8
        FCB     134		;10 
        FCB     134		;13
        FCB     134		;15  
        FCB     134		;18
        FCB     134		;20
        FCB     134		;30
        FCB     134		;40
        FCB     134		;50
;
;~~~~~~~~~~~~~~~~
;-Main %VE table
;~~~~~~~~~~~~~~~~
;
LD278   FCB       0		;row offset
        FCB      16		;Col offset
        FCB       8		;# of cols

;    RPM/1k  .4   .8  1.2  1.6  2.0  2.4  2.8  3.2 ;kPa
;              
        FCB  50,  49,  54,  57,  60,  62,  63,  65 ; 30
        FCB  51,  52,  55,  63,  69,  76,  86,  90 ; 40
        FCB  53,  54,  61,  65,  79,  88,  99, 103 ; 50
        FCB  55,  59,  75,  82,  86,  94, 101, 108 ; 60
        FCB  65,  71,  88,  91,  93,  99, 110, 116 ; 70
        FCB  95, 107, 112, 108, 103, 103, 111, 120 ; 80
        FCB  98, 106, 121, 121, 119, 119, 122, 127 ; 90
        FCB  99, 107, 121, 125, 124, 125, 125, 129 ;100
        FCB  99, 106, 120, 127, 126, 124, 126, 130 ;110
;
;~~~~~~~~~~~~~~~~~~~~
;-%VE adder table
;~~~~~~~~~~~~~~~~~~~~
;
;		%VE		;RPM/25
;
LD2C3   FCB      51		;   0
        FCB      51		; 400
        FCB      74 		; 800
        FCB     102		;1200
        FCB     106		;1600
        FCB     110		;2000
        FCB     112		;2400
        FCB     111		;2800
        FCB     106		;3200
        FCB     102		;3600
        FCB      96		;4000
        FCB     108		;4400
        FCB      99		;4800
        FCB      72		;5200
        FCB      64		;5600
        FCB      57		;6000
        FCB      53		;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-BPW inv. cool. correction term.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;       Factor			;Deg C
;
LD2D4   FCB     107		;200
        FCB     122		;135
        FCB     132		;108 
        FCB     137		; 93
        FCB     142		; 80
        FCB     145		; 70
        FCB     149		; 62
        FCB     152		; 54
        FCB     155		; 50
        FCB     158		; 43
        FCB     161		; 32
        FCB     165		; 30
        FCB     169		; 24
        FCB     173		; 15
        FCB     179		;  5
        FCB     189		;-20
        FCB     211		;-40 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-BPW corr. vs fuel pump volts
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	       %Corr. = 
;	       Val/128		;Volts
;			
LD2E5   FCB     128		; 0.0
        FCB     128		; 1.6 
	FCB     255		; 3.2
        FCB     255		; 4.8
        FCB     255		; 6.4
        FCB     255		; 8.0
        FCB     160		; 9.6
        FCB     136		;11.2 
        FCB     130		;12.8
        FCB     126		;14.4
        FCB     126		;16.0
        FCB     122		;17.6
        FCB     120		;19.2
        FCB     118		;20.8
        FCB     116		;22.4
        FCB     114		;24.0
        FCB     112		;25.5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Decel enlean factor vs temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD2F6   FCB       4		;4 line table
;
;	       factor		;Deg C
;		
        FCB      96		;-40
        FCB      80		; 25
        FCB      64		; 38
        FCB      64		; 80
        FCB      64		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Accel enrich vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;               Factor		;Deg C
;	
LD2FC   FCB     208		;-40  
        FCB     192		;-10 
        FCB     181  		;  5
        FCB     160  		; 15 
        FCB     143  		; 25
        FCB     131  		; 31
        FCB     120   		; 37
        FCB     109 		; 43
        FCB      96  		; 50
        FCB      86  		; 55
        FCB      77  		; 64
        FCB      64  		; 70
        FCB      56  		; 80
        FCB      44  		; 92 
        FCB      40  		;110
        FCB      40  		;140
        FCB      36  		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Open loop AFR correction vs. vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD30D   FCB       8  		;9 line table
;
;	AFR = val/10		;Vac
;
        FCB      20		; 80  
        FCB      20		; 70  
        FCB      20		; 60  
        FCB      20		; 50  
        FCB      20		; 40  
        FCB      20		; 30 
        FCB      12		; 20
        FCB       7		; 10
        FCB       5		;  0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Choke AFR coor. vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;				;Deg C
;
LD317   FCB      35		;-40
        FCB      30		;-10
        FCB      30		;  5
        FCB      25		; 15
        FCB      23		; 24
        FCB      19		; 31
        FCB      15		; 38
        FCB      15		; 43
        FCB      15		; 48
        FCB      15		; 55
        FCB      15		; 64
        FCB      15		; 70
        FCB      15		; 80
        FCB      10		; 91
        FCB      10		;110
        FCB      10		;135
        FCB      10		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Open loop AFR mult. vs cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;             Mult.= 
;	      val/256 		;Deg C
;
LD328   FCB     248		;-40
        FCB     246  		;-10
        FCB     243		;  5
        FCB     241		; 15
        FCB     235		; 24
        FCB     230		; 31
        FCB     230		; 38
        FCB     230		; 43
        FCB     230		; 48
        FCB     230		; 55
        FCB     230		; 64
        FCB     230		; 70
        FCB     224		; 80
        FCB     192		; 91
        FCB     192		;110 
        FCB     192		;135
        FCB     192		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;Crank AFR vs. cool temp
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;	      AFR x 10		;Deg C
;
LD339   FCB      20		;-40
        FCB      35		;-10
        FCB      40		;  5
        FCB      60		; 15
        FCB      78		; 24
        FCB      78		; 31
        FCB      78		; 38
        FCB      78		; 43
        FCB      78		; 48
        FCB      78		; 55
        FCB      78		; 64
        FCB      78		; 70
        FCB      78		; 80
        FCB      78		; 91
        FCB      78		;110
        FCB      78		;135
        FCB      64		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Cold crank AFR corr factor vs. vac
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		Factor =
;		val. / 16	;Vac	
;
LD34A    FCB      34		; 50
         FCB      34		; 45
         FCB      34		; 40
         FCB      32		; 35
         FCB      30		; 30
         FCB      28		; 25
         FCB      26		; 20
         FCB      24		; 15
         FCB      22		; 10
         FCB      21		;  5
         FCB      15		;  0
;
;~~~~~~~~~~~~~~~~~~~~~
;-Added open loop AFR
;~~~~~~~~~~~~~~~~~~~~~
;
;	      AFR x 10		;Deg C
;
LD355   FCB      92		;-40
        FCB      97		;-10
        FCB     105		;  5
        FCB     110		; 15
        FCB     115		; 24
        FCB     120		; 31
        FCB     120		; 38
        FCB     127		; 43
        FCB     127		; 48
        FCB     127		; 55
        FCB     127		; 64
        FCB     127		; 70
        FCB     127		; 80
        FCB     127		; 91
        FCB     127		;110
        FCB     127		;135
        FCB     127		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;BPW mult. vs RPM for sync -> async BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;Sync = alternating fire 
;Async = fire together @ 80 Hz
;
;Factor = val. / 64, makes calcs relative to 2400 rpm = 80 Hz firings
;
LD366   FCB       8		;9 lines
;
;      	       Factor		;rpm
;
        FCB       0		;   0
        FCB      21		; 800
        FCB      43		;1600
        FCB      64		;2400
        FCB      85		;3200
        FCB     107		;4000
        FCB     128		;4800
        FCB     149		;5600
        FCB     171		;6400
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Inj const. corr factor vs. IAT temp
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;               factor=
;		val. /128 	;Deg C	
;
LD370   FCB     128		; 
        FCB     128		; 
        FCB     128		; 
        FCB     125		;
        FCB     128		; 
        FCB     128		; 48
        FCB     128		; 63
        FCB     128		; 80
        FCB     128		;110 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Inj corr. factor vs. Baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		Factor=
;		val. /128	;kPa
;
LD379   FCB     132		; 75 
        FCB     130		; 85
        FCB     128		; 95
        FCB     128		;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-%TPS vs. baro corr. table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;				;kPa
;
LD37D   FCB     213		; 75
        FCB     213		; 85
        FCB     255		; 95
        FCB     255		;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-%TPS for PE vs rpm table
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		%TPS = 
;	        Val x .392	;Scaled RPMs
;				
LD381   FCB      77 		; 400
        FCB      90 		; 800
        FCB      90 		;1600
        FCB      90 		;2400  
        FCB      90 		;4800
;
;~~~~~~~~~~~~~~~~
;-PE AFR vs. RPM
;~~~~~~~~~~~~~~~~
;
;	        AFR x 10	;Scaled RPMs
;
LD386   FCB     125		; 400
        FCB     124		; 800
        FCB     124		;1600
        FCB     125		;2400
        FCB     128		;4800
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-PE AFR corr. factor vs. TPS
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;               Factor =
;		val. /128	;%TPS
;
LD38B   FCB     133		; 60
        FCB     134		; 70
        FCB     142		; 80
        FCB     139		; 90
        FCB     128		;100
;
;~~~~~~~~~~~~~~~~~~
;-HW mode AFR table
;~~~~~~~~~~~~~~~~~~
;
;	      AFR x 10		;Vac 	
;
LD390   FCB     147		;80
        FCB     147		;70
        FCB     147		;60
        FCB     147		;50
        FCB     147		;40
        FCB     147		;30
        FCB     147		;20
        FCB     144		;10	
        FCB     144		; 0
;
;~~~~~~~~~~~~~~~~~~~~
;-Lookups vs airflow
;~~~~~~~~~~~~~~~~~~~~
;
;				;Airflow, gms/sec
;-Lean 02 threshold
;
LD399   FCB      22		; 0
        FCB      18		;16
        FCB      12		;32
        FCB       8		;48
        FCB       6		;64
;
;-Rich 02 threshold
;
        FCB     108		; 0
        FCB     110		;16
        FCB     114		;32
        FCB     114		;48
        FCB     110		;64
;
;-Mean R/L O2 thresh, thresh. = val x .0043
;
        FCB     118		; 0
        FCB     114		;16
        FCB     116		;32
        FCB     114		;48
        FCB     110		;64
;
;-Int delay
;
        FCB     098		; 0
        FCB     106		;16
        FCB     112		;32
        FCB     114		;48
        FCB     110		;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-02 filter coeff vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	         FC		;airflow, gms/sec
;
LD3AD   FCB       5		;0		
        FCB       8		;16
        FCB      11		;32
        FCB      18		;48
        FCB      22		;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Proportional gain term for O2 err
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;             Gain term		;err val x2
;
LD3B2   FCB      24		;  0
        FCB      24		; 16
        FCB      24		; 32
        FCB      12		; 48
        FCB      12		; 64
        FCB      24		; 80
        FCB      40		; 96
        FCB      48		;112
        FCB      56		;128
        FCB      64		;144
        FCB      80		;160
        FCB      96		;176
        FCB      96		;192
;
;~~~~~~~~~~~~~~~~~~
;-O2 err bias term
;~~~~~~~~~~~~~~~~~~
;
;		  Bias		;O2 err x2
;
LD3BF   FCB       2		;  0
        FCB       3		; 16
        FCB       4		; 32	
        FCB       8		; 48	
        FCB      16		; 64
        FCB      32		; 80 
        FCB      64		; 96
        FCB      96		;112
        FCB     120		;128
        FCB     120		;144
        FCB     120		;160
        FCB     120		;176
        FCB     120		;192
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Flow factor vs. airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;				;Airflow, gms/sec
;
LD3CC   FCB      10		; 0		
        FCB       6		;16
        FCB       4		;32
        FCB       2		;48
        FCB       1		;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Airflow factor for prop gain, used in fueling
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;				;Airflow, gms/sec
;	
LD3D1   FCB      24		; 0 
        FCB      40		;16
        FCB      64		;32
        FCB      80		;48
        FCB      96		;64
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-INT delay timer adj. factor vs 02 err
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;		Factor=
;		val/256	  	;O2 err x2   
;
LD3D6   FCB     255		;  0
        FCB     255		; 16
        FCB     255		; 32
        FCB     224		; 48
        FCB     192		; 64
        FCB     160		; 80
        FCB     128		; 96
        FCB      96		;112
        FCB      80		;128
        FCB     128		;144
        FCB     160		;160
        FCB     192		;176
        FCB     192		;192
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;List of ALDL addr. to be xmitted
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD3E3   FDB 	$D002		;Prom ID, MSB
        FDB     $D003		;Prom ID, LSB
;
        FDB     $00FD		;Current IAC pos.
;
        FDB     $0022		;Coolant counts
;
        FDB     $0030		;MPH
;
        FDB     $0029		;A/D MAP
;
        FDB     $001B		;RPM/25
;
        FDB     $0042		;TPS counts
;
        FDB     $00A5		;Integrator
;
        FDB     $0039		;O2 counts
;
        FDB     $00E1		;Malf flag 1
				 ;b7 = code 12, no DRP
				 ;b6 = code 13, O2
				 ;b5 = code 14, CTS high
				 ;b4 = code 13, CTS low
				 ;b3 = code 21, TPS high
				 ;b2 = code 22, TPS low
				 ;b1 = code 23, IAT low
				 ;b0 = code 24, VSS
;
        FDB     $00E2		;Malf flag 2
				 ;b7 = code 25, IAT high
				 ;b6 = code 31, 
				 ;b5 = code 32, EGR
				 ;b4 = code 33, MAP high
				 ;b3 = code 34, MAP low
				 ;b2 = 
				 ;b1 = 
				 ;b0 = code 42, est monitor err.
;
        FDB     $00E3		;Malf flag 3
				 ;b7 = code 43, esc failure
				 ;b6 = code 44, O2 lean
				 ;b5 = code 45, O2 rich
				 ;b4 = code 51, prom error
				 ;b3 = code 52, 
				 ;b2 = code 53, VATS
				 ;b1 = code 54, FP relay failure 
				 ;b0 = calibration pack missing
;
        FDB     $000E		;a/F mode flag
				 ;b7 = closed loop
				 ;b6 = rich/lean ind.
				 ;b5 = closed loop flag
				 ;b4 = async fuel in effect
				 ;b3 = 4->3 downshift
				 ;b2 = low battery
				 ;b1 = blm store enable
				 ;b0 = 
;
        FDB     $0040		;Batt volts x 10
;
        FDB     $0801		;MCU2 I/O
;	
        FDB     $0069		;MSB of PA3, knock counts
;
        FDB     $00A4		;BLM
;
        FDB     $0023		;IAT
;
;~~~~~~~~~~~~~~~~~~
;-Diagnostic masks
;~~~~~~~~~~~~~~~~~~
;
;bit==1, recognize error
;
LD409   FCB     255		;1111 1111
 				 ;b7 = Code 12, no ref. pulses
				 ;b6 = code 13, 02
				 ;b5 = code 14, CTS high
				 ;b4 = Code 15, CTS low
				 ;b3 = Code 21, TPS hi
				 ;b2 = Code 22, TPS low .
				 ;b1 = Code 23, IAT low
				 ;b0 = Code 24, VSS
;
LD40A   FCB     153		;1001 1001
				 ;b7 = Code 25, IAT Hi
				 ;b6 = Code 31
				 ;b5 = Code 32, EGR malf.
				 ;b4 = Code 33, MAP hi
				 ;b3 = Code 34, MAP low
				 ;b2 = Code 35, IAC err. (NA)
				 ;b1 = Code 41, No DRPs, (NA)
				 ;b0 = Code 42, EST err.
;

LD40B   FCB     243		;1111 0011
				 ;b7 = Code 43, ESC failure
				 ;b6 = Code 44, O2 lean
				 ;b5 = Code 45, O2 rich
				 ;b4 = Code 51, Prom error
				 ;b3 = Code 52, CAL-PACK missing (NA)
				 ;b2 = Code 53, VATS
				 ;b1 = Code 54, Fuel pump relay failure
				 ;b0 = Code 55, ADC error
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD40C   FCB      50		;50 starts, number of clean starts to clear stored codes
;
;~~~~~~~~~~~~~~~~~~~~~
;-Field service stuff
;~~~~~~~~~~~~~~~~~~~~~
;
LD40D   FCB      10		;
LD40E   FCB      20		;
LD40F   FCB     100		;
LD410   FCB     120		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 13, O2 failure params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD411   FCB      60		;120 secs		
LD412   FCB      81		;350 mV, lower limit for err to be set
LD413   FCB     127		;550 mV, upper limit for err. to be set
LD414   FCB      13		;%TPS thresh to advance timer
LD415   FCB      30		;timer thresh to set err.
LD416   FCB      81		;70 deg C, temp thresh to set err.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 14, CTS high err params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD417   FCB       1		;Engine run time, secs/2. Used in CTS init. + diag.
LD418   FCB      16		;Min coolant counts
LD419   FCB      15		;Engine run time, secs/2. Used in CTS init. + diag.
LD41A   FCB     252		;Max allow A/D coolant counts.
LD41B   FCB     100		;Default cool. counts, used upon failure
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 21, TPS high err params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD41C   FCB     128		;2.5 volts
LD41D   FCB      80		;Thresh for timer to set err.
LD41E   FCB     112		;57.1 kPa, thresh to adv. timer and set err
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 22, TPS low err params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD41F   FCB      10		;Min TPS counts, .19 volts
LD420   FCB      80		;Default min TPS, used on err.
LD421   FCB     245		;Min alow. A/D IAT counts
LD422   FCB       1		;min engine run time for test, 1 sec
LD423   FCB      45		;
;
LD424   FCB      20		;20 mph, IAT diag. threshold
LD425   FCB     152		;Default A/D IAT counts 
L;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 24, VSS err params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD426   FCB       5		;5 mph
LD427   FCB      64		;800 rpm, min rpm to set VSS error
LD428   FCB     240		;4400 rpm, max rpm to set VSS error
LD429   FCB      40		;25.2 kPa, max map to set VSS error
LD42A   FCB       3		;3 seconds, timer thresh to set VSS err.
LD42B   FCB      30		;Min allow. A/D IAT counts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 32, egr err params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD42C   FCB      10		;Timer val
LD42D   FCB      80		;Vac, 55 kPa, max vac for egr test 
LD42E   FCB     144		;Vac, 35 kPa, min vac for egr test 
LD42F   FCB      23		;9% tps, min tps for egr test
LD430   FCB      51		;20% tps, max tps for egr test
LD431   FCB      10		;timer val
LD432   FCB       2		;
LD433   FCB       1		;Delta %TPS, .4%, max delta tps for egr test
LD434   FCB      25		;Timer val
LD435   FCB       8		;2.5 kPa, delta pressure for egr active 
LD436   FCB      50		;50 mph, min speed for egr test
LD437   FCB       1		;timer val
LD438   FCB      12		;
LD439   FCB     128		;
LD43A   FCB      32		;
LD43B   FCB      40		;UL for rpm/drive ratio, egr test
LD43C   FCB      19		;LL for rpm/drive ratio, egr test
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 33, MAP sens high params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD43D   FCB      10		;3.92% tps 
LD43E   FCB     156		;68 kPa, min allow baro press for test
LD43F   FCB      50		;timer thresh to set err
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 34, MAP sens low params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD440   FCB      10		;Min allow MAP, A/D counts
LD441   FCB      64		;(64*12.5 + 400) = 1200 rpm, used in map test
LD442   FCB       2		;timer val to set err.
LD443   FCB      54		;% tps from idle, used in map test
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
LD444   FCB     218		;Default baro val.
LD445   FCB     146		;%TPS multiplier, used in creation of default MAP value
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Map bias vs RPM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD446   FCB      64		;Upper table lim
;	
;            A/D counts		; RPM
;
        FCB      91		; 800
        FCB      45		;1200
        FCB      10		;2400
        FCB       0		;3200
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD44B   FCB       6		;75 rpm, used in idle logic. Min rpm diff to adj. idle
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD44C   FCB     145		;
LD44D   FCB       0		;
;
;~~~~~~~~~~~~
;-EST diags.
;~~~~~~~~~~~~
;
LD44E   FCB       4		;50 rpm, min engine speed to check EST under crank
LD44F   FCB       0		;
LD450   FCB       4		;
LD451   FCB       4		;Thresh value, EST err counter
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD452   FDB      50		;50 secs, min engine run time for knock retard
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 43, ESC err params
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD454   FCB     235		;Thresh for runaway knock
LD455   FCB       2		;Counter val for ESC counter
LD456   FCB      64		;80 deg C, min temp to set ESC err.
LD457   FCB      12		;150 dec C, max temo to set ESC err.
LD458   FCB     224		;rpm/25, 5625 rpm, max rpm to set ESC code
LD459   FCB     196		;81.25 kPa
LD45A   FCB      40		;Used in code 43 test, 14.08 deg, SA to force knock
LD45B   FCB      57		;Used in code 43 test, 20 deg, SA to force knock before setting err.
;
LD45C   FCB       2		;Threshold for new knock counts
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 44, O2 lean err params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD45D   FCB      46		;200 mV, min allow O2 volts
LD45E   FCB      50		;50 secs, time before err set
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 45, O2 rich err params
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD45F   FCB     173		;750 mV, max allow O2 volts
LD460   FCB      30		;30 secs, time before err set
LD461   FCB      51		;20% tps, min high tps to set err 
LD462   FCB       5		;2.0% tps, max low tps to set err
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD463   FCB       0		;Timer val. for VATS err timer
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD464   FCB      30		;3/4 of a second, delay for fuel pump volts test
;
;~~~~~~~~~~~~~~~~~~~~~
;-AIR emmisions quals 
;~~~~~~~~~~~~~~~~~~~~~
;
LD465   FCB       2		;400 msec delay to cut AIR if rpm limit exceeded
LD466   FCB       1		;Filter coeff for slow filtered RTS O2
LD467   FCB     161		;698 mV, high limit for AIR
LD468   FCB      65		;282 mV, low limit for AIR
LD469   FCB      50		;50 sec O2 rich timer to cut AIR
LD46A   FCB     164		;2050 rpm, scaled rpm value, max rpm for air to cat (Note: likely mistake)
LD46B   FCB      20		;2 sec delay after hard accel for AIR resume
LD46C   FCB       8		;22.5 kPa, SD MAP limit for AIR
LD46D   FCB      80		;Delta SD MAP, 45 kPa, thresh for hard accel (AIR)
LD46E   FCB     199		;20 deg C, cool temp thresh for AIR
LD46F   FCB      50		;5 secs., init value for forced to open loop timer (AIR)
LD470   FCB       0		;1 sec delay for AIR divert if in PE
LD471   FCB      64		;80 deg C, temp limit for air to cat
LD472   FCB     255		;99.6 kPa, SD MAP thresh to force air to mans./cat
LD473   FCB      20		;20 MPH, tresh to turn on AIR if cool temp is overly hot
LD474   FCB      35		;35 MPH, thresh to turn off AIR if cool temp is overly hot
;
;~~~~~~~~~~~~~~~
;-Stuff for CCP 
;~~~~~~~~~~~~~~~
;
LD475   FCB       1		;timer val, CCP
LD476   FCB       2		;2 mph
LD477   FCB       1		;1 mph
LD478   FCB      16		;6.3% tps
LD479   FCB       5		;2.0% tps
LD47A   FCB     205		;16 kPa,
LD47B   FCB     120		;INT val
LD47C   FCB     100		;INT val
LD47D   FCB       8		;added in to output for CCP
LD47E   FCB       2		;subed out of output for CCP
LD47F   FCB      20		;20 mph
LD480   FCB     112		;BLM val
;
;~~~~~~~~~~~~~~~~~~~
;-Table for max CCP 
;~~~~~~~~~~~~~~~~~~~
;
;             Value		;Vacuum
;
LD481   FCB     255		;80		
        FCB     255		;70
        FCB     255		;60
        FCB     255		;50
        FCB     255		;40
        FCB     255		;30
        FCB     255		;20
        FCB     255		;10
        FCB     255		; 0
;
;~~~~~~~~~~~~~~~~~
;
; TCC parameters
;
;~~~~~~~~~~~~~~~~~
;
LD48A   FCB     102		;60 deg C, min cool temp for TCC lockup 
LD48B   FCB       3		;3 mph
LD48C	FCB       5		;5 mph
LD48D   FCB      10		;3.92% TPS
LD48E   FCB      10		;3.92% TPS
LD48F   FCB       5		;2% TPS, subbed out if TCC locked
LD490   FCB       0		;
LD491   FCB     253		;Filter coeff for MPH
LD492   FCB      15		;1.5 secs, post 4->3 TCC lockup delay timer val
LD493   FCB      15		;1.5 secs, TCC relock delay timer
LD494   FCB     255		;255 mph, mand speed for TCC lockup
;
;-TCC low gears thresholds
;
LD495   FCB     255		;Min speed for TCC to lock, low gears
LD496   FCB     255		;Max speed for TCC to lock, low gears
LD497   FCB      30		;Min speed for TCC to remain locked, low gears
LD498   FCB     255		;Max speed for TCC to remain locked, low gears
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TCC low gears load limit to remain locked
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;               %TPS =
;		val x .392 	;MPH
;
LD499   FCB      72		;20	
        FCB      74		;24
        FCB      74		;28
        FCB      80		;32	
        FCB      82		;36
        FCB      85		;40
        FCB      87		;44
        FCB      92		;48
        FCB     102		;52
        FCB     133		;56
        FCB     133		;60
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TCC low gears load limits to remain unlocked
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;
;               %TPS =
;		val x .392 	;MPH
;
LD4A4   FCB      54		;20
        FCB      57		;24
        FCB      57		;28
        FCB      62		;32
        FCB      64		;36
        FCB      67		;40
        FCB      69		;44
        FCB      72		;48
        FCB      79		;52
        FCB      97		;56
        FCB     102		;60
;
;-TCC high gear thresholds
;
LD4AF   FCB     255		;Min speed for TCC to lock, high gear
LD4B0   FCB     255		;Max speed for TCC to lock, high gear
LD4B1   FCB      30		;Min speed for TCC to remain locked, high gear
LD4B2   FCB     255		;Max speed for TCC to remain locked, high gear
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TCC high gear load limits to remain locked
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;               %TPS =
;		val x .392 	;MPH
;
LD4B3   FCB      72		;20
        FCB      74		;24
        FCB      74		;28
        FCB      80		;32
        FCB      82		;36
        FCB      85		;40
        FCB      90		;44
        FCB      97		;48
        FCB     118		;52
        FCB     138		;56
        FCB     138		;60
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-TCC high gear load limit to remain unlocked
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;               %TPS =
;		val x .392 	;MPH
;
LD4BE   FCB      54		;20	
        FCB      57		;24
        FCB      57		;28
        FCB      62		;32
        FCB      64		;36
        FCB      67		;40
        FCB      69		;44
        FCB      72		;48
        FCB      79		;52
        FCB      97		;56
        FCB     102		;60
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-TPS multiplier vs Baro
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Mult. = 	
;	Val/ 255		;kPa
;	  			
;
LD4C9   FCB     255		; 75
        FCB     255		; 85
        FCB     255		; 95
        FCB     255		;105
;
;~~~~~~~~~~~~~~~~~~~~~~~~
; 
; Shift light parameters
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-UL for rpm/drive ratio for gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD4CD   FCB     100		;1st
        FCB     141		;2nd
        FCB      40		;3rd
        FCB      30		;4th
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-LL for rpm/drive ratio for gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD4D1   FCB      80		;1st
        FCB      50		;2nd
        FCB      30		;3rd 
        FCB      20		;4th
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Min rpm value for shift light to be on vs gear
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD4D5   FCB       0		;1st
        FCB       0		;2nd
        FCB       0		;3rd
        FCB       0		;4th
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-%TPS multiplier vs gear
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD4D9   FCB     128		;1st
        FCB     128		;2nd
        FCB     128		;3rd
        FCB     128		;4th
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD4DD   FCB     209		;15 deg C,
LD4DE   FCB      32		;12.5% tps, min low gear tps for S/L
LD4DF   FCB      38		;14.9% tps. min high gears tps for S/L
LD4E0   FCB     168		;4200 rpm, mand rpm to activate shift light
LD4E1   FCB       0		;S/L delay value for low gear
LD4E2   FCB       0		;S/L delay value for high gears
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LD4E3	FCB      18		;IAC pos. init 
LD4E4   FCB	145        	;IAC park pos.
LD4E5   FCB      44		;Stall saver init RPMs, RPM/12.5, 550 RPM 
LD4E6   FCB      50		;Stall saver exit RPMs, RPM/12.5, 625 RPM
LD4E7   FCB       5		;Min pos. for closed throttle, 2.0%
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Idle adj. delay timer vals
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD4E8   FCB       5		;timer val for idle adj., idle too high
        FCB       0		;timer val for fast idle adj., idle too high
        FCB       5		;timer val for idle adj., idle too low
LD4EB   FCB       0		;timer val for fast idle adj., idle too low 
;
;~~~~~~~~~~~~~~~~
;
; Idle logic 
;
;~~~~~~~~~~~~~~~~
;
LD4EC   FCB       4		;50 rpm, delta threshold for fast rpm adjust, rpms > desired idle rpms
LD4ED   FCB       4		;50 rpm, delta threshold for fast rpm adjust, rpms < desired idle rpms
LD4EE   FCB       1		;12.5 rpm, margin for no idle adjust
LD4EF   FCB     200		;IAC retract steps
LD4F0	FCB      22		;IAC position, init	
LD4F1   FCB      87		;8.7 volts, threshold for IAC low voltage
LD4F2   FCB      16		;Min DFCO steps
LD4F3   FCB       9		;min stall saver steps
LD4F4   FCB       1		;A/C on, delay for idle adjust
LD4F5   FCB      60		;RPM/25, 1500 rpm
LD4F6   FCB      36		;103 dec C, temp threshold for addl. A/C on IAC counts
LD4F7   FCB       5		;Added A/C on IAC counts upon hot cool temp
LD4F8   FCB       3		;Addl. A/C on IAC counts if not idling
LD4F9   FCB       1		;1 sec, added in to kickdown delay timer
LD4FA   FCB      65		;IAC kickdown steps
LD4FB   FCB       2		;Added IAC steps for A/C on
LD4FC   FCB       8		;IAC steps sub'd out when not in drive
LD4FD   FCB      60		;750 rpm, target idle speed, A/C req.
LD4FE   FCB      80		;1000 rpm, ALDL target idle speed
LD4FF   FCB      58		;750 rpm, target idle speed, No A/C req.
LD500   FCB     210		;Max allow. IAC steps
LD501   FCB      70		;Max IAC steps for idle adjust, A/C on
LD502   FCB      40		;Max IAC steps for idle adjust, A/C off
LD503   FCB     112		;1400 rpm, max cold engine speed
LD504   FCB      80		;1000 rpm, max idle speed
LD505   FCB     128		;Max IAC throttle follower steps
LD506   FCB      48		;Low mph T/F decay thresh.
LD507   FCB      48		;Mid mph T/F decay thresh.
LD508   FCB      25		;High speed T/F decay coeff
LD509   FCB      20		;Decay coeff. for IAC steps, filtered
LD50A   FCB      64		;Decay coeff. for added in stall saver steps
LD50B   FCB       5		;5 mph, low speed t/f decay thresh
LD50C   FCB      20		;20 mph, high speed thresh.
LD50D   FCB       4		;min allow. steps for throttle follower
LD50E   FCB     254		;99%, Min %TPS for throttle follower
LD50F   FCB      15		;Throttle follower factor, in P/N
LD510   FCB      64		;Throttle follower factor, not in P/N
LD511   FCB       2		;Max rate of change for T/F
LD512   FCB     255		;Min temp to maintain engine speed below max cold engine rpm limit
LD513   FCB       5		;Min speed thresh to clear IAC trim (-)
;
;~~~~~~~~~~~~~~~~~~~~~~
;IAC steps vs. coolant
;~~~~~~~~~~~~~~~~~~~~~~
;
;		Steps		;Deg C
;
LD514   FCB     140		;-40
        FCB     130		;-10
        FCB     110		;  5
        FCB     105		; 15
        FCB     100		; 24
        FCB      95		; 31
        FCB      90		; 38
        FCB      85		; 43
        FCB      80		; 48
        FCB      65		; 55
        FCB      55		; 64
        FCB      55		; 70
        FCB      55		; 80
        FCB      55		; 91
        FCB      55		;110 
        FCB      55		;135
        FCB      55		;200
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-IAC added park pos. steps vs Baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	Steps			;kPa
;
LD525   FCB      40		; 75 
        FCB      35		; 85
        FCB      30		; 95 
        FCB      30		;105 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Stall saver steps vs. baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD529   FCB      25		; 75
        FCB      20		; 85
        FCB      15		; 95
        FCB      10		;105 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Added A/C on IAC steps vs. baro
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD52D   FCB       4		; 75 
        FCB       2		; 85
        FCB       0		; 95
        FCB       0		;105
;
;
		ORG   LCODE_START		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>			   <;
;>Begining of actual code  <;
;>                         <;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~
;>
;>Fuel minor loop
;>
;~~~~~~~~~~~~~~~~~~~
;
;-02 init
;
LD531	LDAA    #$0003		;02 channel
        LDAB    #$0001		;Return imm.		
        JSR     LFC21		;A/D routine, set up for data fetch
;
;-%VE adder lookup
;
        JSR     LFA94		;Do default map if err.		
        LDAA    L001B		;Load RPM/25
        LDX     #LD2C3		;%VE adder table
        JSR     LFB7B		;2D lookup
        STAA    L00AC		;Save it
;
;-Get 02 counts
;
        JSR     LFC2E		;A/D routine, get 02, A/D counts
        STAA    L0039		;02 counts
;
;-TPS init
;
        LDAA    #$000B		;TPS channel		
        LDAB    #$0001		;Return imm.
        JSR     LFC21		;A/D routine, set up for data fetch
;
        LDAA    L003A		;02, minor loop filtered
        STAA    L00BD		;02, minor loop filtered, one delayed
;
;-Filter 02
;
        LDX     L003A		;02, minor loop filtered
        LDAA    L0039		;02 
        LDAB    LD1D6		;240, filer coeff.
        JSR     LFB44		;Lag filter routine
        STD     L003A		;Store it
;
        ASLB    		;x2 for roundup
        ADCA    #$0000		;round up if needed
        STAA    L0039		;Save 02
        PSHA   			;02 ----> stack
; 
        LDAA    L00BE		;Airflow term
        LDX     #LD3AD		;02 filter coeff. vs airflow
        JSR     LFB7B		;2D lookup
        TAB 			;filter coeff. ----> B    
        PULA  			;Pull 02 off the stack
        LDX     L003E		;02 term, fitlered by airflow
        JSR     LFB44		;Lag filter		
        STD     L003E		;Store it
; 
;-Check if use Baro/Raw map is flagged, else use SD MAP for %VE lookup
;
        LDAA    L0024		;Load SD map
        LSRA 			;/2   
        LDAB    LD006		;opt word
        BITB    #$0008		;Test b3, do baro fuel corr.
        BEQ     LD596		;Bra if ==0
;
;-Do raw map conv. and use for %VE lookup, takes baro press. into account.
;
        LDAA    L0027		;Raw map
        CMPA    L00FE		;Baro pressure
        BCS     LD58C		;Bra if < baro pressure
;
        LDAA    #$007F		;127		
        BRA     LD596		;Bra
;
LD58C   LSRA  			;Raw Map /2  		
        ADDA    #$000E		;15, offset
        LDAB    L002F		;factor from Baro lookup
        MUL  			;(MAP val. x factor)   
        ASLD			;x2    
        ASLD 			;x2   
        SUBA    #$0020		;-32
;
;~~~~~~~~~~~~~~~~
;main %VE lookup
;~~~~~~~~~~~~~~~~
;
LD596   LDAB    L001B		;RPM/25
        BPL     LD59C		;bra if <3200
;
        LDAB    #$0080		;3200 rpm
;
LD59C   LDX     #LD278		;%VE table
        JSR     LFB99		;Do 3D lookup
        ADDA    L00AC		;add %VE in
        BCC     LD5A8		;Bra if overflow
;
        LDAA    #$00FF		;clr overflow
;
LD5A8   STAA    L00AC		;Store it, %VE
;
        JSR     LFC2E		;Go fetch TPS
        STAA    L0042		;Store it, TPS
        LDAB    L0008		;Status word
        ANDB    #$00DF		;clr b5, tps low err
;
        LDAA    L0001		;Status word
        BPL     LD5CF		;Bra if engine off
;
;-Engine on here
;
        LDAA    LD409		;diag mask
        BITA    #$0004		;Test b2, tps low
        BEQ     LD5D7		;Bra if ==0, dont perform test
;
;~~~~~~~~~~~~~~~~~~~~~~~
;-Code 22, TPS low err.
;~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAA    L0042		;TPS, A/D counts
        CMPA    LD41F		;10, .19 volts
        BCC     LD5D7		;bra if TPS is >=
;
        LDAA    L0012		;Error flag 1
        ORAA    #$0004		;Set b2
        STAA    L0012		;Save it
        ORAB    #$0020		;Set b5 of L0008, low TPS
        BRA     LD5D7		;Bra 
;
;-Engine off here
;
LD5CF   LDAA    LD1D4		;Load default min TPS pos
        STAA    L0047		;Store it, tps min pos, MSB
        CLR     L0048		;zero out LSB
;
LD5D7   STAB    L0008		;Save status word
        JSR     LFCEC		;Go do TPS work	
;
        LDAB    L0002		;Status word
        ANDB    #$007F		;clr b7
        CMPA    LD4E7		;5, %tps, 2.0% 
        BHI     LD5EE		;Bra if greater
;
        LDAA    L0030		;MPH
        CMPA    LD245		;3, mph
        BHI     LD5EE		;Bra if greater
;
        ORAB    #$0080		;set b7, do idle adjustment
LD5EE   STAB    L0002		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Take two routes, depending on engine running or not
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
        LDAA    L0001		;Status word
        BMI     LD5F7		;Bra if engine running
;
        JMP     LD6C8		;skip if engine off
;
;~~~~~~~~~~
;Engine on
;~~~~~~~~~~
;
LD5F7   LDAB    L0801		;MCU2
        LDAA    L0003		;Status word
        BITA    #$0008		;Test b3, park/neutral bit
        BEQ     LD625		;Bra if ==0
;
        BITB    #$0010		;Test b4, P/N bit
        BNE     LD629		;Bra if in P/N
;
        ANDA    #$00F7		;Clr P/N bit
        LDAB    L00C0		;startup choke adj. to AFR
        BNE     LD62B		;Bra if !=0
;
        LDAB    LD24B		;239 = -5 deg C, inv, A/D cool counts 
        BITA    #$0020		;Test b5, eng cool less then -5 deg C
        BEQ     LD617		;bra if ==0, coolant >= -5 deg C
;
        ADDB    #0002		;Add in addl. counts needed to set/clr status bits
;
        BCC     LD617		;bra if no overflow
;
        LDAB    #$00FF		;clr overflow
;
LD617   CMPB    L0020		;Coolant, inv., A/D counts
        BCS     LD61F		;Bra if coolant is < -5 deg C
;
        ORAA    #$0020		;Set b5, cool temp >= -5 deg C.
        BRA     LD62B		;bra
;
LD61F   ANDA    #$00DF		;Clr b5
        ORAA    #$0040		;set b6, engine cool < -5 deg C
        BRA     LD62B		;bra, dont set P/N bit just yet
;
LD625   BITB    #$0010  	;b4, P/N bit
        BEQ     LD62B		;Bra if still in park/neutral
;
LD629   ORAA    #$0008		;Set b3 of L0003, in P/N
;
LD62B   STAA    L0003		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Check status of MAP for AE
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        CLRB 			;   
        LDAA    L0024		;SD map
        SUBD    L002B		;SD map, slow filtered
;
        BLS     LD662		;Bra if map is falling
        TSTB 			;Test B  
        BPL     LD638	        ;Bra if <128
;	
        INCA 			;Round up MSB of delta map
;   
LD638   PSHA			;Delta map -----> stack    
        STAA    L002E		;Store it, delta MAP for AE
        LDAB    LD1D8		;7.1 kPa, delta map counts for AE 
        LDAA    L0043		;%tps	
        CMPA    LD1D9		;19% tps
        BHI     LD64A		;Bra if tps is greater
;
;-Double delta SD MAP thresh for AE
;
        ASLB    		;x2, 14.2 kPa thresh for AE
        BCC     LD64A		;bra if no overflow
;
	LDAB    #$00FF		;clr overflow
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;Enough delta map for AE?
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD64A   PULA    		;Get delta map off the stack
        CBA  			;Compare delta map to thresh   
        BLS     LD665		;Bra if not enough
;
;-MAP high enough for SD MAP AE
;
        LDX     #LD25F		;AE enrich table
        JSR     LFB72		;2D lookup with line count
;
;-Double AE term if enough %TPS
;
        LDAB    L0043		;%TPS
        CMPB    LD1DA		;128, 50% tps
        BLS     LD666		;Bra if tps is <=
;
        ASLA 			;AE x2   
        BCC     LD666		;Bra if no overflow
;	
        LDAA    #$00FF		;Clr overflow
;
        BRA     LD666		;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~
;MAP is falling here
;~~~~~~~~~~~~~~~~~~~~
;
LD662   CLR     L002E		;Clr delta MAP
LD665   CLRA    		;Clr delta MAP from stack pull
;
LD666   STAA    L004B		;tmp storage, AE pump shot
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Now see about delta TPS AE 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAB    L00E0		;Status word
        LDAA    L0043		;%TPS
        SUBA    L0044		;%TPS, one delayed
        BLS     LD690		;Bra if %TPS <=
;
        BITB    #$0010		;Test b4, 
        BNE     LD679		;Bra if ==1, no min %TPS for delta TPS AE
;
        CMPA    LD1DB		;4, 1.6% tps
        BLS     LD690		;Bra if delta TPS is less, no AE
;
;x delta %tps by 8 for lookup
;
LD679   ASLA			;x2    
        BCS     LD682		;overflow?
;
        ASLA 			;x2   
        BCS     LD682		;
;
	ASLA 			;x2    
        BCC     LD684		;bra if no overflow
;
LD682   LDAA    #$00FF		;Clr overflow
;
LD684   LDX     #LD265		;delta TPS AE table
        JSR     LFB72		;2D lookup w/ line count
;
        LDAB    L00E0		;Status word	
        ORAB    #$0010		;set b4, skip min %TPS check on next pass.
        BRA     LD693		;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~
;No delta TPS AE here
;~~~~~~~~~~~~~~~~~~~~~
;
LD690   CLRA 			;Clr delta %TPS   
        ANDB    #$00EF		;Clr b4 in status word L00E0
;
LD693   STAB    L00E0		;Save the status word
        STAA    L004A		;tmp storage, delta TPs pumpshot
;
;~~~~~~~~~~~~~~~~~~
;Sum up all the AE
;~~~~~~~~~~~~~~~~~~
;
        CLRA 			;   
        LDAB    L00E0		;Status word
        BITB    #$0004		;Test b2, IAC enabled 
        BEQ     LD6A1		;Bra if ==0
;
        LDAA    LD1DC		;6, IAC opening addl PW
;
LD6A1   ADDA    L004A		;Add in delta TPS AE PW
        BCS     LD6A9		;Bra if overflow
;
        ADDA    L004B		;delta MAP AE PW
        BCC     LD6AB		;Bra if no overflow
;
LD6A9   LDAA    #$00FF		;Clr overflow
;
LD6AB   BEQ     LD6C0		;Bra if pumpshot ==0
;
;-A now has all the addl. async. PW, do temp correction
;
        LDAB    L009C		;AE cool. factor
        MUL 			;AE x factor    
        LSRD 			;/2   
        LSRD			;/2    
        LSRD  			;/2
;  
        ADDD    L009A		;Add it in to tmp async fuel accumulator
        STD     L009A		;Store, tmp async accumulator
        STD     L0447		;HU ram
;
        LDAA    L000D		;Status word
        ORAA    #$0060		;set b5, b6, Async in effect and reset int
        BRA     LD6C4		;Bra, save it
;
;-No AE comes here
;
LD6C0   LDAA    L000D		;Status word
        ANDA    #$00BF		;clr b6, dont reset int. 
;
LD6C4   STAA    L000D		;Save it
        BRA     LD6D1		;Bra, engine is running
;
;-Engine off here
;
LD6C8   LDAA    L0043		;%TPS		
        CLRB 			;clr LSB   
        STD     L0045		;store, %TPS, slow filtered
        LDAA    L0024		;SD map
        STD     L002B		;store, SD map, slow filtered
;
;~~~~~~~~~~~
;Check VATS
;~~~~~~~~~~~
;
LD6D1   LDAA    L00DF		;Status word
        BITA    #$0040		;Test b6, VATS
        BEQ     LD6ED		;Bra, start not ok'd
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Check for high speed fuel shutoff
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	
        LDAB    LD221		;255 MPH, fuel cutoff speed
        LDAA    L000F		;Status word
        BITA    #$0001		;Test b0, High speed fuel cutoff
        BEQ     LD6E6		;Bra if ==0, high speed fuel cutoff not flagged
;
        DEC     L000F		;clr b0
        LDAB    LD222		;255 MPH, fuel resume speed
;
LD6E6   CMPB    L0030		;MPH
        BHI     LD6F0		;Bra if fuel cutoff speed is greater then MPH
;
        INC     L000F		;Set b0, high speed fuel cutoff in effect
LD6ED   JMP     LD876		;go kill the engine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Engine run a go, time to build BPW
;
;BPW = BPWC x AFR x VE x MAP x Cool corr. x BLM corr. x DFCO x decel. x FPV corr.  
;      +/- INT prop. term
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD6F0   LDAA    L00A9		;Inj cost.
        LDAB    L00A6		;Desired AFR
        CMPB    #$003F		;6.3 AFR
        BHI     LD710		;Bra if desired AFR is > 6.3
;
        CMPB    #$000F		;1.5 AFR
        BHI     LD705		;Bra if AFR > 1.5
;
;AFR <= 1.5 
;
        CLRB  			;Clr LSB of BPW	  
        STD     L00AE		;Store it, BPW
        LDAA    L00A6		;Desired AFR
        ASLA   			;x2 
        ASLA    		;x2
        BRA     LD70C		;Bra
;
;1.5 < AFR <= 6.3 
;
LD705   LDAB    #$0040		;64
        MUL 			;64 x inj const.    
        STD     L00AE		;Store it, BPW
        LDAA    L00A6		;desired AFR
;
LD70C   ASLA   			;x 2 
        ASLA 			;x 2   
        BRA     LD717		;bra
;
;6.3 > AFR
;
LD710   LDAB    #$0010		;16
        MUL 			;Inj. const. x 16    
        STD     L00AE		;store it, BPW
        LDAA    L00A6		;AFR
;
;-Go do inverse AFR lookup
;
LD717   LDX     #LFE5C		;Inverse AFR table
        JSR     LFB72		;2D lookup w/ line count
;
        BSR     LD73D		;Add it to BPW
;
        LDAA    L00AC		;%VE
        BSR     LD73D		;Go add it in
;
        LDAA    L002A		;Map term for BPW calc.
        BSR     LD73D		;
;
        LDAA    L00AD		;BPW inv cool correct term
        BSR     LD73D		;Add it in
;
        LDAA    L000D		;Status word
        BMI     LD748		;Bra if in PE, no BLM correction
;
        LDAA    L00A4		;Load in present BLM
        JSR     LFC0C		;(A x X*)/256
        ASLD   			;x2, now /128 for BLM correction 
        BCC     LD746		;Bra if no overflow
;
        LDD     #$FFFF		;Clr overflow
        JMP     LD878		;Jump
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;subroutine to add to BPW
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD73D   LDX     #L00AE		;sync BPW
        JSR     LFC0C		;(A x X*)/256	
        STD     L00AE		;Save BPW
        RTS 			;Return
;    
LD746   STD     L00AE		;Save BPW
;
;~~~~~~~~~~~~~~~~~~~
;DFCO quals.
;~~~~~~~~~~~~~~~~~~~
;
LD748   LDAA    L0020		;Load cool, inv, A/D counts
        CMPA    LD23E		;231, 0 deg C
        BLS     LD752		;Bra if temp is greater
;
        JMP     LD7EF		;Skip DFCO
;
LD752   LDAA    L0010		;Status word
        BITA    #$0010		;Test b4, in P/N
        BNE     LD77B		;Bra if in P/N, do DFCO
;
        LDAB    L0008		;Status word
        BITB    #$0024		;Test b3, b6
        BNE     LD765		;Bra if ==0
;
        LDAA    L0043		;%TPS
        CMPA    LD23C		;8, 3.1% tps limit for DFCO	
        BCC     LD791		;Bra if tps is greater
;
LD765   LDAA    L001F		;RPM/12.5, filtered, one delayed
        SUBA    L001D		;RPM/12.5, filtered
;
        BCS     LD770		;Bra if rpms rising
;
        CMPA    LD236		;delta RPM = 4, 50 RPM
        BHI     LD77B		;Bra if delta RPMs are greater, No DFCO
;
LD770   BITB    #$00C0		;b6, b7  
        BNE     LD7A8		;Bra if ==1, MAP tests failed
;
        LDAA    L002E		;Delta SD MAP, from AE
        CMPA    LD237		;10 = 23 kPa
        BLS     LD796		;Bra if delta map is <=
;
LD77B   LDAA    L00A1		;post DFCO timer
        BEQ     LD791		;Bra if ==0, not in DFCO
;
;~~~~~~~~~~~~~~~~~~
;Here to exit DFCO
;~~~~~~~~~~~~~~~~~~
;
        LDD     L009A		;tmp asnc accumulator
        ADDD    LD238		;262,
        BCC     LD789		;Bra if overflow
;
        LDD     #$7FFF		;clr overflow
;
LD789   STD     L009A		;Save it
;
        LDAA    L000D		;Status word
        ORAA    #$0020		;b5, async fuel in effect
        STAA    L000D		;Save it
;
LD791   CLR     L00A1		;Clr post DFCO timer
        BRA     LD7E3		;Bra
;
LD796   LDAA    L0027		;Load MAP A/D counts
        LDAB    L0007		;Status word
        CMPA    LD234		;34, 23 kPa, lower limit for DFCO
        BCS     LD7A8		;Bra if MAP is less
;
        BITB    #$0008		;b3 = DFCO flag
        BEQ     LD7E3		;Bra if DFCO wasnt active
;
        CMPA    LD235		;53, 30 kPa, upper limit for DFCO
        BCC     LD7E3		;Bra, no DFCO
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Do DFCO limits for RPM/MPH
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;RPM thresholds to exit DFCO
;$D230 = 1175 RPM
;$D231 = 950 RPM
;
;MPH thresholds to exit DFCO
;$D232 = 40 MPH
;$D233 = 35 MPH
;
LD7A8   LDX     #LD230		;Addr. of table of vals. 
        LDAB    L0007		;Status word
        BITB    #$0008		;DFCO active bit
        BEQ     LD7B2		;Bra if not in DFCO
;
        INX 			;Inc addr.    
;
LD7B2   LDAA    L001B		;RPM/25
        CMPA    $0000,X		;Compare to RPM	limit for DFCO
        BLS     LD77B		;Bra if RPMS are less, exit DFCO
;
        LDAA    L0030		;MPH
        CMPA    $0002,X		;compare to MPH limit for DFCO
        BCS     LD77B		;Bra if less, exit DFCO
;
        LDAA    L00A2		;DFCO timer
        BNE     LD7E0		;Not time for DFCO yet
;
        ORAB    #$0008		;Set b3, DFCO active
        STAB    L0007		;Save it
;
        LDAA    LD23B		;160 = 2 secs. 
        STAA    L00A1		;Save it, Post DFCO timer
;
        LDAA    L000D		;Status word
        ORAA    #$0010		;Decel enleanment underway
        STAA    L000D		;Save it
;
        LDAA    L00A0		;DFCO mult.		
        SUBA    LD23D		;-1
        BCC     LD7D9		;Bra if no underflow
;
        CLRA 			;Clr underflow
;   
LD7D9   STAA    L00A0		;Save it
        JSR     LD73D		;Add it into the BPW
        BRA     LD84D		;Still in DFCO so bra
;
LD7E0   DECA 			;-1, DFCO timer   
        BRA     LD7E6		;Bra it save it
;
;~~~~~~~~~~~~~~~~~~~~
;Not in DFCO anymore
;~~~~~~~~~~~~~~~~~~~~
;
LD7E3   LDAA    LD23A		;80 = 1 sec.
;
LD7E6   STAA    L00A2		;Store it, DFCO timer
;
        LDAA    L00A1		;Post DFCO timer
        BEQ     LD7EF		;Bra if ==0
;
        DEC     L00A1		;-1, post DFCO timer
;
LD7EF   LDAA    L0007		;Status word
        ANDA    #$00F7		;Clr DFCO bit.
        STAA    L0007		;save it
;
        LDAA    #$00FF		;255
        STAA    L00A0		;Save it, DFCO mult.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;Check decel enlean quals
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDD     L0045		;%TPS, slow filtered
        ASLB   			;LSB x2 
        ADCA    #$0000		;Round if needed
        BCC     LD801		;Bra if no overflow
;
        DECA 			;Subtract carry
;   
LD801   SUBA    L0043		;Subtract TPS
        BCS     LD847		;Bra if TPS is rising, no decel enlean
;
        CMPA    LD22D		;3=1.2%, Delta %TPS 
        BLS     LD847		;Bra if less, no decel enlean
;
        LDD     L002B		;Slow filtered SD map
        ASLB 			;LSB x2			   
        ADCA    #$0000		;round if needed
        BCC     LD812		;Bra if no overflow
;
        DECA  			;Subtract carry
;  
LD812   SUBA    L0024		;Subtract SD map
        BCS     LD847		;Bra if MAP is rising, no decel enlean
;		
        CMPA    LD22E		;8 = 22.5 kPa, delta MAP lim for decel enlean
        BLS     LD847		;Bra if less go do decel enlean
;
;    8 x (Delta MAP x 224) x D.E.C.F
;A = --------------------------------
;                   256 
;
        LDAB    LD22F		;224			
        MUL   			;delta SD MAP x mult.
;
        LDAB    L009F		;Decel enlean cool. factor
        MUL  			;
;   
        ASLD    		;x2
        BCS     LD82B		;Overflow?
;
        ASLD 			;x2   
        BCS     LD82B		;
;
        ASLD 			;x2   
        BCC     LD82D		;Carry clear?
;
LD82B   LDAA    #$00FF		;Clr overflow
;
LD82D   NEGA  			;2's comp. of A  
        BEQ     LD847		;Bra if A = 0, no decel enlean
;
        LDAB    L000D		;Status word
        ORAA    #$0010		;det b4, decel enlean underway
        STAB    L000D		;Save it
;
        STAA    L0050		;tmp storage, from op. above
        LDX     #L009A		;async fuel acc.
        JSR     LFC0C		;(A x X*)/256
        STD     L009A		;Store it
;
        LDAA    L0050		;tmp storage
        JSR     LD73D		;Go add it in to the sync. BPW
        BRA     LD850		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~
;No decel enlean here
;~~~~~~~~~~~~~~~~~~~~~
;
LD847   LDAA    L000D		;Status word
        ANDA    #$00EF		;clr b4, decel enlean no longer in effect
        STAA    L000D		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;Continue with BPW calcs.
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD84D   LDX     #L00AE		;Sync BPW	
LD850   LDAA    L00B5		;FP volts corr. factor
        JSR     LFC0C		;(A x X*)/256
        ASLD  			;x2, now /128  
        BCC     LD85D		;Bra if no overflow
;
        LDD     #$FFFF		;Clr overflow
        BRA     LD878		;Bra past code, BPW already maxed out
;
LD85D   STD     L00AE		;Save BPW
        CLRA  			;clr MSB  
        LDAB    L00B4		;int proportioning term
        BMI     LD86D		;Bra if <0
;
;-Positive int proportioning term.
;
        ADDD    L00AE		;Add it in to the BPW
        BCC     LD878		;bra if no overflow
;
        LDD     #$FFFF		;clr overflow
        BRA     LD878		;BRa to save
;
;-Negative int proportioning term
;
LD86D   NEGB			;2s comp, make positive    
        STD     L0049		;tmp storage
        LDD     L00AE		;BPW
        SUBD    L0049		;Subtract it out
        BCC     LD878		;Bra if no underflow
;
;~~~~~~~~~~~~~~~~~~~~~~
;Come here to cut fuel
;~~~~~~~~~~~~~~~~~~~~~~
;
LD876   CLRA 			;Clr out BPW   
        CLRB 			;
;   
LD878   STD     L00AE		;Save it, BPW
;
;-BPW x 4 for Async calcs.
;
        LDD     L00AE		;Load BPW
        ASLD			;x2    
        BCS     LD884		;Bra if overflow
;
        ASLD 			;x2   
        BCS     LD884		;
;
        BPL     LD887		;Bra if b15 == 0
;
LD884   LDD     #$7FFF		;Load in max val.
;
LD887   STD     L004B		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Do BPW conversion for async fuel
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;            4 x Sync BPW x RPM conv. coeff.
;Async PW = --------------------------------- 
;			   256
;
        LDAA    L001B		;RPM/25
        LDX     #LD366		;Addr of conversion table
        JSR     LFB72		;2D lookup with line count
        LDX     #L004B		;Stored BPW x 4
        JSR     LFC0C		;(A x X*)/256
        STD     L004F		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Time for inj. pulsewidth programming
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; LBC0E = Sync PW counter
; LBC14 = Async. PW counter
; LBC3C = PWM control, b7 for async fuel
;
        LDAA    L0000		;Status word
        BITA    #$0010		;Engine shut down	
        BEQ     LD8A7		;Bra if shutdown isnt in effect
;
;-Shutdown in effect
;
        CLRA   			;Clr pulse width 
        CLRB   			; 
        STD     LBC0E		;Save it, cut the fuel to motor
        JMP     LD95C		;
;
LD8A7   LDAA    L0001		;Status word
        BPL     LD8CF		;Bra if motor off
;
;-Engine running
;
        LDX     L00AE		;sync BPW
        CPX     LD223		;1098 usecs, min sync BPW thresh for exiting async fueling
        BHI     LD8CF		;Bra if greater
;	
        LDAA    L000E		;Status word
        BITA    #$0010		;Test b4, async fueling in effect
        BNE     LD8C1		;Bra if ==1, continue with async fueling
;
        CPX     LD225		;900 usecs, min sync BPW to enter async fueling	
        BHI     LD8CF		;Bra if sync BPW greater
;
        ORAA    #$0010		;Set b4, in async fueling
        STAA    L000E		;Save it
;
LD8C1   LDD     L004F		;Load up async BPW
        ADDD    L00B0		;Asnyc PW accumulator
        STD     L00B0		;Save it
;
        LDX     #$0000		;
        STX     LBC0E		;Zero out the sync PW
        BRA     LD903		;Bra, continue

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Exiting/not in async fueling here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD8CF   LDAA    L000E		;Status word
        ANDA    #$00EF		;Clr b4, no longer in async
        STAA    L000E		;Save it
;
        LDX     #$0000		;
        STX     L00B0		;clr the async fuel acc.
;
;If sync BPW >= 1950 usecs, add in inj. bias
;
        LDD     LD227		;26, 396 usecs.
        LDX     L00AE		;sync BPW
        CPX     #$0080		;128 = 1950 usecs
        BCC     LD8F1		;Bra if sync BPW is >  
;
;sync BPW < 1950 usecs, use table for bias
;
        LDX     #LD253		;inj. bias vs BPW table			
        LDAA    L00AF		;LSB of sync BPW
        ASLA 			;x2   
        LDAB    #$0050		;80=610 usec offset	
        JSR     LFB77		;2D lookup w/ SBA
        TAB   			;bias ----> B  
        CLRA  			;  
LD8F1   ADDD    L00AE		;Add in bias
        BCS     LD8F7		;Bra if overflow
;	
        BPL     LD8FA		;Bra if less then max val
;
LD8F7   LDD     #$7FFF		;Load in max
;
LD8FA   STD     LBC0E		;Save it, sync PW counter
;
        LDAA    L000D		;Status word
        BITA    #$0020		;b5, async fueling in effect
        BEQ     LD95C		;Bra if no quasi-async fueling in effect
;
;~~~~~~~~~~~~~~~~~~
;Do asnync fueling
;~~~~~~~~~~~~~~~~~~
;
LD903   LDD     L00B0		;Asnyc fuel accumulator
        ADDD    L009A		;Tmp async fuel acc. 	
        PSHB   			;PW ----> stack 
        PSHA    		;
        PULX    		;PW ----> X
        CPX     LD229		;11.9 msecs, largest async PW per pass
        BHI     LD922		;Bra if greater
;
        CPX     LD22B		;237 usecs, smallest async PW
        BLS     LD956		;Bra if <=, no async fuel
;
        ADDD    LD227		;Add in inj bias
        STD     LBC14		;Store it, async PW counter
;
        CLRA    		;
        CLRB    		;
        STD     L009A		;Clr tmp async fuel acc.  
        STD     L00B0		;Clr async fuel acc.
        BRA     LD93A		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Async PW is greater then 11.9 msecs.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD922   LDD     LD229		;11.9 msec, max async PW
        ADDD    LD227		;Add in inj. PW
        STD     LBC14		;Save it, async PW counter
; 
        LDD     L00B0		;Async acc.
        SUBD    LD229		;-11.9 msec, max PW in async
        BCC     LD938		;Bra if no underflow
;
        ADDD    L009A		;Add remainder into tmp async fuel acc.
        STD     L009A		;Save it
;
        CLRA   			;Clr underflow 
        CLRB    		;
;
LD938   STD     L00B0		;Store async fuel acc.
LD93A   JSR     LFD2B		;RTS, delay	
        LDD     LBC3C		;PWM control reg.
        ANDB    #$007F		;clr b7, async BPW
        JSR     LFD2B		;RTS, delay
        STD     LBC3C		;Save it
;
        ORAB    #$0080		;b7, async BPW
        JSR     LFD2B		;RTS, delay
        STD     LBC3C		;Save it PWM control reg.
;
        LDAA    L000D		;Status word
        ORAA    #$0020		;Set b5, async fuel in eff.
        BRA     LD95A		;
;
LD956   LDAA    L000D		;Load status word
        ANDA    #$00DF		;clr b5, async fuel no longer in effect
LD95A   STAA    L000D		;save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Alternate paths on each pass though
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Runs alternate 40 Hz code loops on each pass
;
LD95C   LDAA    L0066		;RTS counter
        ANDA    #$0003		;Mask out b0, b1
        CMPA    #$0003		;		
        BEQ     LD967		;bra if ==3, run first code loop 
        JMP     LDCD0		;jmp to second loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;> Fuel loop one
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LD967   LDAA    LD1EC		;147, 14.7 AFR
        LDAB    L000E		;status word	
        BITB    #$0081		;b0, b7
        BNE     LD987		;bra if ==1, in closed loop
;
;-In open loop
;
        LDX     #LD30D		;Open loop AFR correction vs. vacuum
        LDAA    L002D		;Vacuum	
        JSR     LFB72		;2D lookup with line count
        ADDA    L00B6		;Added open loop AFR
        BCC     LD97E		;Bra if no overflow
;
        LDAA    #$00FF		;clr overflow
;
LD97E   SUBA    L00E5		;Choke adj to AFR
        BCS     LD986		;Bra if underflow
;
        SUBA    L00C0		;Startup choke adj. to AFR
        BCC     LD987		;Bra if no underflow
;
LD986   CLRA   			;Clr underflow
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Force open loop if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Test if in ALDL mode
;
LD987   LDAB    L0002		;Status word
        BITB    #$0020		;Test b5, in ALDL mode
        BNE     LD9DF		;Bra if ==1
;
        LDX     #LD1F1		;Start addr. of quals.
        LDAB    L0020		;Cool, inv., A/D counts	
        CMPB    $0006,X		;0, 200 deg C
        BCC     LD9DF		;bra if cool temp is less
;
        LDAB    L0003		;Status word
        BITB    #$0010		;Test b4, use entering closed loop quals.
        BNE     LD99D		;bra if ==1
;
;-Check to make sure motor isnt idling
;
        INX 			;Curr addr. +1, alternate vals. 
;		   
LD99D   LDAB    L0043		;load %TPS
        CMPB    $0000,X		;5, = 2.0%, 6 = 2.3%
        BCC     LD9DF		;Bra if %TPs is > 
;
;-Check to see if rpms are > 650 rpm 
;
        LDAB    L001B		;RPM/25
        CMPB    $0002,X		;26 = 650 RPM, 28 = 700 RPM
        BCC     LD9DF		;bra if rpm/25 is > 
;
;-See if vehicle is moving
;
        LDAB    L0030		;MPH
        CMPB    $0004,X		;4 = 4 mph, 2 = 2 mph
        BCC     LD9DF		;bra if mph is > 
;
;-Any map errors?
;
        LDAB    L0008		;Status word
        BITB    #$00C0		;Test b6, b7 map test 
        BNE     LD9DF		;BRa if ==1, dont force open loop
;
;-After first pass, set b4 of L0003
;
        LDAB    L0003		;Status word
        ORAB    #$0010		;Set b4, use entering closed loop quals.
        STAB    L0003		;save it
;
        BITB    #$0001		;Test b1, forced to open loop
        BEQ     LD9E7		;bra if ==0, bra if not forced to open loop previously
;
        LDAB    L00A7		;timer
        CMPB    LD1F9		;5
        BCS     LD9D4		;Bra if less
;
        LDAA    LD1FA		;140
        LDAB    L0010		;Status word
        BITB    #$0008		;Test b3, A/C req bit
        BEQ     LD9FA		;Bra if A/C req.
        LDAA    LD1FB		;132
        BRA     LD9FA		;bra
;
LD9D4   LDAB    L0066		;RTS counter
        ANDB    #$001C		;Mask out b2-b4
        BNE     LD9FA		;bra if !=0
;
        INC     L00A7		;Inc delay timer
        BRA     LD9FA		;bra
;
;-Not forcing open loop here
;
LD9DF   LDAB    L0003		;Status word 
        ANDB    #$00EE		;clr b4, b1
        STAB    L0003		;Save it
        BRA     LD9F7		;bra, 
;
LD9E7   LDAB    L00A7		;delay timer
        CMPB    LD1F8		;40
        BCS     LD9D4		;Bra if less
;
;-Forced to open loop here
;
        INC     L0003		;Set b1, forced to open loop  
        LDAB    L000E		;Status word
        ANDB    #$007F		;Clr b7, clr closed loop flag
        STAB    L000E		;Save it
;
;-Common location to reset delay timer
;
LD9F7   CLRB			;Clr B 
        STAB    L00A7		;Save it, 
;
LD9FA   LDAB    L0001		;status word		
        BPL     LDA6A		;Bra bra if engine off
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Engine on here, HW mode quals
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAB    L000E		;Status word
        BPL     LDA31		;bra if b7==0, in open loop
;
        LDAB    L002D		;Load vacuum
        CMPB    LD028		;HW mode vac thresh, 254 = 80 kPa
        BCC     LDA31		;Bra if vacuum is less then threshold
;
        LDAB    L0020		;Cool temp
        CMPB    LD1E2		;199, 20 deg thresh for HW mode
        BCC     LDA31		;Bra if cool temp is less
;
        LDAB    L0080		;CCP
        CMPB    LD1EE		;166
        BLS     LDA31		;Bra if <=
;
        LDAB    L0008		;Status word
        BITB    #$00C0		;b6, b7, map test bits
        BNE     LDA31		;Bra if ==1
;
        LDAB    L0030		;MPH
        CMPB    LD1ED		;52 mph
        BCS     LDA31		;Bra if MPH <=
;
        LDAB    L000F		;Status word
        BITB    #$0010		;Test b4, in HW mode
        BEQ     LDA3C		;Bra if ==0, not in HW mode
;
        LDAB    L00A8		;HW mode timer
        CMPB    LD1F0		;255
        BCS     LDA46		;Bra if < do HW mode, else, pop out of HW mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Here if quals not passed
;~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA31   CLR     L00A8		;Clr hw mode timer
        LDAB    L000F		;Load status word
        ANDB    #$00EF		;Clr b4, not in HW mode
        STAB    L000F		;Save it
        BRA     LDA5E
;
LDA3C   LDAB    L00A8		;Hw mode timer
        CMPB    LD1EF		;60
        BCS     LDA55		;bra if <, dont do lookup for HW mode
;
        CLR     L00A8		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Passed all quals. now do HW mode fuel
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDA46   LDAB    L000F		;Status word
        ORAB    #$0010		;Set b4, in HW mode
        STAB    L000F		;Save it
;
        LDX     #LD390		;HW mode AFR vs vac
        LDAA    L002D		;Vac.
        LSRA  			;/2  
        JSR     LFB7B		;Go do lookup
;
LDA55   LDAB    L0066		;RTS counter
        CMPB    #$0033		;51
        BNE     LDA5E		;Bra if !=
;
        INC     L00A8		;+1, HW mode timer in Acc B
LDA5E   CMPA    LD214		;200, 20:1 AFR, max allow. lean AFR
        BLS     LDA66		;Bra if <=
;
        LDAA    LD214		;load in 200, 20:1 AFR
LDA66   STAA    L00A6		;Save it, AFR
        BRA     LDAA2		;bra
;
;~~~~~~~~~~~~~~~~
;Engine off here
;~~~~~~~~~~~~~~~~
;
;-Check to see if clr flood req.
;
LDA6A   LDAA    LD216		;200, 20.0:1 AFR	
        LDAB    LD215		;230, 90.1% TPS
        CMPB    L0043		;%TPS
        BLS     LDA9E		;Bra if %TPS is <=, clear flood req.
;
;Do crank AFR corr. for temps less then 0 deg C (cold high alt. corr?)
;
        LDAA    L00B7		;Crank AFR
        LDAB    L0020		;Cool, inv., A/D counts
        CMPB    LD217		;231, 0 deg. C
        BLS     LDA9E		;Bra if temp is >= thresh
;
        PSHA  			;Crank AFR ----> stack
;  
        LDAA    L002D		;Load Vac
        LDAB    #$0060		;96, 50 kPa offset
        LDX     #LD34A		;Crank AFR corr. vs vac
        JSR     LFB77		;2D lookup with SBA
        PULB  			;Get crank AFR back off the stack  
        MUL   			;Crank AFR x corr factor
;  
        ASLD   			;x2 
        BCS     LDA96		;Bra if overflow
;
        ASLD 			;x2   
        BCS     LDA96		;
;
        ASLD 			;x2   
        BCS     LDA96		;
;
        ASLD  			;x2  
        BCC     LDA98		;Bra if still no overflow
;
;                        (Crank AFR x crank AFR mult.)
;Corr. crank AFR term = -------------------------------	
;				      16
;
LDA96   LDAA    #$00FF		;Clr overflow
LDA98   CMPA    L00B6		;Compare added open loop AFR
        BCS     LDA9E		;Bra if crank AFR is less then open loop AFR
;       
	LDAA    L00B6		;Load in added open loop AFR
;
;-Save AFR
;
LDA9E   STAA    L00A6		;AFR
        BRA     LDABC		;
;
;~~~~~~~~~~~~~~~~~~
;Do some PE quals.
;~~~~~~~~~~~~~~~~~~
;
;-Do baro correction of TPS
;
LDAA2   LDX     #LD37D		;tps mult. vs baro table		
        JSR     LFBC7		;Go do lookup
        PSHA    		;adjusted %tps ----> stack
;
        LDX     #LD381		;%TPS for PE vs RPM table
        BSR     LDAC4		;scaled RPM lookup routine
;
        LDAA    L000D		;Status word
        BPL     LDAB8		;Bra if not in PE
;
        SUBB    LD218		; - 8, tps hyst.
        BCC     LDAB8		;Bra if no underflow
;
        CLRB 			;Clr overflow
;   
LDAB8   PULA    		;Adj. %tps
        SBA 			; - %TPS for PE    
        BCC     LDACF		;Bra if %TPS is greater
;
LDABC   LDAA    L000D		;Load status word
        ANDA    #$007F		;Clr b7, no PE
        STAA    L000D		;Save it
        BRA     LDB06		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Subroutine to do lookup using scaled RPM
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDAC4   LDAA    L001A		;Load in scaled RPM
        LSRA  			;/2  
        LSRA  			;/2  
        ADCA    #$0000		;Round if needed
        JSR     LFB7B		;Go do lookup		
        TAB     		;Transfer looked up val to B
        RTS     		;Return
;
;~~~~~~~~~~~
;In PE here
;~~~~~~~~~~~
;
LDACF   LDAA    L000D		;Status word
        ORAA    #$0080		;set b7, PE in effect
        STAA    L000D		;Save it
;
        LDX     #LD38B		;Corr. factor vs %TPS table
        LDAA    L0043		;%TPS
;
;-Scale %TPS for lookup
;
        LDAB    #$00A0		;160
        MUL     		;(%TPS x 160)/256
        ADCA    #$0000		;round if needed
        LDAB    #$0060		;96
        JSR     LFB77		;2D lookup with SBA
        PSHA    		;corr. factor ----> stack
;
;Look up PE AFR
;
        LDX     #LD386		;PE AFR vs RPMs
        BSR     LDAC4		;Lookup using scaled rpms
;
;-Do %TPS corr. to PE AFR
;
        PULA  			;get %TPS corr. factor off the stack 
        MUL     		;%TPS corr. factor x PE AFR
        ASLD 			;x2   
        BCC     LDAF1		;BRa if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LDAF1   TAB   			;(TPS corr. factor x PE AFR)/128 ----> B
;  
        LDAA    L0020		;Coolant, inv., A/D counts
        CMPA    LD219		;231, 0 deg C
;
        BCS     LDAFF		;Bra if cool temp is greater
;		
;-Enrich the AFR  if cool temp below 0 deg C
;
        SUBB    LD21A		;sub out 1.0:1 AFR
        BCC     LDAFF		;Bra if no underflow
;	
        CLRB			;clr underflow
;
;-See if PE AFR is leaner than desired AFR
;    
LDAFF   LDAA    L00A6		;Load stored AFR
        CBA   			;Compare PE AFR to stored AFR
        BLS     LDB06		;Bra if PE AFR is >= (leaner)
;
        STAB    L00A6		;Save PE AFR
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Do some stuff with the BLMs
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDB06   LDAA    L0000		;Load status word
        BITA    #$0002		;test b1
        BEQ     LDB0F		;BRa if ==0, no HU
;
;-Do HU
;
        JSR     L5800		;Go do HU
;
;-Check rpm boundries
;
LDB0F   LDAA    L000D		;Status word
        ANDA    #$00FB		;clr b2, bit for int reset
        STAA    L000D		;Store it
;
        LDAB    L00A3		;Current BLM cell in use
        ANDB    #$0003		;mask out b0 and b1
        LDX     #LD1FD		;BLM RPM boundries
        ABX   			;add lower 2 bytes to X and use as offset  
        DEX     		;Addr. -1
        TSTB   			;Test curr BLM cell # 
        BEQ     LDB30		;Bra if ==0
;
;Test lower rpm bounds
;
        LDAA    $0000,X		;Load in BLM rpm boundry
        SUBA    LD203		;BLM RPM hyst., 50 RPM
        BCS     LDB2C		;bra if boundry - hyst is < 0.
;
;-Time to change cells yet?
;
        CMPA    L001B		;RPM/25
        BHI     LDB67		;Bra if RPMs are > curr. boundry, time to change cell
;
;Test upper rpm bounds
;
LDB2C   CMPB    #$0003		;BLM cell #3, last cell in row
        BEQ     LDB3B		;Bra if ==3, dont do hyst. check
;
LDB30   LDAA    $0001,X		;Next BLM rpm boundry
        ADDA    LD203		;Add rpm hyst. in
        BCS     LDB3B		;Bra if boundry + hyst. >255
;
        CMPA    L001B		;rpm/25
        BCS     LDB67		;Bra if next boundry is less then curr. rpms, change cell
;
;-Check SD MAP boundries
;
LDB3B   LDAB    L00A3		;Curr blm cell in use
        ANDB    #$000C		;Mask out b2,b3
        LSRB    		;/2
        LSRB   			;/2 
        LDX     #LD200		;Addr. of lower map boundry
        ABX   			;Add in curr blm cell w/ resp. to map in  
        DEX  			;-1   
        TSTB    		;Test sign
        BEQ     LDB58		;Bra if ==0
;
;-Test lower map bounds
;
        LDAA    $0000,X		;Load in boundry
        SUBA    LD204		;MAP hyst. 1.8 kPa
        BCS     LDB54		;Bra if current boundry - hyst <0
;
        CMPA    L0024		;SD map
        BHI     LDB67		;Bra if MAP is lower then boundry
;
LDB54   CMPB    #$0003		;3, last cell in use
        BEQ     LDB63		;Bra if curr cell ==3
;
;-Test upper map bounds
;
LDB58   LDAA    $0001,X		;Load next boundry
        ADDA    LD204		;Add in map hyst.	
        BCS     LDB63		;bra if map boundry + hyst. > 255
;
        CMPA    L0024		;Comp boundy to SD map
        BCS     LDB67		;Bra if boundy is less
;
;-Stick with curr. cell
;
LDB63   LDAB    L00A3		;Load current blm cell
        BRA     LDB99		;
;
;
;-Calc which cell to enter into
;
;  
;-BLM cell map   
;
;        RPM
; -----------------
;  12| 13 | 14 | 15
; -----------------
;  8 |  9 | 10 | 11 
; ----------------- MAP
;  4 |  5 |  6 | 7
; -----------------
;  0 |  1 |  2 | 3
; -----------------
;
LDB67   LDAA    L000D		;Status word
        ORAA    #$000C		;set b2,b3, new cell in use, reset int.
        STAA    L000D		;Save it, status word
;
        CLRB  			;Clr, used to calc. BLM cell #
        LDAA    L001B		;rpm/25
        CMPA    LD1FD		;Lower map boundry
        BCS     LDB82		;Bra if rpms are less then boundry
;
        INCB  			;+1  
        CMPA    LD1FE		;mid RPM boundry
        BCS     LDB82		;Bra if rpms are less
;	
        INCB   			;+1 
        CMPA    LD1FF		;upper BLM boundry
        BCS     LDB82		;Bra if rpms are less
;
        INCB 			;+1, now using uppermost blm cell w/ respect to rpm
;   
LDB82   LDAA    L0024		;SD map
        CMPA    LD200		;Lower blm map boundry
        BCS     LDB99		;bra if map is less
;
        ADDB    #$0004		;Skip to next row
        CMPA    LD201		;Mid map boundry	
        BCS     LDB99		;Bra if map is less
;
        ADDB    #$0004		;Skip another row
        CMPA    LD202		;High map boundry
        BCS     LDB99		;Bra if map is less
;
        ADDB    #$0004		;Now in uppermost row
;
LDB99   LDX     #L00ED		;BLM cell #0
        ABX    			;Add in curr blm cell # to get offset 
        LDAA    $0000,X		;Load blm cell
;
;-Check BLM limits
;
        CMPA    LD208		;185, upper limit
        BHI     LDBA9		;Bra if BLM val is greater
;
        CMPA    LD209		;95, lower limit
        BCC     LDBB2		;Bra if >
;
;-BLM out of limits
;
LDBA9   LDAA    L0007		;Status word
        ORAA    #$0040		;Set b6
        STAA    L0007		;save it
        JSR     LFE0F		;Go reset the BLM cells
;
LDBB2   STAA    L00A4		;Store BLM
        STAB    L00A3		;Store curr BLM cell #
;
;-EGR
;
        LDAB    L00DF		;Status word
        BITB    #$0002		;test b1, egr active
        BEQ     LDBC8		;BRa if egr not active
;
;-Generate indexed val. for lookup
;
        LDAA    L002D		;Load vac
        COMA   			;ones comp.
; 
        CMPA    #$0040		;64, 20 kPa, 60 kpa of vac
        BLS     LDBD0		;Bra if man. press is <=
;
        LSRA   			;/2 
        ADDA    #$0060		;offset
        BRA     LDBD1		;Go do lookup
 ;
LDBC8   LDAA    LD205		;134, inj const
        LDAB    LD1CF		;24, filter coeff
        BRA     LDBDA		;Bra
;
LDBD0   ASLA    		;x2
;
LDBD1   LDX     #LD26B		;Inj const. vs. man. press
        JSR     LFB68		;2D lookup w/ UL
        LDAB    LD1D0		;Filt. coeff for egr active
;
;-Filter inj. const 
;
LDBDA   LDX     L00AA		;Stored inj const.
        JSR     LFB44		;Lag filter
        STD     L00AA		;Save filtered value
        ASLB 			;LSB x2	   
        ADCA    #$0000		;Roun d if needed
        PSHA 			;inj const. ----> stack 
;  
        LDX     #LD370		;Inj corr. factor vs temp
        LDAA    L0023		;IAT temp, A/D counts
        COMA   			;ones comp. 
        LSRA  			;/2  
        JSR     LFB7B		;2D lookup
        PULB    		;Get inj cost off the stack
        MUL   			;(corr. factor x inj. const.)  
        ASLD  			;x2, now /128  
        BCC     LDBF6		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LDBF6   LDAB    LD006		;Opt byte
        BITB    #$0008		;Test b3, do baro fuel corr.
        BNE     LDC0E		;Bra if ==0
;
;-Do baro correction on inj const.
;
        PSHA    		;Inj const ----> stack
        LDX     #LD379		;inj const corr. factor vs. baro
        JSR     LFBD1		;Go get baro and lower limit
        JSR     LFB77		;2D lookup with SBA
        PULB 			;Get inj const. off the stack   
        MUL   			;(factor x inj. const)  
        ASLD  			;x2 now /128  
        BCC     LDC0E		;Bra if no overflow
        LDAA    #$00FF		;clr overflow
;
LDC0E   STAA    L00A9		;Save it, stored injector const.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Check if time to do some more fuel related items
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAA    L0066		;RTS timer
        BITA    #$0004		;test b2
        BNE     LDC19		;Bra, run next portion of code
;
        JMP     LDCCD		;Go return to vect. handler
;
LDC19   LDAA    L009D		;Transient fuel calc. interval timer for tps/map filter
        BNE     LDC46		;Bra if !=0
;
        LDAA    LD1DD		;0, always run loop 
        STAA    L009D		;Save it, trans. fuel calc interval timer
;
        LDAB    LD1DE		;16	
        LDX     L0045		;%TPS, slow filtered
        LDAA    L0043		;%TPS
        JSR     LFB44		;Go filter it
        STD     L0045		;Save it, slow filtered %TPS
;
        LDAB    LD1E1		;36, SD map filter coeff.
;
        LDAA    L0020		;Cool, inv., A/D counts
        CMPA    LD1DF		;64, 80 dec C
        BCS     LDC3B		;BRa if cool. greater
;
        LDAB    LD1E0		;20, filter coeff., used if cool temp <=80
;
LDC3B   LDX     L002B		;Slow filtered SD map
        LDAA    L0024		;SD MAP
        JSR     LFB44		;Go filter it
        STD     L002B		;Save it, slow filtered SD map
        BRA     LDC49		;Bra
;
LDC46   DEC     L009D		;-1 from transient fuel calc. timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;See if its time to adj. the BLM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDC49   LDAA    L000E		;Status word
        BITA    #$0002		;b1, Learn enable bit
        BEQ     LDCBE		;Bra if ==0, learn not ok
;		
        LDAA    L000D		;Status word
        BITA    #$0008		;Bra if in PE
        BNE     LDCBE		;Bra if ==1, in PE
;
        LDAA    L00A5		;INTegrator
        CMPA    #$0080		;128
        BEQ     LDCBE		;Bra if ==128
;
        LDAB    L00BA		;integrator delay timer
        INCB   			;+1 
        BMI     LDC67		;Bra if >=128
;
        STAB    L00BA		;Save it
        ASLB  			;x2			  
        CMPB    L00B3		;INT timer term
        BCS     LDCC3		;Bra if <
;
LDC67   LDAB    L00B9		;Block learn timer
        INCB  			;+1  
        BEQ     LDC73		;bra 
;
        STAB    L00B9		;Save it
        CMPB    LD1FC		;cmp to 12
        BCS     LDCC3		;Bra if < 
;
LDC73   SUBA    #$0080		;INT - 128
        BCS     LDC84		;Bra if less, will be removing fuel
;
;-INT > 128 here
;
        CMPA    LD206		;3, INT threshold away from 128 to do adj.
        BLS     LDCC3		;Bra if <=
;
        LDAA    L000E		;Status word
        BITA    #$0040		;Test b6, Rich/lean ind. bit
        BNE     LDCC3		;bra if ==1, going richer
;
        BRA     LDC90		;bra 
;
;-INT < 128 here
;
LDC84   NEGA 			;2's comp, make it positive again   
        CMPA    LD206		;3, INT threshold away from 128 to do adj.
        BLS     LDCC3		;Bra if <=
;
        LDAA    L000E		;Status word
        BITA    #$0040		;Test b6, rich/lean ind. bit	
        BEQ     LDCC3		;Bra if ==0, going leaner
;
LDC90   LDX     #L00ED		;BLM cell #0
        LDAB    L00A3		;Curr blm cell #
        ABX   			;add to X for offset
;  
        LDAA    $0000,X		;Load in curr BLM cell number
        LDAB    L000E		;Status word
        BITB    #$0040		;load b6, rich/lean ind. bit.
        BEQ     LDCAD		;Bra if ==0, going leaner
;
;-Step blm down
;
        SUBA    LD207		;curr BLM - BLM movement step 
        BCS     LDCA8		;Bra if underflow
;
        CMPA    LD209		;Lower limit for blm
        BCC     LDCBA		;bra if >=
;
LDCA8   LDAA    LD209		;load in min BLM
        BRA     LDCBA		;Bra to save
;
;-Step BLM up
;
LDCAD   ADDA    LD207		;curr BLM + BLM movement step
        BCS     LDCB7		;bra if overflow
        CMPA    LD208		;maximum limit for blm
        BLS     LDCBA		;Bra if <=
;
LDCB7   LDAA    LD208		;Load in maximum blm
;
LDCBA   STAA    $0000,X		;Save blm at curr blm cell location	
        STAA    L00A4		;Save blm 
;
LDCBE   CLRB    		;Clr B
        STAB    L00BA		;Save as int. delay timer
        STAB    L00B9		;Save as block leart timer
;
;-Here if not adj. BLMs
;
LDCC3   LDAA    L000D		;Status word
        ANDA    #$00F7		;Clr b3, no int reset 
        STAA    L000D		;Save it
;
        LDAA    L001D		;Laod RPM/12.5, filtered
        STAA    L001F		;Save as rpm/12.5, filtered, one delayed
;
;-Common point to return to vect. handler
;
LDCCD   JMP     LE474
;
;~~~~~~~~~~~~~~~~~~
; 
; Second fuel loop
;
;~~~~~~~~~~~~~~~~~~
;
LDCD0   LDAA    L0001		;Status word
        BPL     LDCF7		;Bra if motor off
;
        LDAA    L000E		;Status word
        BMI     LDCE0		;Bra if in closed loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;If O2 fails to continue to cross r/l boundries, exit or bar
;enrty into closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-In open loop here
;
        LDAA    LD20E		;682 mV 
        LDAB    LD20F		;299 mV
        BRA     LDCE6		;
;
;-In closed loop here
;
LDCE0   LDAA    LD20C		;682 mV
        LDAB    LD20D		;299 mV
;
LDCE6   CMPA    L0039		;02, A/D counts
        BCS     LDCEE		;Bra if 02 > upper thresh
;
        CMPB    L0039		;02, A/D counts
        BLS     LDCF7		;Bra if 02 >= lower thresh
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;clear exit closed loop timer and ok closed loop
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDCEE   CLR     L009E		;clr exit closed loop timer
        LDAB    L00DE		;Status word
        ORAB    #$0001		;Set b0, ok closed loop
        STAB    L00DE		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Here if not ok'ing closed loop yet
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Calculate gms/sec airflow term
;
;           (128 x Map term)/256 + 15    RPM
;          -------------------------- x -----
;gms/sec =	     256		 12.5
;          ----------------------------------
;			   256
;
LDCF7   LDAA    L002A		;MAP term for grms/sec & BPW calc		
        LDAB    LD241		;128
        MUL     		;A = (128 x MAP term)/256
        ADDA    LD242		;15, offset
        CMPA    LD244		;100, limit 
        BLS     LDD08		;Bra if <=
;
        LDAA    LD244		;Load in limit
;
LDD08   LDAB    L001B		;Load RPM/25
        ASLB   			;x2 
        BCS     LDD12		;bra if iverflow
        CMPB    LD243		;2050 rpm
;
        BLS     LDD15		;bra if <=
;
LDD12   LDAB    LD243		;Load max val.
;
LDD15   MUL			;A x B     
        CMPA    #$0040		;64, limit for term
        BLS     LDD1C		;Bra if <=
;
        LDAA    #$0040		;load in limit, 64 gms/sec
;
LDD1C   STAA    L00BE		;Save it, gms/sec airflow term.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Four pass loop to do lookups by gms/sec airflow
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-1: L0050, lean 02 threshold
;-2: L004F, rich 02 threshold
;-3: L004E, mean rich/lean 02 threshold
;-4: L004D, int delay
;
        LDAB    #$0003		;3, loop four times
LDD20   STAB    L004C		;tmp storage
        LDAA    #$0005		;5, lines per table
        MUL   			;# of lines x loop #
;  
        LDX     #LD399		;Start of tables
        ABX     		;Add B to X, use as addr. offset
        LDAA    L00BE		;load in gms/sec airflow term
        JSR     LFB7B		;2D lookup
        LDX     #L004D		;addr. of tmp storage ram
        LDAB    L004C		;Load
        BEQ     LDD3B		;Bra if ==0, save as int timer
        ABX  			;Add B to X, use as addr. offset   
        STAA    $0000,X		;Store at tmp storage addr.
        DECB 			;-1 from B   
        BRA     LDD20		;Bra, loop till b==0
;
LDD3B   STAA    L00B3		;Int timer
;
;-See which direction the O2 is headed, window is mean r/l O2 val +/- 156 mV
;
        LDAB    L000E		;Status word
        LDAA    L004E		;tmp storage from 3rd pass, mean r/l O2 threshold
        ADDA    LD23F		;+156 mV, upper limit for O2 r/l
        BCS     LDD4A		;Bra if overflow
;
        CMPA    L003A		;O2, minor loop filtered
        BCS     LDD5F		;Bra if filtered 02 is past the upper bounds of the window 
;
LDD4A   LDAA    L004E		;Tmp storage from 3rd pass, mean r/l O2 threshold
        SUBA    LD23F		;-156 mV
        BCS     LDD55		;Bra if underflow
;
        CMPA    L003A		;O2, minor loop filtered
        BHI     LDD5B		;Bra if O2 is past the lower boundry of the window
;
LDD55   LDAA    L003A		;O2
        CMPA    L00BD		;O2, one delayed
        BHI     LDD5F		;Bra if O2 > O2, one delayed richening up
;
;-Leaning out here
;
LDD5B   ANDB    #$00BF		;Clr b6, going leaner
        BRA     LDD61		;bra
;
;-Richening up here
;
LDD5F   ORAB    #$0040		;Set b6, going richer
;
LDD61   CMPB    L000E		;Cmp B to status word
        BEQ     LDD71		;Bra if no change in fueling status
;
;-increment 02 cross counts
;
        INC     L00BB		;cross counts
        LDAA    L0006		;Status word
        ORAA    #$0010		;set b4, switch occured 
        STAA    L0006		;Save it
        CLRA  			;Clr  
        BRA     LDD76		;bra to save a
;
;-No change in fueling status here
;
LDD71   LDAA    L00BF		;Proportioning timer
        INCA   			;+1 
        BEQ     LDD78		;Test for rollover 
;
;-Here when O2 crosses over, do resets
;
LDD76   STAA    L00BF		;Proportioning timer
;
;-Save and check for closed loop
;
LDD78   STAB    L000E		;Status word
        BPL     LDDEE		;Bra if not in closed loop
;
;-In closed loop, check if resets needed
;
        LDAA    L0005		;Status word
        BITA    #$0002		;Test b1, CCP has changed state
        BEQ     LDD88		;Bra if ==0, No change with CCP
;
        ANDA    #$00FD		;Clr b1, CCP has changed state
        STAA    L0005		;Save it
        BRA     LDDEE		;Bra to reset INT, CCP has turned on/off
;
LDD88   LDAA    L000F		;Status word
        BITA    #$0010		;Test b4, in HW mode
        BNE     LDDE8		;bra if==1, reset INT when in HW mode
;
        LDAA    L0007		;status word
        BITA    #$0008		;Test b3, DFCO in effect
        BNE     LDDE8		;bra if ==1, reset INT
;
        LDAB    L000D		;Status word
        BMI     LDDE8		;Bra if in PE, go reset INT
;
;-Reset int if AE is in effect
;
        LDAB    LD006		;Opt word
        BITB    #$0020		;test b5, do reset upon AE
        BEQ     LDDAB		;bra if ==0, dont to reset
;
        LDAB    L000D		;Status word
        BITB    #$0040		;Test b6, do INT reset
        BEQ     LDDAB		;bra if ==0, not resetting
;
;-Go do resets
;
        ANDB    #$00BF		;clr b6, INT reset
        STAB    L000D		;Save it
        BRA     LDDEE		;Bra to do resets
; 
;-Reset INT if decel enlean is in effect
;
LDDAB   LDAB    L000D		;Status word
        BITB    #$0010		;Test b4, decel enlean underway
        BEQ     LDDBD		;Bra if no decel enlean
;
        LDAA    L000E		;Status word
        BITA    #$0040		;Test b6, r/l ind.
        BNE     LDDFE		;Bra if going richer
;
;-Decel enlean underway, if not going rich, do resets
;
        LDAA    L00A5		;INT
        BPL     LDDFE		;Bra if < 128, taking out fuel
;
        BRA     LDDEE		;Bra if >= 128, do resets
;
;-No decel enlean here, continue...
;
LDDBD   LDAB    LD006		;Opt. byte
        BITB    #$0010		;Test b4, reset if changing BLM cells
        BEQ     LDDCA		;Bra if ==0, not resetting when changing cells
;
;-See if blm cell has changed
;
        LDAA    L000D		;Status word	
        BITA    #$0004		;Test b2, changed BLM cell
        BNE     LDDEE		;Bra if ==1, do resets
;
LDDCA   LDAB    L0002		;Status word
        BITB    #$0020		;Test b5, in ALDL mode
        BNE     LDDFE		;BRa if in ALDL mode
;
        LDAB    L0024		;Load SD Map
        CMPB    LD210		;27.5 kP
        BHI     LDDFE		;Bra if >
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Low map present, but no decel enlean.
; Do resets and exit closed loop if not 
; currently adding fuel.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAB    L001B		;RPM/25
        CMPB    LD211		;1000 rpm
        BLS     LDDFE		;bra if <= limit to reset int
;
        LDAA    L000E		;Status word
        BITA    #$0040		;b6, r/l ind. bit
        BNE     LDDFE		;Bra if going richer
;
;-Going leaner here
;
        LDAA    L00A5		;Int 
        BPL     LDDFE		;Bra if <128, adding fuel
;
;-Going leaner with INT >= 128
;
LDDE8   LDAA    L000A		;Status word
        ORAA    #$0004		;set b2, exit closed loop
        STAA    L000A		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Common point to reset slow O2, INT and timers
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDDEE   LDAA    #$0066		;102, 442 mV
        STAA    L003E		;Slow O2, filtered by airflow
;
        LDAA    #$0080		;128
        STAA    L00A5		;INT
;
        CLRA    		;Clr
        STAA    L00B2		;INT delay timer
        STAA    L00BC		;Gain term
        JMP     LDEF0		;skip, resets already performed
;
;~~~~~~~~~~~~~~~~~~~
;Calculate 02 error
;~~~~~~~~~~~~~~~~~~~
;
LDDFE   LDAB    L0007		;Status word
        LDAA    L003E		;Slow 02, filtered by airflow
        CMPA    L004F		;Rich 02 thresh
        BHI     LDE12		;Bra if 02 volts greater then thresh for rich O2
;
        SUBA    L0050		;O2 - Lean 02 threshold
        BCS     LDE0D		;Bra if O2 is less then lean O2 threshold
;
;-Inside of R/L window, go save to HU RAM and continue
;
        CLRA 			;Clr    
        BRA     LDE2E		;Bra to save to HU
;
;-O2 is less then lean O2 threshold
;
LDE0D   NEGA   			;2's comp, change sign
        ANDB    #$00FD		;Clr b1 in L0007, O2 is less then lean threshold
        BRA     LDE1C		;Bra
;
;-O2 is greater then rich O2 threshold
;
LDE12   SUBA    L004F		;Subtract rich O2 thresh from O2
        LDAB    LD249		;232, x by .9 for O2 being rich
        MUL   			;(02 err x 232)/256  
;
        LDAB    L0007		;Status word
        ORAB    #$0002		;set b1, O2 is greater then rich threshold
;
LDE1C   STAB    L0007		;Save status word
        STAA    L004E		;tmp storage, O2 error
;
        LDAB    L0002		;Status word
        BPL     LDE28		;Bra if b7==0, NOT idling, non-ALDL mode
;
;-Addl correction for idle to aid in smooth engine operation
;
        LDAB    LD24A		;224, mult. err by .875 if in idle
        MUL     		;(02 err x 224)/256
;
;-Both in idle and run
;
LDE28   CMPA    #0096		;Max err val. allowed
        BLS     LDE2E		;Bra if error term is <=
        LDAA    #0096		;load in max val.
;
LDE2E   STAA    L0453		;HU RAM	
        ASLA  			;x2  
        STAA    L004E		;Save to tmp storage, err term x2
;
	LDX     #LD3B2		;Prop. gain term vs O2 err.
        JSR     LFB7B		;2D lookup
        STAA    L00BC		;Gain term
        LDAB    L0002		;Status word
        BPL     LDE49		;Bra if not idling
;
;-Idling here
;
        LDAA    LD246		;8, 34.6 mV offset 
        PSHA    		;O2 bias term ----> stack
        LDAA    LD247		;1, airflow factor
        BRA     LDE5A		;
;
;-Not idling here
;
LDE49   LDAA    L004E		;02 err term x2
        LDX     #LD3BF		;O2 bias term table addr.
        JSR     LFB7B		;2D lookup
        PSHA    		;O2 bias term ---->stack
        LDAA    L00BE		;Airflow, gms/sec
        LDX     #LD3D1		;Airflow factor
        JSR     LFB7B		;2D lookup
;
;-Both idle and run here
;
LDE5A   LDAB    L00BC		;Load in proportional gain term
        MUL     		;(airflow factor x gain)/256
        ADCA    #$0000		;Round if needed
        STAA    L00BC		;Save it, prop. gain
;
        LDAA    L00BE		;Aiflow, gms/sec
        LDX     #LD3CC		;Flow factor vs. airflow
        JSR     LFB7B		;2D lookup
;
        PULB 			;Get O2 bias term   
        ABA     		;Add it in
        BCC     LDE6F		;Bra if no overflow
;
        LDAA    #$00FF		;255, clr overflow
;
LDE6F   STAA    L0050		;Tmp storage, proportional gain
;
        LDAA    L004E		;O2 err term x2
        LDX     #LD3D6		;INT delay timer adj. vs 02 err
        JSR     LFB7B		;2D lookup
        LDAB    L00B3		;INT delay timer
        MUL    			;(Factor x INT delay timer)/256 
;
        LDAB    L0002		;Status word
        BPL     LDE87		;Bra if not idling
;
;-Idling here
;
        ADDA    LD248		;12, Add to INT delay timer
        BCC     LDE87		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
;-Idle/run here
;
LDE87   STAA    L00B3		;Save it, INT delay timer term
        STAA    L0454		;Save to HU ram
;
        LDAA    L0007		;Status word
        ANDA    #$0002		;clr all but b1, slow O2 above/below O2 rich/lean thresh
        LDAB    L000E		;Status word
        ANDB    #$0040		;clr all but r/l ind flag
        ABA   			;Add L000E to L0007  
        BEQ     LDEA4		;Bra if result ==0, overall fueling is lean
;
        CMPA    #$0042		;100 0010 
        BEQ     LDEA4		;Bra if ==, overall fueling is rich 
;
;-Fueling isnt overly lean or rich, decay out proportional gain term
;
        LDAA    L00BC		;Prop gain term
        BEQ     LDEAB		;Bra if ==0
;
        DEC     L00BC		;-1
        BRA     LDEAB		;bra
;
LDEA4   LDAA    L004E		;02 err x2	
        CMPA    LD240		;0
        BHI     LDEB9		;Bra if O2 err term >0
;
LDEAB   CLR     L00B2		;Clr INT delay timer term
        LDAA    L00BF		;proportioning timer
        CMPA    L0050		;Timer term
        BLS     LDEDF		;Bra if <=, skip INT
;
        CLR     L00BC		;Clear Prop gain timer
        BRA     LDEDF		;bra
;
LDEB9   LDAA    L00B2		;INT delay timer term
        CMPA    L00B3		;INT delay timer
        BCS     LDEC2		;Bra if int delay timer is >
;
        CLRA   			;Clr timer 
        BRA     LDEC3		;Bra to save and move INT
;
LDEC2   INCA    		;+1
;
LDEC3   STAA    L00B2		;Save INT delay timer
        BNE     LDEDF		;Bra if not cleared
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Time to move the integrator
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Move the integrator up here
;
        LDAA    L00A5		;INT
        LDAB    L0007		;Status word
        BITB    #$0002		;Test b1, slow O2 above rich O2 threshold
        BNE     LDED7		;Bra if ==1
;
;-Move the integrator up here
;
        CMPA    LD213		;158, max int.
        BEQ     LDEDD		;Bra if ==
;
        INCA  			;+1  
        BRA     LDEDD		;Bra to save
;
;-Move the integrator down here
;
LDED7   CMPA    LD212		;40, min int.
        BEQ     LDEDD		;Bra if ==0
        DECA    		;-1
;
LDEDD   STAA    L00A5		;Save the integrator
;
;-Here to skip integrator adjustment
;
LDEDF   LDAA    L00BC		;proportional gain
        LDAB    L000E		;Status word
        BITB    #$0040		;Test b6, r/l ind
        BEQ     LDEF0		;Bra if going leaner
;
;-Going richer here
;
        LDAA    L00A5		;INT
        SUBA    L00BC		;proportional gain
        BCC     LDEF6		;Bra if no underflow
;
        CLRA    		;Clr underflow
        BRA     LDEF6		;Bra
;
;-Going leaner here
;
LDEF0   ADDA    L00A5		;INT
        BCC     LDEF6		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LDEF6   SUBA    #$0080		;128, neutral INT
        STAA    L00B4		;Int proportioning term for BPW
;
;-Do fuel pump volt low test
;
        LDAA    LD40B		;Diag mask
        BITA    #$0002		;Test b1
        BEQ     LDF3D		;bra if ==0
;
        LDAA    L0000		;Status word
        LDAB    L0009		;Status word
        BITA    #$0010		;Test b4 in L0000, engine shutdown in effect
        BEQ     LDF0D		;Bra if ==0, shutdown not in effect
;
        ANDB    #$00FD		;clr b1, fuel pump volts low bit
        BRA     LDF3B		;Bra
;
LDF0D   BITB    #$0004		;Test b2 in L0009
        BNE     LDF3D		;Bra if ==1, do not perform fuel pump volts low test
;
        LDAA    L0881		;Load in MCU1 I/O
        BITA    #$0020		;Test if motor is cranking
        BEQ     LDF39		;Bra if not in crank
;
        LDAA    L0001		;status word
        BMI     LDF3D		;Bra if motor is running
;
        LDAB    L0099		;Delay timer for fuel pump test
        INCB    		;+1
        CMPB    LD464		;30, 3/4 of a second
        BLS     LDF3E		;Bra if still less
;
        LDAA    L0041		;Fuel pump volts x10
        LDAB    L0009		;Status word
        CMPA    #$0028		;2.8 volts
        BCC     LDF39		;Bra if volts are >=
;
        LDAA    L00E3		;Malf flag 3
        ORAA    #$0002		;Set b1
        STAA    L00E3		;Save it
;
        JSR     LFD2C		;Do checksum on malf. flags
        STAA    L00EA		;Save, err flag on checksum
        ORAB    #$0002		;Fuel pump volts low
;
LDF39   ORAB    #$0004		;Set b4 in L0009, fuel pump volts test already performed
;
LDF3B   STAB    L0009		;Save it
;
LDF3D   CLRB  			;Clr timer  
;
LDF3E   STAB    L0099		;Save timer
        JMP     LDCCD		;Jump to return to vect. handler
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Some 80 Hz stuff
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDF43   LDAB    L0801		;MCU2
        LDAA    LD007		;Opt. word
        BITA    #$0004		;Test b2, state for PSPS closed
        BEQ     LDF4F		;bra if 0=on

        EORB    #$0040		;Flip P/S request bit from MCU2 read
;
LDF4F   LDAA    L0010		;Status word
	ANDA    #$00E3		;1110 0011, clear switch states
;
        BITB    #$0040		;Test b6 P/S request
        BNE     LDF59		;Bra if open
;
        ORAA    #$0004		;Set b2, PSPS closed

LDF59   BITB    #$0010		;Test b4, P/N switch
	BEQ     LDF5F		;Bra if open
;
        ORAA    #$0010		;Set b4, P/N switch closed
;
LDF5F   TSTB 			;Test b7, A/C request   
        BMI     LDF64		;bra if ==1, no A/C at this time
;
        ORAA    #$0008		;Set b3, A/C requested
;
LDF64   STAA    L0010		;Store it
;
        LDAB    L0002		;Status word
        BITB    #$0020		;Test b5, in ALDL mode?
        BEQ     LDF81		;bra if ==0
;
        LDAB    L001B		;Load RPM/25
        CMPB    LD4F5		;1500 rpm
        BLS     LDF81		;Bra if RPM is <=1500	
;
        LDAB    L00E0		;Status word	
        BITB    #$0008		;test b3 
        BNE     LDF81		;Bra if ==1
;
        ORAB    #$0008		;Set b3
        STAB    L00E0		;Store it
        ANDA    #$00FE		;Clr b0	
        BRA     LDF8F		;
;
LDF81   BITA    #$0001		;Test b0 of L0010
        BNE     LDFA4		;Bra to do some IAC stuff
;
        BITA    #$0002		;b1 of L0010
        BNE     LDF9B		;Bra if ==1
;
        LDAB    L0000		;Status word
        BITB    #$0020		;b5
        BEQ     LDFA4		;Go set some IAC stuff
;
;-Addr. pointed to by vector table
;
LDF8F   ORAA    #$0002		;Set b1
        STAA    L0010		;Store it
;
        LDAB    LD4EF		;200, IAC retract steps
        STAB    L00FD		;Store it, current IAC pos
;
        CLRB 			;   
        STAB    L00CB		;IAC steps, used in IAC output
;
LDF9B   LDAB    L00FD		;Load curr IAC pos.
        BEQ     LDFA0		;bra if ==0, set some IAC stuff
        RTS  			;Return   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Set some IAC params upon initial startup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LDFA0   ORAA    #$0001		;Set b0
        STAA    L0010		;Save it, status word
;
LDFA4   LDAB    L0000		;Status word
        BITB    #$0010		;b4, engine shutdown in eff.
        BNE     LDFAE		;Bra if ==1
;
        LDAB    L0001		;Status word
        BMI     LDFBC		;Engine running, bra
;
;-Here if shutdown/not running
;
LDFAE   LDAB    LD4E4		;IAC park pos
        LDAA    L0014		;Err flag 3
        BITA    #$0010		;Test b4, PROM err.
        BNE     LDFB9		;bra if ==1
;
        STAB    L00CB		;IAC steps, used in IAC output
LDFB9   JMP     LE166		;Jump to check HU and return
;
;-Engine on here
;
LDFBC   LDAA    L0001		;Status word
        BITA    #$0020		;b5, IAC baro steps added
        BNE     LDFDA		;Bra if ==1
;
;-Do baro compensation of IAC park position after engine first on
;
        ORAA    #$0020		;Set b5, baro steps added
        STAA    L0001		;Store it
;
        JSR     LFBD1		;Go get baro + lower lim  for lookup
        LDX     #LD525		;IAC steps vs baro
        JSR     LFB77		;2D lookup with SBA
;
        STAA    L00E4		;IAC pos, IAC vs. baro, idle control
        ADDA    LD4E3		;Add into IAC park pos.	
        BCC     LDFD8		;bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LDFD8   STAA    L00C2		;Store it, lag filtered IAC steps

LDFDA   LDAB    L0007		;Status word
        BITB    #$0008		;b3, DFCO flag
        BEQ     LDFEB		;Bra if ==0
;
        BSR     LE023		;Set b6 of L0010 and clr B
        LDAA    LD4F2		;16, min DFCO steps
        CMPA    L00C3		;IAC steps, filtered	
        BCS     LDFEB		;Bra if IAC steps > min dfco steps
;
        STD     L00C3		;Save min DFCO steps as IAC steps
;
LDFEB   LDAA    L0010		;Status word
        BITA    #$0004		;Test b2
        BEQ     LDFFC		;Bra if ==0
;
        BSR     LE023		;Bra to set b6 in L0010 and clr B
;
;-Check if stall saver needed
;
        LDAA    LD4F3		;9, min stall saver steps
        CMPA    L00C5		;Stall saver steps
        BCS     LDFFC		;Bra if >
;
        STD     L00C5		;Stall saver steps
;
LDFFC   LDAB    LD4E6		;625, stall saver exit rpms
        LDAA    L0010		;Status word
        BMI     LE006		;Bra if b7 ==1, stall saver in effect
;
        LDAB    LD4E5		;550, stall saver init rpms	
LE006   CMPB    L001D		;rpms/12.5, filtered
        BCS     LE02B		;Bra if rpms >, bypass/exit stall saver
;
        ORAA    #$0080		;Set b7, stall saver in effect
        ANDA    #$00BF		;clr b6, steps to be added in unfiltered
        STAA    L0010		;Save status word
;
        JSR     LFBD1		;Go get baro and lower lim for lookup
        LDX     #LD529		;Stall saver steps vs. baro
        JSR     LFB77		;2D lookup with SBA
        LDAB    L00C5		;Stall saver steps, MSB
        CBA  			;Compare stored stall saver steps to steps from lookup  
        BCS     LE034		;Bra if stall saver steps are >
;
        CLRB    		;
        STD     L00C5		;Save stall saver steps vs baro from lookup instead
        BRA     LE034		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>subroutine, set b6 of L0010 to 1 and clear B
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE023   LDAB    L0010		;Status word
        ORAB    #$0040		;Decay out IAC steps
        STAB    L0010		;Store it
        CLRB  			;Clr B  
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Here to enter/exit stall saver
;
LE02B   TSTA   			;Test b7, stall saver in effect
        BPL     LE034		;Bra if stall saver wasnt in effect
;
        ANDA    #$007F		;Clr stall saver in effect bit
        ORAA    #$0040		;Set b6,
        STAA    L0010		;Save status word
;
;-Do throttle follower (T/F)
;
LE034   LDAB    LD510		;64, throttle follower, not in P/N
        LDAA    L0010		;Status word
        BITA    #$0010		;Test b4
        BEQ     LE040		;Bra if in drive
;
        LDAB    LD50F		;Throttle follower factor, in P/N
;
LE040   LDAA    L0043		;%TPS
        SUBA    LD50E		;Min tps for throttle follower
        BCC     LE048		;Bra if no underflow
;
        CLRA   			;Clr delta %TPS
; 
;            (Delta %TPS x throttle follower factor)
;T/F steps = ---------------------------------------
;			       32
;
LE048   MUL     		;(Delta %TPS x throttle follower factor)
        ASLD   			;x2 
        BCS     LE052		;Bra if overflow
;
        ASLD  			;x2  
        BCS     LE052		;
;
        ASLD   			;x2 
        BCC     LE054		;Bra if carry clear
;
LE052   LDAA    #$00FF		;Clr overflow
;
LE054   STAA    L00C9		;Save it T/F steps
        SUBA    L00C7		;Subtract out filtered throttle follower steps
        BLS     LE06C		;Bra if result <= 0
        CMPA    LD511		;2, max rate for increasing throttle follower steps
        BLS     LE06C		;Bra if less
;
        LDAA    LD505		;Max T/F steps
        CMPA    L00C9		;Stored T/F steps
        BLS     LE068		;Bra if T/F steps are >=
;
        LDAA    L00C9		;Load throttle follower steps in
;
LE068   BSR     LE023		;Set b6 in L0010 and clr B
        STD     L00C7		;Save it, filtered throttle follower steps
;
;-Lookup IAC steps vs coolant and see if kickdown ok
;
LE06C   LDX     #LD514		;IAC steps vs coolant
        LDAA    L0020		;Coolant, Inv, A/D counts
        COMA   			;Ones comp. 
        JSR     LFB7B		;2D lookup
        LDAB    L00DF		;Status word	
        BITB    #$0010		;Test b4, IAC kickdown ok
        BNE     LE09E		;Bra if IAC kickdown ok'd
;
;-Check for hot restart
;
        ANDB    #$0004		;Clr all but b2, B == 4 secs. on hot restart
        BEQ     LE082		;bra if ==0, no hot restart in effect
;
;-If in cool start, set kickdown delay to two secs
;
        LDAB    LD21F		;2 secs for cool start for kickdown delay
;
LE082   ADDB    LD4F9		;1, add one second in to delay
        CMPB    L0055		;IAC kickdown timer
        BCC     LE0A4		;Bra
;
        LDAB    L00DF		;Load status word
        ORAB    #$0010		;Set b4, iac kickdown occured
        ANDB    #$00FB		;Clr b3
        STAB    L00DF		;Save status word
;
        LDAB    LD4FA		;65, kickdown steps
        CMPB    L00C3		;IAC steps
        BCS     LE09E		;Bra if IAC steps are greater 
;
        STAB    L00C3		;Save kickdown steps, IAC steps
        BSR     LE023		;Set b6 in L0010 and clr B
        STAB    L00C4		;
;
;-Kickdown complete here
;
LE09E   SUBA    LD4FA		;Subtract kickdown steps 
        BCC     LE0A4		;Bra bra if no underflow
;
        CLRA  			;Clr underflow
;  
;-Check if A/C on compensation is necessary
;
LE0A4   STAA    L00CF		;Save steps from coolant lookup
        LDAB    L0003		;Status word
        LDAA    L0010		;Status word
        BITA    #$0008		;Test b3, A/C req.
        BNE     LE0B5		;Bra if A/C req.
;
        CLRA    		;Clr 
        ANDB    #$00FB		;clr b2 of L0003, no longer compensating for A/C compressor
        STAB    L0003		;Save status word
        BRA     LE0C8		;Bra
;
LE0B5   BITB    #$0004		;Test b2 of L0003, A/C compressor drag compensation
        BNE     LE0CA		;Bra if already compensating
;
        ORAB    #$0004		;Set b2, A/C compressor drag compensation in effect
        STAB    L0003		;Save status word
        LDAA    L00CF		;IAC steps added in from coolant lookup
        BNE     LE0CA		;Bra if still adding in steps
;
        LDAB    L0002		;Status word
        BPL     LE0CA		;Bra if b7==0, not idling
;
        LDAA    LD4FB		;2, IAC steps added in for A/C on
;
LE0C8   STAA    L00CC		;A/C on IAC steps
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Check engine speed and set status bit accordingly
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Check if stall saver active
;
LE0CA   LDAA    L00D0		;Target idle speed
        LDAB    L0010		;Status word
        BPL     LE0DA		;Bra if ==0, stall saver not in effect
;
;-Stall saver in effect here
;
        LDAA    LD4E6		;625, stall saver exit rpms	
        ADDA    LD4EE		;+1, 12.5 rpm, margin for no idle adj.
        BCC     LE0DA		;Bra if no overflow
;
        LDAA    #$00FF		;clr overflow
;
LE0DA   CMPA    L001D		;Compare target idle speed to RPM/12.5, filtered
        BHI     LE0E2		;Bra if idle speed is lower
;
;-engine speed higher here
;
        ANDB    #$00DF		;Clr b5 in L0010
        BRA     LE0E4		;bra
;
;-engine speed is lower or same here
;
LE0E2   ORAB    #$0020		;Set b5 in L0010
;
;-Check to make sure IAC steps are > then the steps specified by baro lookup
;
LE0E4   LDAA    L00E4		;IAC pos, IAC vs. baro, idle control
        STAB    L0010		;Save status word
        BITB    #$0008		;Test b3, A/C req
        BEQ     LE0F4		;Bra if no A/C
;
        CMPA    L00C2		;Compare IAC vs. baro pos. to lag filtered IAC steps
        BLS     LE0F2		;Bra if IAC steps are greater
;
;-Add up all the IAC steps...
;
        STAA    L00C2		;Save IAC pos., IAC vs. baro as current IAC steps
;
LE0F2   LDAA    L00C2		;Load IAC steps, filtered
LE0F4   ADDA    L00CF		;IAC steps vs. cool temp
        BCS     LE122		;Bra if overflow
;
        ADDA    L00C3		;IAC steps, filtered
        BCS     LE122		;
;
        ADDA    L00C5		;Stall saver steps vs. baro
        BCS     LE122		;
;
        STAA    L0049		;IAC steps ----> tmp storage
;
;-Check if T/F steps to be decayed out completly?
;
        LDAB    LD50D		;4, min steps for throttle follower above a certain MPH thresh
        CMPB    L00C7		;Throttle follower steps, filtered
        BCC     LE114		;Bra if filtered throttle follower steps are less
;
        ABA    			;Add in min T/F steps to IAC steps 
        BCS     LE122		;Bra if overflow
;
;-Check to make sure IAC steps are not less then T/F steps
;
        CMPA    L00C7		;Compare to T/F steps, filtered
        BCC     LE11A		;Bra if IAC steps >= T/F steps
;
;-Use T/F steps
;
        LDAA    L00C7		;T/F steps, filtered
        BRA     LE124		;Bra
 ;
LE114   LDAA    L00C7		;Throttle follower steps, filtered
        ADDA    L0049		;Add in accumulated IAC steps thus far
        BCS     LE122		;bra if overflow
;
LE11A   ADDA    L00CE		;Add in IAC trim (+)
        BCS     LE122		;
;
        ADDA    L00CC		;A/C on added IAC steps
        BCC     LE124		;Bra if no overflow
;
LE122   LDAA    #$00FF		;Clr overflow
;
LE124   LDAB    L0010		;Status word
        BITB    #$0010		;Test b4, In P/N 
        BEQ     LE130		;Bra if not in P/N
;
;-In park/neutral here
;
        SUBA    LD4FC		;8 steps, sub'd out when not in drive
        BCC     LE130		;Bra if no underflow
;
        CLRA 			;Clr underflow
;   
LE130   STAA    L00CB		;IAC steps, used in IAC output
        LDAB    L0010		;Status word
        BITB    #$0008		;Test b3, A/C req.
        BEQ     LE15C		;Bra if no A/C
;
;-Add in IAC steps vs. baro if A/C is on 
;
        JSR     LFBD1		;Read in baro and get offset
        LDX     #LD52D		;A/C on IAC steps vs. baro
        JSR     LFB77		;2D lookup with SBA
        LDAB    L0020		;Cool temp
        CMPB    LD4F6		;103 deg C
        BCC     LE14D		;Bra if cool temp is less
;
        ADDA    LD4F7		;5, added steps when engine hot
        BCS     LE15A		;Bra if overflow
;
LE14D   ADDA    L00CB		;IAC steps, used in IAC output
        BCS     LE15A		;bra if overflow
;
        LDAB    L0002		;Load status word
        BMI     LE15C		;bra if b7==1, idling
;
;-Not idling here
;
        ADDA    LD4F8		;3, IAC steps added in if not idling
        BCC     LE15C		;Bra if no overflow
;
LE15A   LDAA    #$00FF		;Clr overflow
;
LE15C   TAB 			;IAC steps ----> B    
        SUBA    L00CD		;IAC trim (-)
        BCC     LE164		;Bra if no underflow
;
        STAB    L00CD		;save, this many commanded steps under current IAC steps
        CLRA   			;Clr underflow
; 
LE164   STAA    L00CB		;Save, IAC steps, used in IAC output
;
;-HU
;
LE166   LDAA    L0000		;Status word
        BITA    #$0002		;test b1
        BEQ     LE16F		;bra if ==0, no HU
        JSR     L5803		;Go do HU routine
LE16F   RTS  			;Return
;   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Reset/Power on vector
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE170	 LDS     #L00DC		;Load up the stack
         JSR     LFD2B		;RTS, delay  
;
         LDX     #$000A         ;Load X with 0000 0000 0000 1010, init
         STX	 LBC3C		;Pulse width monitor@ LBc3C (PWM)
;
         LDX     #LBC00         ;DRP counter
         CLRA			;    
         CLRB    		;
LE181    STD     $0000,X	;Clear it, and the other counters up to LBC36
         INX  			;+1   
         INX     		;+1, next address
         CPX     #$BC38		;Last counter, ecm
         BNE     LE181		;X != $BC38, repeat
;
 	 LDX     #$0199 	;0000 0001 1001 1001
         STX     LBC0C		;
;
         LDX     #L00D3		;RAM, stored op. params.
LE193    CLR     $0000,X	;Clear it
         DEX			;-1     
         CPX     #$FFFF		;last address -1
         BNE     LE193		;X >= 0, repeat
;
         LDAB    L0880		;MCU1, power lost		
         STAB    L0880		;
         BMI     LE1AA		;b7==1, backup batt voltage lost
;
         JSR     LFD2C		;Do checksum on err. flags
         CMPA    L00EA		;error flag, checksum
         BEQ     LE1C8		;==0, bra, C/S ok
;
;-Batt voltage lost, do additional resets
;
LE1AA   LDX     #L00FF		;End of RAM
LE1AD   CLR     $0000,X		;Clear it, and all ram down to L00DD
	DEX   			;-1  
	CPX     #$00DC		;Addr. of stack
        BNE     LE1AD		;X != $00DC, repeat
;
        LDAA    LD4F0		;IAC start pos.
        STAA    L00E4		;Store @ L00E4, lookup vs baro, idle control
; 
	LDAA    LD4E4		;IAC park pos., steps
        STAA    L00FD		;Store it as curr IAC pos.
;
        JSR     LFE0F		;Go reset all blm cells

        LDAA    L0007		;Status word
        ORAA    #$0040		;0100 0000
        STAA    L0007		;store it

LE1C8   LDAA    L00E4		;IAC pos., start point
        ADDA    LD4E3		;+18
        BCC     LE1D1		;Carry set?
        LDAA    #255		;Clear overflow
LE1D1   STAA    L00C2		;IAC steps, compaired against L00E4
;
	LDAA    L00E0		;Status word
	ANDA    #$00C0		;1100 0000
        STAA    L00E0		;store it
;
        LDX     L5800    	;HU routine
        CPX     #$7E58		;Online?
        BNE     LE1E4		;
        JSR     L5815		;Not online, go do HU

LE1E4   LDX     #LCHKSM_END	;End of prom, and area to be checked
        STX     L004D		;store at temp location
        LDX     #LD004		;Begining of checksum area
        JSR     LE32B		;Go do checksum
        SUBD    LD000		;Subtract out stored checksum
        BNE     LE1FB		;Bra if no match
;
        LDAA    LD004		;Mask ID
        CMPA    #$004D		;'8063 mask ID
        BEQ     LE21F		;Match, continue loadup

LE1FB   LDAA    LD004		;Load Mask ID again
        CMPA    #$00AA		;Development/testing purposes
        BEQ     LE21F		;Match, continue
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Checksum/ID error here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        JSR     LFC47	        ;SES light
;
        LDAA    L0014	        ;error flag 3
        ORAA    #$0010	        ;set b4, checksum error
        STAA    L0014		;store it
;
        LDAA    L00E3		;malf flag 3					
        ORAA    #$0010		;set b4, prom error
        STAA    L00E3		;Store it
;
        JSR     LFD2C		;Do checksum on malf. flags
        STAA    L00EA		;Store checksum 
        LDAA    #$000C		;Load with $0C, ALDL diag channel
        JSR     LFF27		;Clr B, go do A/D rout. w/ wait for data
LE21B   CMPA    #$0099		;Counts, A > = normal mode
        BCC     LE21B		;Loop, wait for reset, try to init again
;
;-Here if in normal operating mode
;
LE21F   LDX     #$F92A		;1111 1001 0010 1010
        STX     LBC3C		;PWM
;
;-init MAP
;
        LDAA    #$0005		;Map channel
        JSR     LFF27		;Go do A/D routine
        STAA    L0027		;raw MAP, MSB
;-A/D data to S/D map conv.
        SUBA    #$001A		;A - #26
	LDAB    #$0097		;#151
        JSR     LFC73		;A = (A x B)/128, 
        STAA    L0024		;S/D map, kPa = (X * .3125) + 20
        STAA    L002B		;S/D map, slow filtered
;
;-Init baro, cool., IAT
;
        JSR     LFCC7		;Init baro
        JSR     LFDBC		;Init IAT
        JSR     LFD39		;Init CTS
        STAA    L0021		;startup coolant, A/D counts
;
        LDAB    LD005		;opt. word
        BITB    #$0020		;Test b5, 1 for IAT
        BEQ     LE24B		;Use cool. instead if ==0
        LDAA    L0023		;Load IAT, inv. A/D counts
LE24B   CMPA    LD21E		;72, hot restart threshold
        BCS     LE256		;Bra if temp is greater then thresh.
;
        LDAB    L00DF		;Status word
        ANDB    #$00FB		;Clr b3, cold/cool restart in effect?
        STAB    L00DF		;store it
;
;-Init 02 vals.
;
LE256   LDAA    LD1D7		;599 mV, default loadup value		
        STAA    L003A		;02, minor loop filtered
        STAA    L0039		;02, A/D, filtered, round up from 3A
        STAA    L003C		;02, RTS filtered
        STAA    L003E		;02, filtered vs. airflow
;
;-Init TPS
;
        LDAA    #$000B		;TPS channel
        JSR     LFF27		;Go read in TPS
        STAA    L0042		;TPS, volts = X * .0195	
		
        LDAA    LD1D4		;54, tps counts
        STAA    L0047		;Store as min tps
        JSR     LFCEC		;Go do TPS work
        STAA    L0044		;%TPS, one delayed
        STAA    L0045		;%TPS, slow filtered, MSB
;
        JSR     LFF25		;Go read in Batt. volts
        STAA    L0040		;Batt volts x 10, A/D counts
;
        LDD     LBC06		;EST curcuit
        STD     L0096		;Store EST curcuit data
;
        LDAA    L00FD		;Current IAC pos.
        STAA    L00CB		;IAC steps, used in IAC output
;
        LDAA    L00DE		;Status word
        BITA    #$0004		;
        BNE     LE28E		;Status word
 ;
        LDAB    L0009		;Status word
        ORAB    #$0004		;Do not perform fuel pump volts test
        STAB    L0009		;Status word

LE28E   LDX     LBC04		;MAF/VATS freq.
        ANDA    #$00FB		;b2, no fuel pump volts test
        STAA    L00DE		;Save it
;
        LDAA    LD1EC		;147, 14.7 AFR
        STAA    L00A6		;Desired AFR		
        STAA    L00B7		;Crank AFR
        STX     LBC1A		;VATS
;
        LDAA    #$000E		;14
        STAA    L0066		;Real time subroutine counter
;
        LDAA    #$0080		;128
        STAA    L0067		;$80, bit for ADC hardware
        STAA    L00A4		;BLM, binary value

        LDAA    #0020		;20 bytes, ALDL data
        STAA    L0072		;Store it
;
        LDAA    #0160		;VSS interval counter
        STAA    L0032		;Store it
; 
        LDAA    LD005		;Opt. word
        BITA    #$0040		;b6, Clamp blms
        BEQ     LE2DC		;Bra to skip routine
;
        LDAA    L00DF		;Status word
        BITA    #$0004		;Hot restart in effect?
        BEQ     LE2C3		;Bra if no hot restart?
;
        JSR     LFE0F		;Reset all blm cells
        BRA     LE2DC		;bra around BLM routine
;
;-Routine to clamp BLM cells on reset
;
LE2C3   LDX     #L00ED		;BLM cells
LE2C6   LDAA    $0000,X		;Load in BLM cell
        LDAB    LD20A		;128, upper limit
        CBA			;BLM-limit    
        BHI     LE2D4		;Bra if upper lim is < then stored BLM, save 
;
        LDAB    LD20B		;128, lower limit
        CBA 			;BLM - lower limit    
        BCC     LE2D6		;Bra if lower limit <= BLM, dont save
;
LE2D4   STAB    $0000,X		;Clamp BLM cell
LE2D6   INX  			;Adv. to next cell   
        CPX     #$00FC		;last cell to check
        BLS     LE2C6		;Bra if less, not done yet
;
;~~~~~~~~~~~~~~~~~~~~~
;>
;>Factory diags.
;>
;~~~~~~~~~~~~~~~~~~~~~
;
LE2DC   JSR     LFF2C		;Get ALDL channel
        BCC     LE325		;Skip if ALDL shorted
;
        CLRA 			;read in channel $00   
        JSR     LFF27		;A/D routine
        CMPA    #0160		;160, A/D counts	
        BLS     LE325		;Exit if less
        JSR     LFF25		;Read batt volts channel
;
        CMPA    #0100		;10 volts
        BCC     LE325		;bra if >10 volts, exit
;
        LDAA    L0006		;Status word		
        ORAA    #$0001		;b1, do factory diags.
        STAA    L0006		;store it
;
        LDAA    #0204		;204
        STAA    L0021		;startup coolant, A/D counts
        STAA    L0023		;IAT, inv. A/D counts
;
        LDX     #L00DC		;Stack addr.	
        TXS 			;get stack pointer into X    
        LDAA    #$00AA		;Fill stack with $AA
LE302   INX 			;adv. to next addr.    
        STAA    $0000,X		;Store A at addr.
        CPX     #$00FF		;Last address to fill
        BCS     LE302		;Bra if X is still less
;
        LDX     #LCHKSM_END	;End of checksum area +1
        STX     L004D		;tmp storage
        LDX     #LD000		;start of prom
        BSR     LE32B		;Go do checksum
        STD     L0016		;Store checksum val.
;
        LDAA    #$00F0		;Ram addr.		
        STAA    L004D		;tmp storage
        BSR     LE32B		;checksum routine
        STD     L0012		;err flag 1
        CLR     L004D		;clr tmp storage
        BSR     LE32B		;checksum routine
        STD     L0014		;err flag 3
LE325   LDX     LBC38		;ECM
        JMP     LE49E		;Go wait for interrupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Checksum routine
;>
;>In:  X = start of checksum area, $4D = end of checksum area
;>Out: AB = checksum
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE32B   CLRA    
        CLRB    
        STX     L0049		;Start of checksum area
;
LE32F   INC     L004A		;COP timer
        BPL     LE345		;Continue with checksum
        CLR     L004A		;clear timer
        PSHA			;A ----> stack    
        PSHB    		;B ----> stack
        LDD     LBC3C		;PWM
        EORB    #$0004		;COP, flip b2
        BSR     LE34E		;RTS, delay
        STD     LBC3C		;Store PWM
;        
	PULB 			;stack ----> B   
        PULA			;stack ----> A    
LE345   ADDB    $0000,X		;Add mem location into B
        ADCA    #$0000		;Add carry from B to A
        INX			;+1     
        CPX     L004D		;Area to be checked +1
        BNE     LE32F		;Bra if not to end of area +1
;
LE34E   RTS   			;Finished, return. AB = checksum  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Vector handler
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE34F   LDD     LBC38		;ECM
        BITA    #$0010		;Test b12, high speed RTS counter
        BNE     LE357		;go run a loop if ==1
;
LE356   RTI  			;else, return from interrupt 
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE357   TSX 			;Get stack pointer into X    
        CPX     #$00D6		;Midpoint of stack
        BEQ     LE363		;bra if ==0
;
        LDAB    L0000		;Status word
        ORAB    #$0001		;Flag stack err.
        STAB    L0000		;store it
;
LE363   LDS     #$00DC		;Load the stack @$DC
        LDAB    L0002		;Status word
        BITA    #$0008		;Test b11 of counter 
        BEQ     LE36E		;bra of ==0
;
        ORAB    #$0004		;Set b2 of L0002
;
LE36E   BITA    #$0020		;Test b13 of counter
        BEQ     LE374		;bra if ==0
;
        ORAB    #$0001		;Set b0 of L0002
;
LE374   LDAA    L0000		;Status word
        BITA    #$0010		;b4, engine shutdown
        BEQ     LE37C		;bra if ==0
;
        ANDB    #$00FB		;Clr b3

LE37C   STAB    L0002		;Store it
;
        LDAA    L0006		;Status word
        ASRA 			;shift right   
        BCS     LE389		;bra if carry set, Factory diags. bit set

        LDAA    L0014		;Err flag 3
        BITA    #$0010		;test b4
        BNE     LE393		;Skip ALDL bit toggle
;
;-Toggle ALDL SS bit
;
LE389   LDAA    #$00BF          ;1011 1111 
        JSR     LFC49		;PWM control, entry point to clear bit
        LDAA    #$0040		;0100 0000,
        JSR     LFC54		;PWM control, entry point to set bit
;
LE393   LDX     L00EB		;Engine run time
        LDAA    L0066		;rts counter
        INCA			;advance counter    
        CMPA    #$00A0		;160, one second
        BNE     LE3B8		;Bra if != 160
;
;-One second has passed
;
        LDAB    L0006		;Load status word
        EORB    #$0020		;Flip b5
        STAB    L0006		;Store it
;
        LDAB    L0001		;Status word
        BMI     LE3B1		;Bra if engine is running
;
        CLR     L0055		;Clr L0055, IAC kickdown timer
        LDAA    L00DF		;Load status word
        ANDA    #$00EF		;clr bit b4, IAC kickdown occured
        STAA    L00DF		;Store it
        BRA     LE3B7		;Bra to clear rts timer
;
LE3B1   INC     L0055		;Increment IAC kickdown timer
        INX			;+1     
        STX     L00EB		;Increment engine run time
LE3B7   CLRA    		;
;
;-common point to save rts timer
;
LE3B8   STAA    L0066		;clr rts timer
;
        ANDA    #$001F		;31
        BNE     LE3C7		;bra if != 31
;
        LDAB    L0000		;status word
        BITB    #$0002		;test b1, HU online?
        BEQ     LE3C7		;bra if ==0, no HU
;
        JSR     L580F		;Go do HU routine
;
LE3C7   LDAA    L0006		;Status word		
        ASRA			;Test b0    
        BCC     LE3CF		;bra if ==0, skip factory diags.
;
        JMP     LFE92		;Go do factory diags.
;
LE3CF   LDD     #$0501		;A=$05, B=$01, MAP, with return imm.
        JSR     LFC21		;A/D routine
        JSR     LEBD3		;Check batt volts check and IAC handling
;
        LDAA    L0002		;Status word
        ASRA			;test b0    
        BCC     LE3E2		;bra if ==0, No VSS err.
        ASLA 			;shift back to the left 
        STAA    L0002		;Store it
        BRA     LE3F5
;
LE3E2   LDAB    L0032		;VSS interval counter
        INCB   			;+1 
        CMPB    #0159		;159 / 160
        BLS     LE3F1		;bra if <=, go store it
;
        LDAB    L0001		;Status word
        ANDB    #$00EF		;Clr b4, VSS detects movement
        STAB    L0001		;Store it
;
        LDAB    #0159		;159 / 160
LE3F1   STAB    L0032		;VSS interval counter
        BRA     LE418
;
;~~~~~~~~~~~~~~~~~~~~~~
;-VSS 
;~~~~~~~~~~~~~~~~~~~~~~
;
LE3F5   LDAB    L0001		;Status word
        BITB    #$0010		;b4, vss detects movement
        BNE     LE408		;bra if ==1
;
        ORAB    #$0010		;set b4 
        STAB    L0001		;Store it
;
        LDX     LBC02		;VSS counter
        INX   			;VSS + 1  
        STX     L0037		;Store val @ L0037, L0038
;
        INX  			;VSS + 1   
        STX     L0035		;Store val @ L0035, L0036 
;
;-Shuffle the VSS vals. around
; LBC02 -> L0037,38 -> L0035,36 -> L0033,34
;
LE408   CLR     L0032		;Clr VSS inerval counter
;
        LDX     L0035		;L0035, L0036
        STX     L0033		;L0033, L0034
;
        LDX     L0037		;L0037, L0038
        STX     L0035		;L0035, L0036

        LDX     LBC02		;VSS counter
        STX     L0037		;L0037, L0038
;
;~~~~~~~~~~~~~~~~~~~~
;-VATS
;~~~~~~~~~~~~~~~~~~~~
;
LE418   LDAA    L00DF		;Status word
        BITA    #$0040		;b6, vats checked ok
        BNE     LE446		;Bra if ==1, already checked VATS
;
        LDX     LBC04		;MAF/VATS freq
;
        LDAB    LD007		;Option byte
        BITB    #$0040		;b6 = VATS option bit
        BEQ     LE442		;bra if VATS not enabled
;
        PSHX 			;Push vats freq to stack   
        PULA    		;Get MSB of freq into A
        PULB    		;Get LSB of freq into B

        SUBD    LBC1A		;Ref freq for VATS?
        BEQ     LE446		;Bra if ==0, continue, no start!
;
;-remainder ----> stack
;
        PSHB 			;  
        PSHA    		;
;
        LDAA    L00DF
        STX     LBC1A		;Store freq
        PULX 			;Get remainder   
        CPX     LD24F		;65535, upper threshold
        BHI     LE446		;Bra if >, no start!
;
        CPX     LD251		;65535, lower threshold	
        BCS     LE446		;bra if <, no start!
;
;-Within allowable window, engine may start
;
LE442   ORAA    #$0040		;set b6, ok for start
        STAA    L00DF		;Store it
;
LE446   JSR     LFC2E		;Go retrieve map
        STAA    L0029		;Store raw map counts

        LDAB    L0014		;Err flag 3
        BITB    #$0010		;test b4, prom err.
        BEQ     LE459		;bra if ==0
;
        LDAA    L0066		;RTS counter
        ASRA  			;test b0  
        BCS     LE474		;return to rts loop if ==1
        JMP     LEA59		;
;
;-Decide which to go, b0==0 do spark minor loop, b0==1 do fuel minor loop,
; each is run 80 times a second
;
LE459   LDAA    L0066		;Load rts counter
        ASRA 			;Test b0   	
	BCS     LE463		;Bra, go do fuel

        JSR     LDF43		;80 Hz stuff
        BRA     LE4C1		;Go do spark minor loop
;
;-Fuel minor loop lead in.
;
LE463   LDAA    L0881		;MCU1 
        LDAB    L0002		;Status word
        BITB    #$0008		;Test b3
        BNE     LE46E		;Bra if ==0
;
        EORA    #$0008		;Toggle sentry/dist. bypass bit
LE46E   STAA    L0881
        JMP     LD531		;Go do fuel minor loop
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;     *Real time service routine*
;-Run after fuel/spark minor loops
;-Allows 16 loops to run 10 times/sec
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE474   LDAA    L0066		;RTS counter
        ASRA    		;x2
        BCC     LE47E		;Bra if not time to toggle the COP bit
;
        LDAA    #$00FB		;1111 1011
        JSR     LFC49		;PWM routine, entry point to clear bytes
;
;
;
LE47E   LDAB    L0066		;RTS counter	
        ANDB    #$000F		;Clr upper 4 bits
        LDX     #LE4A1		;addr. of first loop
        ASLB 			;x2 for double byte addr.   
        ABX   			;Add in offset to X  
        LDX     $0000,X		;Load in addr of loop	
        JSR     $0000,X		;Go run the loop
;
;-Back from running a loop
;
        LDAA    L0001		;Status word
        BITA    #$0004		;Test b2,
        BNE     LE49E		;Bra if ==1
;
        ORAA    #$0004		;Set b2	
        STAA    L0001		;Save it
;
        LDAB    L0066		;Load rts counter
        STAB    L00DD		;Save it 
        CLI     		;Clr interupt bit
;
        ANDA    #$00FB		;clr b4
        STAA    L0001		;save status word
;
LE49E   CLI  			;Clr interupt bit   
        BRA     LE49E		;Wait for next interupt
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Real time service routine table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;				;RTS #
;	
LE4A1   FDB     LEA7A 		; 1  
        FDB     LEB39           ; 2 		           
        FDB     LEB40           ; 3 	 
        FDB     LEB65           ; 4  
        FDB     LEC6E           ; 5           
        FDB     LEE25           ; 6           
        FDB     LFE1D           ; 7
        FDB     LF2A6           ; 8
        FDB     LF4C8           ; 9
        FDB     LF1D5 		;10
        FDB     LFE27 		;11
        FDB     LEFFD 		;12	
        FDB     LFE3E		;13
        FDB     LF534 		;14
        FDB     LFE43		;15
        FDB     LEC83           ;16   	          

;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Spark minor loop
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE4C1   JSR     LFA94	 	;Do default map if errs. 
        LDAB    #0151		;
;
;-Get vacuum from baro and map
;
        LDAA    L00FE		;Baro pressure, A/D counts
        SUBA    L0027		;Raw map, A/D counts, subtract from baro press.
        BHI     LE4CF		;bra if >0
;
        LDAA    #$0001		;
        CLC			;Clr carry  
;   
LE4CF   JSR     LFC6F		;(A x B)/128
        NEGA 			;2's comp., now vacuum   
        STAA    L002D		;Vacuum
;
;-Get S/D map
;
        LDAB    #0151		;
        LDAA    L0027		;Raw map, A/D counts
        SUBA    #0026		;Raw map - 26
        JSR     LFC6F		;(A x B)/128
        STAA    L0024		;SDMap = ((A/D map - 26)*151)/128
				;kPa = (SDMap * 0.3125) + 20
;
        LDAB    L0008		;Status word
        ANDB    #$007F		;0111 1111, clr b7
        BITB    #$0004		;test b2
        BNE     LE509		;Bra if ==1, tps err, do not test
;
;-test map for err 34, low map
;
        LDAA    L0029		;A/D map
        CMPA    LD440		;10, min allow counts
        BCC     LE509		;Bra if map is >=, no err.
;
        LDAA    L008D		;Map err timer
        CMPA    LD442		;2, .025 secs
        BHI     LE50E		;bra if timer is greater, set err.
        LDAA    L001A		;Scaled rpm
        CMPA    LD441		;64, 1200 rpm
        BCS     LE504		;bra if RPMs less
;
        LDAA    L0043		;% tps from idle
        CMPA    LD443		;54
        BLS     LE509		;bra if <=
;
LE504   INC     L008D		;Increment err timer
        BRA     LE516		;Bra to save status word
;
LE509   CLR     L008D		;Clr err timer
        BRA     LE516		;bra to save status word
;
;-test failed, set error
;
LE50E   LDAA    L0013		;Err flag 2
        ORAA    #$0008		;Set b3, map err. low map
        STAA    L0013		;store it
;
        ORAB    #$0080		;Set b7 of L0008, map test failed. low map
;
LE516   STAB    L0008		;Store it
;
        LDAA    L0002		;Status word
        BITA    #$0004		;test b2
        BEQ     LE585		;Bra if ==0
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Do decay of dwell calc
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDD     L0059		;dynamic dwell
        LSRD 			;/2   
        LSRD			;/2    
        LSRD 			;/2   
        COMA  			;ones comp  
        COMB 			;ones comp   
        ADDD    L0059		;Add it back into the dwell
        BPL     LE52B		;bra if >=0
;
;-zero it out
;
        CLRA 			;   
        CLRB    		;
;
LE52B   STD     L0059		;store it
;       
	CLR     L0068		;timer 
        LDAA    L0001		;Status word
	BPL     LE549		;Bra if engine not running
;
        BITA    #$0040		;Test b6
        BEQ     LE5A1		;bra if ==0, set COP and continue
;
        LDX     L0063		;DRP info
        CPX     #$FEF0		;65264, 15 rpm, cutoff for engine running/cranking?
        BHI     LE5A1		;Bra if <, set COP amd continue

        LDAB    LD018		;6, filter coeff
        LDAA    #$00FF		;Load with 255
        JSR     LFB44		;Lag filter routine
        BRA     LE581		;bra to store DRP info
;
LE549   LDAB    L0000		;Status word
        BITB    #$0008		;b3
        BEQ     LE594		;bra if ==0, set b3
;
        LDD     LD010		;DRP, 2458 = 400 RPM
        SUBD    LBC00		;Subtract current DRP
        BHI     LE55C		;Bra if >400 rpm
;
        CLRA 			;CLR out current DRP   
;
LE558   STAA    L0051		;engine run timed out 
        BRA     LE598		;Bra 
;
LE55C   LDAA    L0051		;engine run timed out
        CMPA    LD012		;6
        INCA  			;+1  
        BCS     LE558		;bra if <6, store L0051
;
;~~~~~~~~~~~~~~~~~~~~
;Engine running here
;~~~~~~~~~~~~~~~~~~~~
;
        LDAA    L0001		;Status word
        ORAA    #$0080		;Engine is now running
        STAA    L0001		;Save it
;
;-Check for flood clear mode
;
        LDAA    LD215		;230, 90% tps
        CMPA    L0043		;%tps
        BHI     LE577		;Bra if tps is less
;
        LDAA    L0008		;Load status word
        ORAA    #$0001		;b0 = in flood clr
        STAA    L0008		;Save it
;
LE577   LDAA    L00DE		;Status word
        ORAA    #$0008		;set b3 
        STAA    L00DE		;Save it
;
        CLRA  			;  
        STAA    L0051		;Engine run time out
        CLRB  			;
;  
LE581   STD     L0063		;Store DRP info
        BRA     LE5A1		;Bra to do COP and return
;
LE585   LDAA    L0068		;Timer 
        LDAB    L0001		;Status word
        CMPA    #$0017		;23
        BCS     LE59B		;Bra if less
;
        ANDB    #$007F		;Clr b7, engine running
        STAB    L0001		;Store it
        JMP     LEA6C		;jump
;
LE594   ORAB    #$0008		;Set b3
        STAB    L0000		;Status word
LE598   JMP     LEA59		;Jump
;
;~~~~~~~~~~~~~~~~~~~~~~~~~
;RPM calcs.
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE59B   TSTB    		;Test b7
        BPL     LE598		;bra if engine not running
;
        INCA 			;Increment timer   
        STAA    L0068		;Store it
;
LE5A1   LDAA    #$0004		;b2, COP
        JSR     LFC54		;Go set the bit
        JSR     LFD2B		;RTS, delay
;
;-Get DRP's
;
        LDD     LBC00		;DRP counter
	STD     L0018		;Store them
;
;-Calc. DRPs relative to 8 cyl.
;
        LDX     #L0018		;Load DRPs addr.
;
        LDAA    LD00F		;Cyl count
        LDAB    #$0020		;32
        MUL			;$08 x $20    
        TBA 			;A <---- LSB in B 
;   
        BEQ     LE5BF		;Bra if ==0, no correction is needed
;
        JSR     LFC0C		;(A x X*)/256,
        STD     L0018		;Now DRPs relative to 8 cyl.
;
LE5BF   LDAA    L001B		;Load RPM/25
        STAA    L001C		;RPM/25, one delayed
;
;-Calc rpm from DRP
;
;                            60 [sec/min]             		 39142
;rpm/25 = ------------------------------------------ x (1/25) = --------
;	  (DRPs x 15.2 usec x 4 [pulse/revolution])    		  DRPs
;
        LDD     L0018		;DRPs		
        ASLD			;x2  			  
        STD     L004B		;tmp storage
        LDD     #$0133		;(39142 x2)/256
        JSR     LFBE5		;Div. routine
;
;-Do scaled rpms
;
        STD     L0049		;tmp storage
        CMPA    #$0060		;2400 rpm
        BCS     LE5DD		;bra if less
;
;RPM >=2400 here
;
        ADDD    #$4080		;1600 RPM offset to A + 128 to B for roundup
        BCC     LE5E4		;Bra if no overflow
        LDAA    #$00FF		;clr overflow, 3600 rpm max
        BRA     LE5E4		;Bra to save it
;
LE5DD   ASLD			;x2, now rpm/12.5    
        SUBD    #$1F80		;400 rpm offset from A and 128 from B for round down	
        BCC     LE5E4		;Bra if no undeflow
        CLRA			;Clr underflow  
;  
LE5E4   STAA    L001A		;scaled rpm, 
				; 400 - 2400 in 12.5 rpm increments
				; 2400 - 4800 in 25 rpm increments
;	
        LDD     L0049		;Load rpm back in
        ADDD    #$0080		;Round up
        BCC     LE5EF		;Bra if no overflow
        LDAA    #$00FF		;Clr overflow, 6375 max rpm
;
LE5EF   STAA    L001B		;Store it, RPM/25
;
        LDD     L0049		;Load rpm back in
        ASLD			;x2, now rpm /12.5    
        BCC     LE5F9		;bra if no overflow
        LDD     #$FFFF		;clr overflow
;
;-RPM/12.5, filtered
;
LE5F9   LDX     L001D		;prev stored rpm
        BEQ     LE603		;if ==0, no filtering
;
        LDAB    LD01A		;240, filter coeff
        JSR     LFB44		;Go filter it
;
LE603   STD     L001D		;Store it, rpm/12.5, filtered
;
;~~~~~~~~~~~~~
;Dwell calcs.
;~~~~~~~~~~~~~
;
;Dwell in deg = (dwell time/DRP time interval) x 90 deg/DRP
;
;-Dynamic dwell calc
;
        LDX     LBC00		;DRPs
        STX     L0049		;tmp storage
;
        LDAA    #$00FF		;preload max dwell for accel
        LDAB    L0024		;S/D map
        SUBB    L0026		;S/D map, two delayed
        BCS     LE616		;Bra if MAP falling
;
        CMPB    #$0020		;30 kPa, delta S/D MAP
        BCC     LE621		;Bra if greater, set max dwell of 3.96 msec
;
LE616   LDD     L0057		;DRP, one delayed
        SUBD    L0049		;Subtract present DRPs
        ASLD   			;x2 
        SUBD    L0059		;Subtract dynamic dwell
        BMI     LE623		;Bra if < 0
;
        ADDD    L0059		;Add dynamic dwell back in
LE621   STD     L0059		;Store it
;
;-Limit dynamic dwell to DRP/8 or 11.25 deg for 8 cyl.
;
LE623   LDD     L0049		;Load DRPs back in
;
;-DRP/8
;        
	LSRD    		;/2		
        LSRD 			;/2   
        LSRD 			;/2   
        SUBD    L0059		;Subtract dynamic dwell
        BCC     LE630		;Bra if no underflow
;
        ADDD    L0059		;Add it back in
        STD     L0059		;Store it
;
;-Static dwell calcs
;
LE630   LDD     L0049		;Load DRP cnts back in
        STD     L0057		;Store, one delayed
        LSRD 			;/2   
        SUBD    #0229		;229 x 15.26 usec/bit = 3.49 msec	
        BCC     LE63F		;Bra if no underflow
;
;~~~~~~~~~~~~~~~~~~
;DRP < 7 msec
;~~~~~~~~~~~~~~~~~~
;
;exit:
;
;static dwell = (DRP cnts x .01526) / 2 + 1.21 msec
;
        ADDD    #0308		;4.7 msec
        BRA     LE64F		;Bra to store
;
;~~~~~~~~~~~~~~~~~~~
;DRP >= 7 msec
;~~~~~~~~~~~~~~~~~~~
;
;exit:
;
;static dwell so far = (DRP cnts x .01526) / 4 - 6.25 msec
;
LE63F   LSRD 			;/2   
        SUBD    #0295		;4.5 msec
        BCS     LE64A		;Bra if < 25 msec
;
;~~~~~~~~~~~~~~~~~~~~
;DRP >= 25 msec
;~~~~~~~~~~~~~~~~~~~~
;
;exit:
;
;static dwell = (DRP cnts x .01526) / 4 - .45 msec
;
        ADDD    #0382		;5.8 msec
        BRA     LE64F		;Bra to store 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;7 msec <= DRP < 25 msec 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;exit:
;
;static dwell = (DRP cnts x .01526) / 16 + 4.18 msec 
;
LE64A   ADDD    #1527		;23 msec
        LSRD 			;/2	   
        LSRD 			;/2   
;
;-Save static dwell
;
LE64F   STD     L0049		;tmp storage
;
;-Do batt volts corr.
;
        LDAA    #0120		;12 volts
        SUBA    L0040		;Subtract batt volts x 10 from A
        BCC     LE658		;Bra if volts are less
;
        CLRA   			;Clr out delta volts * 10
; 
LE658   LDAB    #$0004		;4, delta volts factor
        MUL  			;Delta volts x factor, 609 usecs per volt
;   
;-Sum up all the dwell
;
        ADDD    L0049		;Add in static dwell
        ADDD    L0059		;Add in dynamic dwell
        STD     L005B		;Dwell
;
;-Limit to ensure at least 600 usecs of dwell
;
        LDD     LBC00		;DRP counter
        SUBD    #0039		;~600 usecs
        SUBD    L005B		;Dwell
        BCC     LE66F		;bra if no carry from ops.
;
        ADDD    L005B		;Add dwell back in
        STD     L005B		;store it
;
;~~~~~~~~~~~~~~~~~~~~~~~
;Spark SA lookups
;~~~~~~~~~~~~~~~~~~~~~~~
;
LE66F   LDAB    L0025		;SD map, one delayed
        STAB    L0026		;store it, SD map, two delayed
        LDAB    L0024		;SD map
;
        STAB    L0025		;Store it, SD map, one delayed	
        LDX     #LD038		;1, use map
        JSR     LFA88		;Map/vac lookup
;
        TAB			;MAP ----> B     
        LDAA    L001A		;scaled RPM
        CMPA    #$00D0		;3600 rpm
;
        BLS     LE686		;Bra if less
;
        LDAA    #$00D0		;3600 RPM, max all. rpm
;
LE686   JSR     LFB99		;3D lookup
;
        LDAB    L001B		;RPM/25
        CMPB    #$0090		;3600
        BLS     LE6A4		;Bra if less
;
        CMPB    LD00A		;Max RPM for slope SA, 4800 rpm
        BLS     LE697		;Bra if rpms <=4800
;
        LDAB    LD00A		;Load in max rpms
;
;-Slope SA
;
LE697   SUBB    #$0090		;sub 3600 rpm, now delta rpm/25
        ASLB			;x2    
        LDAA    LD00B		;1, degrees per 1k rpm
        MUL 			;deg Slope SA x delta RPM
;
;	     Slope SA x RPM/25 	
;SA added = -------------------
;		     128   
;			 
        ADDA    L0049		;Add it into the SA so far
        BCC     LE6A4		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LE6A4   TAB  			;SA ----> B  
        CLRA 			;   
        STD     L004F		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~
;Take alternating paths
;~~~~~~~~~~~~~~~~~~~~~~
;
        LDAA    L0066		;RTS counter
        BITA    #$0002		;Test b1
        BEQ     LE6D1		;Go do cool/Vac SA comp.
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;TCC spark retard lookup
;~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAA    LD02E		;Load TCC spark bias
        LDAB    LD007		;Opt byte
        BMI     LE6CD		;bra if opt for shift light is checked
;
        LDAB    L0005		;Status word
        BPL     LE6CD		;Bra if TCC unlocked
;
        LDX     #LD145		;Flag, use vacuum
;
        JSR     LFA88		;Go do MAP/Vac lookup
        LSRA 			;/2   
        TAB  			;Vac ----> B   
        LDAA    L001B		;RPM/25
        CMPA    #$0050		;rpm/25, 2000 rpm
        BLS     LE6CA		;Bra if <=
;
        LDAA    #$0050		;Set max rpm
LE6CA   JSR     LFB99		;Go do 3D lookup	
;
LE6CD   STAA    L0060		;Store lookup value	
        BRA     LE6EB		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~
;Cool comp. SA lookup
;~~~~~~~~~~~~~~~~~~~~~
;
LE6D1   LDX     #LD10E		;Flag, use vacuum
        JSR     LFA88		;MAP/Vac lookup
        LSRA 			;/2   
        PSHA   			;Vac ----> stack 
        LDAA    L0020		;Coolant, inv A/D counts
        LDAB    LD007		;Opt byte
        LSRB 			;logical shift right, check b0   
        BCC     LE6E3		;bra if ==0
;
        LDAA    L0023		;Use IAT for lookup
;
LE6E3   COMA 			;ones comp.   
        LSRA			;/2    
        PULB  			;Get vac into B  
        JSR     LFB99		;Go do 3D lookup
        STAA    L005F		;Store val.
;
;~~~~~~~~~~~~~~~~~~~~
;EGR active SA
;~~~~~~~~~~~~~~~~~~~~
;
LE6EB   LDX     L005D		;EGR active SA
        LDAB    LD1CF		;Filter coeff for EGR off 24
        LDAA    L00DF		;status word
        ANDA    #$0002		;clr all but b1
        BEQ     LE6FC		;bra if ==0
;
        LDAB    LD1D0		;12, Filter coeff for egr active
        LDAA    LD019		;12, SA for EGR active
;
LE6FC   JSR     LFB44		;Lag filter
        STD     L005D		;EGR active SA
;
;~~~~~~~~~~~~~~~~~~~~~~
;PE adder SA
;~~~~~~~~~~~~~~~~~~~~~~
;
        CLRA 			;   
        LDAB    L0009		;Status word
        BPL     LE717		;Bra if b7==0
        BITB    #$0060		;test b5=ESC failure, b6=runaway knock in progress
        BNE     LE717		;Bra if ==1, no PE adder spark
;
        LDAB    L000D		;Status word
        BPL     LE717		;bra if b7==0, not in PE
;
        LDX     #LD15D		;PE SA adder table
        JSR     LFBD1		;Baro read routine
        JSR     LFB77		;2D lookup with SBA
LE717   STAA    L004E		;tmp storage
;
;~~~~~~~~~~~~~~~~~
;Highway mode SA
;~~~~~~~~~~~~~~~~~
;
        LDX     #$0000		;Preclear, for HW mode timer
        LDAA    L002D		;Vacuum
        CMPA    LD028		;254, 20 kpa, threshold for highway mode SA
        BCC     LE739		;Bra if greater, no HW mode SA
;
        LDAB    L0020		;Coolant, inv. A/D counts
        CMPB    LD1E2		;Coolant, inv A/D counts, 20 deg C
        BCC     LE739		;Bra if temp is lower, no HW mode
;
        LDAB    L0030		;MPH
        CMPB    LD029		;255 MPH, thresh. for HW mode SA
        BCS     LE739		;Bra, No HW mode SA
        LDX     L006F		;HW mode timer
        CPX     LD02A		;4800 = 1 min, delay timer for HW mode
        BHI     LE73E		;bra if >, else, increment HW mode timer
;
;-inc HW mode timer
;
        INX   		  	;+1  
LE739   STX     L006F		;Store it, HW mode timer	
        CLRA   			; 
        BRA     LE747		;Bra, not time yet
;
LE73E   LSRA 			;Vac/2   
        LDAB    #$0030		;offset = 50 kpa
        LDX     #LD13F		;Addr of HW mode SA table
        JSR     LFB77		;2D lookup with SBA
LE747   STAA    L004D		;Store it, tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Sum up all the SA's so far
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        CLRB   			; 
        LDAA    L0002		;Status word
        BITA    #$0020		;test b5, in ALDL mode
        BEQ     LE753		;bra if==0
        LDAB    LD01F		;ALDL SA?
LE753   LDX     L004F		;tmp storage, main SA lookup
        ABX     		;Add it in
        LDAB    L005F		;Cool comp SA
        ABX     		;
        LDAB    L0060		;TCC locked spark retard
        ABX     		;
        LDAB    L005D 		;EGR active SA
        ABX    			; 
        TST     L005E		;EGR active SA, LSB
        BPL     LE765		;Bra if <$80
        INX    			;Round up 
LE765   LDAB    L004E		;tmp sorage, PE adder spark
        ABX   			;  
        LDAB    L004D		;tmp storage, HW mode SA
        ABX    			; 
        LDAB    L00E7		;Choke SA vs. temp.
        ABX  			;   
        STX     L004F		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Some sort of delta RPM/%TPS SA routine
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Throttle opening, closing?
;
        LDX     #LD020		;start addr.
        LDAA    L0043		;%tps
        LDAB    L0044		;%tps, one delayed
        SBA			;Now delta %tps     
        BCC     LE77E		;Bra if delta %tps is >0
;
        NEGA  			;2's comp 
        INX 			;+1, 1.2%, delta TPS closing   
        LDAB    L0043		;%tps
;
LE77E   CMPA    $0000,X		;compare delta TPS value to delta tps opening/closing
        BCS     LE7A9		;Bra if below threshold 
;
        CMPB    $0002,X		;%tps, opening/closing
        BCC     LE78C		;Bra if %tps in b >=
;
        LDAB    L000F		;status word
        ORAB    #$0080		;set b7,
        BRA     LE7AF		;
;
LE78C   LDAA    L001B		;Load rpm/25
        SUBA    L001C		;RPM/25, one delayed
        ADDA    #$0008		;200 rpm
        BPL     LE795		;bra if delta RPMs are greater than 200 rpms
;
        CLRA    
;
LE795   CMPA    #$0010		;400 rpm
        BLS     LE79B		;Bra if delta rpms are <= 400 rpm
;
        LDAA    #$0010		;400 rpm, max
;	
LE79B   CMPA    LD027		;delta rpm/25, 3=75 rpm
        BCS     LE7B3		;bra if delta rpm <
;
        CMPA    LD026		;delta rpm/25, 13=325 rpm
        BCC     LE7B3		;Bra if greater
;
        LDD     L004F		;Get SA
        BRA     LE7D5		;Go subtract bias'
;
LE7A9   LDAB    L000F		;Status word
        BPL     LE78C		;bra if b7==0
;
        ANDB    #$007F		;clr b7
LE7AF   STAB    L000F		;Save it
        LDAA    $0004,X		;delta RPM, opening/closing %tps
;
LE7B3   PSHA  			;----> stack  
        LDAA    L001B		;rpm/25
        LDAB    #$0010		;16, 400 rpm offset
        LDX     #LD1B7		;addr. of table
        JSR     LFB69		;2D lookup with upper lim
;
        PULB  			;Get delta RPM back  
        LDX     #LD1A6		;addr. of table
        ABX  			;Add delta RPM to X   
        LDAB    $0000,X		;Load up value from table using delta RPM/25 as offset
        BPL     LE7C8		;bra if >0
        NEGB    		;2's comp.
LE7C8   MUL     		;Multiply two looked up factora
        ASLD    		;x2
        ASLD    		;x2
        TAB     		;MSB ----> B
        CLRA    		;
        TST     $0000,X		;Test value pointed to by X
        BPL     LE7D3		;Bra if >0
        NEGB    		;Twos comp.
        DECA 			;Make signed as negative
;
;~~~~~~~~~~~~~~~~~~~~
;Subtract the biases
;~~~~~~~~~~~~~~~~~~~~
;   
LE7D3   ADDD    L004F		;Add in stored SA
;
LE7D5   SUBB    LD00D		;Subtract the main spark bias
        SBCA    #$0000		;do carry
        SUBB    LD00E		;subtract Cool comp. spark bias
        SBCA    #$0000		;
        SUBB    LD02E		;TCC locked spark bias
        SBCA    #$0000		;
        STD     L0049		;tmp storage
;
;-Do heads up
;
        LDAA    L0000		;Status word
        BITA    #$0002		;test b1
        BEQ     LE7EF		;bra if ==0
        JSR     L580C		;HU routine
;
LE7EF   LDD     L0049		;Load timing back in
        SUBB    LD009		;subtract base time
        SBCA    #$0000		;
;
        STD     L0061		;Calc. spark advance
        LDD     LD014		;Max allowable SA
        SUBD    L0061		;Sub it out
        BGT     LE803		;BRa if max SA is >0
;
        ADDD    L0061		;Now max allow SA
        STD     L0061		;store it
;
;~~~~~~~~~~~~~~~~
;Check for knock
;~~~~~~~~~~~~~~~~
;
LE803   LDD     LBC0A		;knock counter
        STD     L004A		;tmp storage
        SUBD    L0069		;Pulse acc. counts
        TSTA  			;Test MSB
        BEQ     LE80F		;Bra if ==0
;
        LDAB    #$00FF		;Max out knock counts
;
LE80F   STAB    L004D		;tmp storage
        LDX     L00EB		;Engine run time	
        CPX     LD452		;50 secs
        BLS     LE823		;bra if <=
;
        CMPB    LD45C		;2, threshold for knock
        BLS     LE826		;bra if <=
;
        LDAA    L0009		;Status word
        ORAA    #$0080		;set b7, knock detected
        STAA    L0009		;Save it
;
LE823   CLR     L0093		;ESC counter
;
LE826   LDX     L004A		;load Pulse acc. counts
        STX     L0069		;Store them, Pulse acc. counts
;
;-Check engine/transmission speed ratio
;
        LDAA    L007D		;rpm/drive ratio
        SUBA    L007E		;-Filtered rpm/drive ratio, MSB
        BCC     LE837		;bra 
;
        NEGA    		;2's comp., switch sign
        CMPA    LD035		;2, delta rpm/drive ratio
        BHI     LE850		;bra, transmission has upshifted/TCC locked, do knock quals
;
        CLRA    
;
;-Here if trans has downshifted/in same gear/TCC unlocked and engine accelerating
;
LE837   LDAB    L0043		;%tps
        CMPB    LD032		;255, 100% tps
        BLS     LE850		;Bra if tps% <= 255
;		
        LDAB    L006C		;Timer for knock retard alg.
        BNE     LE84C		;Bra if !=0, skip knock quals
;
        CMPA    LD034		;255
        BLS     LE850		;
;
        LDAA    LD033		;0
        STAA    L006C		;Store it, timer for knock retard alg.
LE84C   CLRA    		;Clr accumulated retart
        JMP     LE8D6		;skip knock retard
;
;~~~~~~~~~~~~~~~~~
;Knock quals
;~~~~~~~~~~~~~~~~~
;
;-Coolant
;
LE850   CLR     L006C		;Clr it, timer for knock retard alg.
        LDAA    L0020		;Coolant, inv A/D counts
        CMPA    LD031		;126 = 50 deg C
        BCC     LE84C		;bra if cool temp < threshold, no retard
;
;Speed
;
        LDAA    L0030		;MPH
        CMPA    LD02F		;10 mph
        BCC     LE868		;Bra if speed is >10 mph
;
        LDAA    L001D		;RPM/12.5, filtered
        CMPA    LD030		;1000 rpm
        BCS     LE8E3		;Bra if rpms are less
;
LE868   LDAA    L0040		;Batt. volts
        CMPA    #0090		;9 volts
        BCS     LE874		;Bra if voltage is less
;
        LDAA    L0009		;Status word
        BITA    #$0060		;b5=ESC failure, b6=runaway knock in progress
        BEQ     LE878		;Bra if ==0
;
;-Set max knock counts
;
LE874   LDAA    #$00FF		;255		
        STAA    L004D		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~
;Do knock retard lookups
;~~~~~~~~~~~~~~~~~~~~~~~
;
LE878   LDX     #LD179		;Knock retard vs. IAT table
        LDAA    L0023		;IAT
        COMA  			;Ones comp   
        LSRA   			;/2 
        JSR     LFB7B		;2D lookup
        STAA    L004E		;tmp storage
;
        LDAB    L000D		;Status word
        BPL     LE895		;bra if b7==0, not in PE
;
        LDX     #LD190		;Addr of PE-knock attack rate table	
        PSHX    		;Addr. ----> stack
        LDX     #LD16D		;Addr of PE max retard table
        LDAA    L001B		;RPM/25
        LDAB    #$0010		;16, 800 rpm
        BRA     LE8A8		;Bra, go do lookup
;
LE895   LDAA    #$00FF		;prelaod A with 255, zero vacuum
        LDAB    L0008		;Status word
        BITB    #$00C0		;test b6= , b7 = map test failed
        BNE     LE89F		;bra if ==1, map err.
;
        LDAA    L002D		;Vacuum
LE89F   LDAB    #$0040		;64, offset
        LDX     #LD196		;addr of Non-PE knock attack rate table
        PSHX    		;Addr. ----> stack
        LDX     #LD173		;addr of non-PE max knock retartd table
;
LE8A8   LSRA   			;/2 , RPM/Vac
        STD     L004F		;tmp storage
        JSR     LFB69		;2D lookup with UL
        LDAB    L004E		;Load in knock retard vs IAT multiplier
        MUL 			;Max knock retards from lookups x multiplier 			   
        ASLD 			;x2, now A = (max knock retard x multiplier)/128   
        BCC     LE8B6		;Bra if no overflow
;	
        LDAA    #$00FF		;clr overflow
;
LE8B6   STAA    L004E		;store max retard, tmp storage
        PULX 			;Get addresses off stack, knock attack rates   
        LDD     L004F		;Get RPM/Vac back in
        JSR     LFB69		;Go do lookup with UL
;
;-Calculate the retard from the attack rates and knock
;
        LDAB    L004D		;load knock counts back in
        CMPB    LD037		;2, threshold for knock recognition
        BCC     LE8C6		;Bra if >2
;
        CLRB			;Clr stored counts
;    
LE8C6   MUL   			;knock x attack rate from lookup  
        ASLD  			;x2  
        BCS     LE8CE		;bra if overflow, set max val.
;
        ADDA    L006E		;accumulated knock retard + (attack rate x KCs)/128
        BCC     LE8D0		;Bra if no overflow
;
LE8CE   LDAA    #$00FF		;clr overflow
;
LE8D0   CMPA    L004E		;Compare to max allow retard from lookup
        BLS     LE8D6		;bra if calced retard is 
        LDAA    L004E		;load in max val.
;
LE8D6   STAA    L006E		;Store it, accumulated knock retard
        LSRA  			;/2  
        STAA    L0049		;tmp storage
        LDD     L0061		;Stored spark advance
        SUBB    L0049		;Subtract out the retard
        SBCA    #$0000		;Round down if needed
        STD     L0061		;Store it
;
LE8E3   LDAA    LD40A		;Diag. mask
        BITA    #$0020		;Test b5, EGR failure
        BEQ     LE915		;Bra if ==0
;
;-Lag filter of spark term
;
        LDAB    LD43A		;32
        LDX     L008F		;Spark term
        LDAA    L000B		;Status word
        ANDA    #$0004		;Clr all but b2
        BEQ     LE8FA		;Bra if ==0
;
        LDAA    #$00FF		;
        LDAB    LD439		;128, filter coeff
;
LE8FA   JSR     LFB44		;Lag filter
        STD     L008F		;Store it

        LDX     #L008F		;Start addr. of spark term
        LDAA    LD438		;12
        JSR     LFC0C		;(A x X*) /256
        ASLB  			;x2, round up  
        ADCA    #$0000		;Round up if needed
        STAA    L0049		;tmp storage
        LDD     L0061		;Stored SA
        SUBB    L0049		;Sub out term
        SBCA    #$0000		;Rount down if needed
        STD     L0061		;Store it
;
;-Check to make sure SA is greater the min allowed value
;	
LE915   LDD     LD016		;Min allowed SA, signed double byte
        SUBD    L0061		;-3.8 - stored SA
        BLT     LE920		;Bra if still <0
;	
        ADDD    L0061		;Add back in SA, now -3.8 deg.
        STD     L0061		;Store it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Add SA to create knock if needed
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE920   LDAA    L0093		;ESC counter	
        BEQ     LE93F		;Bra if ==0, not performing ESC test
;
;-Push SA up to check for knock for ESC test
;
        LDX     L0061		;Load in SA
        LDAB    LD45A		;40, 14.08 deg., added in on first pass to force knokc
;
        LDAA    L0009		;Status word
        BITA    #$0010		;test b4, adding in addl. SA to force knock
        BEQ     LE932		;bra if ==0
;
        LDAB    LD45B		;57, 20 deg., alternate SA added in to attempt to force knock
;
LE932   ABX     		;Add in the timing
        CPX     LD014		;40.1 deg, max timing
        BLS     LE93D		;Bra if < 40.1 deg
;
        CLR     L0093		;Clr ESC counter
        LDX     L0061		;Load SA back in
;
LE93D   STX     L0061		;Store SA
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Finalize SA
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LE93F   LDD     L0061		;Load SA back in
        BMI     LE94B		;Bra if <0
;
;SA >= 0
;
        LDAA    L0001		;Status word
        ANDA    #$00FE		;Clr b0
        STAA    L0001		;Store it
        BRA     LE952		;
;
;SA < 0
;
LE94B   LDAA    L0001		;Status word
        ORAA    #$0001		;Set b1
        STAA    L0001  		;Store it
        NEGB 			;2's comp 
;   
LE952   LDAA    L0063		;Stored SA
        TST     L0064		;DRP info	
        BPL     LE95A		;bra if b7==0
;
        INCA 			;+1
;   
LE95A   MUL 			;    
        INCA    		;+1
;
        LDAB    L0000		;Status word	
        BITB    #$0002		;Test b2, HU		
        BEQ     LE965		;bra if ==0, no HU
        JSR     L5812		;Go do HU
;
;-Make SA time based for ECU
;
LE965   LDX     #L0018		;DRPs
        JSR     LFC0C		;(A x *X)/256
        STD     L004E		;tmp storage
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Lookup spark latency correction
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        LDAA    L001B		;rpm/25
        LDX     #LD182		;Addr of table
        JSR     LFB68		;Clr B, 2D lookup w/ UL
        STAA    L004C		;tmp storage
;
        LDAB    L0001		;Status word
        BITB    #$0001		;Test b0, sign of SA
        BNE     LE983		;Bra if SA <0
;
;-SA >=0
;
        CLRA  			;Pre clear  
        CLRB    		;
        SUBD    L004E		;Subtract SA x DRPs/256
        BRA     LE985		;Bra
;
;-SA < 0
;
LE983   LDD     L004E		;Load in SA x DRPs/256
LE985   SUBB    L004C		;Sub out looked up value 
        SBCA    #$0000		;Subtract with carry
        STD     L0049		;tmp storage
;
        CLRA    		;Pre clear
        CLRB    		;
        SUBD    LBC00		;DRP counter
;
        LSRD   			;/2 
        LSRD    		;/2
        LSRD    		;/2
        LSRD    		;/2
;
;-Get it out to the counters
;
        ORAA    #$00F0		;240
        ADDD    LBC20		;EST fall counter
        SUBD    L0049		;tmp storage
        BMI     LE9A1		;Bra if <0
;
        ADDD    L0049		;Add it back in
        STD     L0049		;tmp storage
;
LE9A1   LDD     L0049		;tmp storage
        SUBD    LBC20		;ESt fall counter
        JSR     LFD2B		;RTS, delay only
        STD     LBC28		;EST fall counter
        JSR     LFD2B		;RTS, delay
        ADDD    LBC1C		;Dwell counter
        SUBD    L005B		;Subtract Dwell
        NOP   			;No op., delay  
        LDX     L005B		;Load dwell back in
        STD     LBC26		;Est fall counter
        JSR     LFD2B		;RTS, delay
        STX     LBC1C		;Save it, EST fall counter
        JSR     LFD2B		;RTS, delay
        LDD     L0049		;tmp storage
        STD     LBC36		;
;
;~~~~~~~~~~
;EST diag.
;~~~~~~~~~~
;	
        LDAA    L0000		;Status word
        BITA    #$0008		;b3
        BEQ     LEA3B		;bra if ==0, Engine is off. 
;
        LDAB    L0002		;Status word
        BITB    #$0004		;b2
        BEQ     LEA21		;bra 
;
        LDX     LBC06		;EST circuit
        STX     L0049		;tmp storage
        LDAB    LD40A		;Diag. mask
        BITB    #$0001		;b0, EST mon. err.
        BEQ     LEA23		;bra if b0==1
;
        LDAB    L0881		;Load MCU1
        BITB    #$0020		;b5 = engine in crank
        BEQ     LEA13		;Bra if engine cranking?
;
        LDAB    L0001		;Status word
        BITB    #$0040		;Test b6
        BNE     LEA2E		;Bra if ==1
;
        LDAA    L0000		;status word
        BMI     LEA17		;bra if b7==1, est err in effect.

        PSHA   			;Status word ----> stack 
        LDD     L0049		;EST circuit, tmp storage
        SUBD    L0096		;EST circuit data
        TSTA  			;Test MSB  
        PULA  			;Get status word off the stack  
        BNE     LEA07		;bra if MSB was != 0
;
        CMPB    LD44F		;0
        BHI     LEA07		;bra if diff. is >0
        BITA    #$0040		;Test b6 in L0000
        BNE     LEA23		;Bra if ==1, esc ok.
;
        ORAA    #$0040		;Set b6, est ok
        BRA     LEA13		;bra
;
LEA07   LDAB    L0098		;err counter
        CMPB    LD450		;4, > more then 4 faults sets err.
        BHI     LEA17		;Bra if >, set err.
;
        INC     L0098		;+1
        ANDA    #$00BF		;clr b6, dont set err. yet
LEA13   STX     L0096		;Store, est ciruit data
        BRA     LEA1F		;Bra, dont set err.
;
LEA17   ORAA    #$0080		;Set b7 of L0000, EST err.
;
        LDAB    L0013		;err. flag 2
        ORAB    #$0001		;set b0
        STAB    L0013		;Store it
LEA1F   STAA    L0000		;Store status word
LEA21   BRA     LEA71		;Bra
;
LEA23   LDAB    L0001		;Status word
        ORAB    #$0040		;set b6
        STAB    L0001		;Save it
        CLR     L0098		;Clr est err counter
        STX     L0096		;Save as EST circuit data
LEA2E   ANDA    #$00F7		;Clr b3 in L0000	
        STAA    L0000		;Save it
;
        LDD     LBC2C		;EST
        JSR     LFD2B		;Delay
        STD     LBC24		;EST
;
;~~~~~~~~~~~~~~
;-Code 42, EST
;~~~~~~~~~~~~~~
;
LEA3B   LDAA    L0013		;err flag 2
        ORAA    #$0001		;set b0, EST failure
        LDAB    L00DE		;Status word
        BPL     LEA4C		;Bra if b7 ==0, EST failure not flagged
;
        STAA    L0013		;Save it
;
        LDD     LBC3C		;PWM, control register  
        ANDB    #$00EF		;clr b5, EST? 
        BRA     LEA51		;Bra
;
LEA4C   LDD     LBC3C		;PWM 	
        ORAB    #$0010		;Set b5
;
LEA51   JSR     LFD2B		;RTS, delay
        STD     LBC3C		;Save it
        BRA     LEA71		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Engine is off from here on 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEA59   LDAA    #$0004		;Preload with 0000 0100
        JSR     LFC54		;PWM routine, COP
        LDX     #$FFFF		;0 rpm
        STX     L0018		;DRP counter
        LDAA    L00DE		;Status word
        BITA    #$0008		;Test b3
        BNE     LEA6C		;Bra if ==1
;
        INX			;Roll X over     
        STX     L00EB		;Store as engine run time
LEA6C   LDAA    #$00EF		;Go clr b4 in control reg.
        JSR     LFC49		;PWM control routine
;
LEA71   LDAA    L0002		;Status word
        ANDA    #$00FB		;clr b2
        STAA    L0002		;Store it
        JMP     LE474		;End of spark minor loop
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 1* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Battery volts check and VATS handling
;
LEA7A   LDAA    #$0002		;Batt channel
        JSR     LFF27		;A/D routine, clr B to get data.
        PSHA    		;Push raw batt volts to stack
;
        LDAB    L0000		;status word
        CMPA    #0090		;Batt volts x10, 9 volts
        BCC     LEAD0		;Bra if batt. volts >=
;
        CMPA    #0040		;4 volts
        BCC     LEB05		;Bra if batt volts >=
;
;-Check to make sure volts dip isnt a singular occurence
;
        LDAA    L0040		;Batt volts x 10
        CMPA    #0040		;4 volts
        BCC     LEB05		;Bra if stored batt. volts greater
;
;-Uh, oh... volts way too low for motor to continue running
;
        CLRA    		;
        STAA    L00EB		;Clr engine run timer
        STAA    L00EC		;Clr engine run time
        ORAA    #$0004		;Set b2, perform fuel pump volts low test
        STAA    L00DE		;Status word
;
        LDAA    L0001		;Status word
        ANDA    #$007F		;clr b7, engine no longer allowed to run
        STAA    L0001		;Save it
;
        LDAA    L00DF		;Status word
        ANDA    #$0005		;clr b0, b2 = hot restart in effect

        ANDB    #$00DF		;Status word
        BITB    #$0010		;Test b5 in L0000
        BNE     LEACC		;Bra if ==1, low volts already flagged
;
        BITA    #$0001		;Test b1 of L00DF
        BEQ     LEAB5		;Bra if ==0
;
        LDAA    L0010		;Status word
        ANDA    #$00FC		;Clr b0, b1
        STAA    L0010		;Save status word
;
        ORAB    #$0020		;Set b5 of L0000, very low batt volts.
;
LEAB5   ORAB    #$0010		;Set b4 of L0000, engine shutdown in effect		
        STAB    L0000		;Save status word
; 
        LDAA    L0023		;Load in IAT
        LDAB    LD005		;Opt byte
        BITB    #$0020		;Test b5, use IAT 
        BNE     LEAC4		;Bra if ==1
;	
        LDAA    L0020		;Coolant, inv, A/D counts
;
LEAC4   CMPA    LD21D		;40 deg C, thresh to set hot restart in effect 
        LDAA    #$0004		;b2, hot restart in effect
        BCS     LEACC		;Bra if cool temp is greater
;
        CLRA   			;Clr L00DF
; 
LEACC   STAA    L00DF		;Save status word
        BRA     LEB05		;Bra
;
;- Batt volts >= 9 volts bra here
;
LEAD0   BITB    #$0010		;Test b4, engine shutdown in effect
        BEQ     LEAD9		;Bra if not shutting down
;
;-Engine shutdown in effect
;
        LDX     LBC06		;EST circuit
        STX     L0096		;Save it, est circuit data
;
LEAD9   LDAA    L00DF		;Status word		
        BITA    #$0040		;Test b6, VATS, engine start ok'd
        BNE     LEAF9		;BRa if engine start a go
;
;-Engine start not ok'd
;
        LDAA    L0056		;VATS err timer
        CMPA    LD463		;0
        BLS     LEAF1		;Bra if timer is less
;
;-Set VATS err., code 53
;
        LDAA    L00E3		;Malf flag 3
        ORAA    #$0004		;Set b2, VATS err.
        STAA    L00E3		;Save malf flag
        JSR     LFD2C		;Do checksum on flags
        STAA    L00EA		;Store checksum
;
LEAF1   INC     L0056		;+1
        BNE     LEAF9		;Bra if no rollover	
;
        DEC     L0056		;Roll timer back
;
LEAF9   LDAA    L00DE		;Status word		
        ANDA    #$00FB		;Clr b2, no fuel pump volts test
        STAA    L00DE		;Save status word
;
        ANDB    #$00EF		;Clr b4 of L0000, engine shutdown bit
        ANDB    #$00DF		;Clr b5 of L0000, very low batt volts flag
        STAB    L0000		;Save it
;
;-Batt volts < 9 volts bra here
;
LEB05   PULA 			;Get batt volts x10 off the stack   
        STAA    L0040		;Save it, batt volts x10
;
        LDAA    #$0000		;Fuel pump
        JSR     LFF27		;A/D w/ clr B, wait for data
        STAA    L0041		;Store it, fuel pump volts, A/D counts
;	
        LDAB    L0001		;Status word
        BPL     LEB23		;Bra if motor is off
;
;-Engine on here
;
        ORAB    #$0008 		;Set b3 of L0001, motor is running
        LDAA    L00DF		;Load status word
        ORAA    #$0001		;Set b0 
        STAA    L00DF		;Save status word
        BRA     LEB36		;Bra to store and return
;
;-More then 4 secs. has elapsed, dont allow fuel pump volts test
;
LEB1D   LDAA    L00DE		;Status word
        ANDA    #$00FB		;Clr b2, no fuel pump volts test
        STAA    L00DE		;Save status word
;
;-Engine off here as well
;
LEB23   CLRA   			;
        BITB    #$0008		;Test b3 of L0001, engine had been running prior to shutdown
        BNE     LEB31		;Bra if ==0, inc timer and continue
;
;-Engine off here
;
        LDAA    L0052		;Fuel pump volts test timer
        BEQ     LEB34		;Bra if timer is ==0, 
;
        CMPA    LD013		;delay thresh, 4 secs
        BHI     LEB1D		;Bra if motor has been off for longer
;
LEB31   INCA  			;+1  
        STAA    L0052		;Save timer, Fuel pump volts test timer
LEB34   ANDB    #$00F7		;Clr b4 of L0001, VSS detect movement
; 
LEB36   STAB    L0001		;Save status word
        RTS  			;Return 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~   
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 2* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-CTS and pseudo-baro read
;
LEB39    JSR     LFD39		;Go run CTS coolant diag routine
        JSR     LFC80		;Do pseudo-baro
        RTS			;Return      
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 3* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-ALDL channel read
;
;b5: >= 2 volts, ALDL mode
;b4: < .8 volts, field service mode
;b3: < 2 volts, backup mode
;
LEB40   LDAA    #$000C		;ALDL channel
        CLRB    		;Clr B, go read data
        JSR     LFC21		;A/D routine
        LDAB    L0002		;Status word
        ANDB    #$00C7		;Clr b3-b5
;
;-See if ALDL is less then .8 volts, field service mode
;
	CMPA    #0040		;.8 volts
        BCS     LEB5A		;Bra if volts are less
;
;-See if ALDL is less then 2 volts, Backup mode
;
        CMPA    #0100		;2 volts
        BCS     LEB5E		;Bra if volts are less
;
;-Check if ALDL is >= 3 volts, open
;
        CMPA    #0153		;3 volts
        BCC     LEB60		;Bra if volts >= ALDL pins open
;
;-Set ALDL mode
;
        ORAB    #$0020		;Set b5, in ALDL mode
        BRA     LEB60		;Bra to save
;
;-Set field service mode
;
LEB5A   ORAB    #$0010		;Set b4, field service mode
        BRA     LEB60		;Bra to save 
;
;-Set backup mode
;
LEB5E   ORAB    #$0008		;Set b3, backup mode
;
LEB60   STAB    L0002		;Save status word
        JMP     LFDBC		;Jump to do IAT lookup and diag. routine
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 4* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-EGR quals
;
LEB65   LDX     #LD1C6		;Addr of EGR quals
        LDAA    $0001,X		;Load addr. +1, 45 deg C, cool temp thresh for EGR
        LDAB    L0005		;Status word, EGR quals
;
        BITB    #$0004		;Test b2, Temp thresh for EGR on already met
        BEQ     LEB72		;Bra if ==0, EGR temp thresh not yet passed
;
        LDAA    $0000,X		;Load addr, 40 deg C, cool temp to deactivate EGR 
;
LEB72   CMPA    L0020		;Cool counts, inv, A/D counts
        BHI     LEB7A		;Bra if cool is less
;
        ANDB    #$00FB		;Clr b2, Cool temp thresh for EGR not met
        BRA     LEBA8		;
;
LEB7A   ORAB    #$0004		;Set b2, Cool temp for EGR on met
        LDAA    L0008		;Load status word
        BITA    #$0024		;Test b2 = TPS high err., b5 = TPS low err.
        BNE     LEB94		;Bra if err. dont perform TPS test
;
        LDAA    $0005,X		;%TPS thresh for EGR on
        BITB    #$0020		;Test b5 of L0005, EGR TPS thresh status
        BEQ     LEB8A		;Bra if ==0
;
        LDAA    $0004,X		;%TPS thresh to deactivate EGR
;
LEB8A   CMPA    L0043		;%TPS	
        BCS     LEB92		;Bra if tps is less
;
        ANDB    #$00DF		;Clr b5, TPS tresh for EGR off exceeded
        BRA     LEBA8		;Bra
;
LEB92   ORAB    #$0020		;Set b5, TPS tresh for EGR on met 
;
LEB94   LDAA    L00DE		;Load status word
        BITA    #$0040		;Test b6, VSS error.
        BNE     LEBAC		;Bra if ==1
;
        LDAA    $0003,X		;MPH thresh for EGR on
        BITB    #$0040		;Test b6, MPH thresh for EGR already met 
        BEQ     LEBA2		;Bra if ==0, bra if not yet met.
;
        LDAA    $0002,X		;EGR off speed
;
LEBA2   CMPA    L0030		;mph
        BLS     LEBAC		;Bra if MPH are >=
;
        ANDB    #$00BF		;Clr b4, MPH exceeded for EGR on
;
;-Here if qual not passed, no EGR
;
LEBA8   ANDB    #$00FE		;Clr b1, No EGR/Vacuum thresh for EGR exceeded
        BRA     LEBC1		;Bra
;
LEBAC   ORAB    #$0040		;Set b6, MPH thresh for EGR on met
;
        LDAA    $0006,X		;50% TPS, max tps for EGR	
        CMPA    L0043		;%TPS
        BCS     LEBA8		;Bra if %TPS is greater, 
;
        BITB    #$0001		;Test b0 of L0005, Vac. thresh for EGR on
        BEQ     LEBB9		;Bra if ==0, Thresh not yet met.
;
        INX    			;addr. +1, Vac thresh for EGR off
; 
LEBB9   LDAA    L002D		;Load vacuum
        CMPA    $0007,X		;Compare vacuum to to thresh
        BHI     LEBA8		;Bra if vacuum greater
;
        ORAB    #$0001		;Set b0, Vac thresh for EGR on met
;
LEBC1   STAB    L0005		;Save status word
        LDAA    L00DF		;Status word
        ANDA    #$00FD		;Clr b2, EGR active bit
        BITA    #$0020		;Test b5, EGR failure
        BNE     LEBD0		;Bra if ==1
;
        ASRB   			;Shift right 
        BCC     LEBD0		;Bra if b0==0, no EGR 
;
        ORAA    #$0002		;Set EGR active bit
LEBD0   STAA    L00DF		;Save status word
        RTS  			;Return   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Batt. volts check and IAC handling
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LEBD3   LDAB    L00E0		;Load status word 
        LDAA    L0040		;Load batt volts
        CMPA    #0171		;17.1 volts
;
        BLS     LEBE1		;bra if volts are <= 17.1 volts
;
;-Overvoltage, disable MCU1/turn off IAC
;
        ANDB    #$00DF		;Clr b5, disable MCU1		
LEBDD   ANDB    #$00FB		;Clr b2, iac enabled bit
        BRA     LEC55		;bra to shut off IAC
;
LEBE1   LDAA    L0014		;Load err flag
        BITA    #$0010		;test b4
        BNE     LEBFE		;bra if ==1
;
        LDAA    L0000		;Status word
        BITA    #$0010		;test b4
        BNE     LEC13		;Engine shutdown in effect if ==1
;
        LDAA    L0001		;Status word
        BPL     LEC08		;bra if engine off
;
        LDAA    L0040		;Batt. volts
        CMPA    LD4F1		;8.7 volts, threshold for low voltage for IAC
        BHI     LEC02		;Bra if >8.7 volts
;
;-Undervoltage, turn off IAC
;
        LDAA    L000E		;Status word
        ORAA    #$0004		;b2, undervoltage in effect
        STAA    L000E		;save status word
;
LEBFE   ORAB    #$0020		;b5, MCU1 enable
        BRA     LEBDD		;Bra to clear IAC enable bit to protect from undervolt cond.
;
;-Volts ok here
;
LEC02   LDAA    L000E		;Status word
        ANDA    #$00FB		;Clr b2, volts ok now
        STAA    L000E		;Store it
;
LEC08   LDAA    L0001		;Status word
        BMI     LEC13		;Bra if motor running
;
        LDAA    L0002		;status word
        SEC 			;set carry bit    
        BITA    #$0010		;In field service mode?
        BNE     LEC19		;Bra if ==1
;
;-Do actual IAC adjustment here
;
LEC13   LDAA    L00CB		;IAC steps
        SUBA    L00FD		;Current IAC pos.
        BEQ     LEBFE		;Bra if same, turn off IAC enable bit for now
;
LEC19   BITB    #$0020		;Test b5, MCU1 enable/disable bit
        BEQ     LEBFE		;Go turn it on
;
        BCC     LEC2A		;Bra to go retract IAC
;
        ANDB    #$00FA		;clr b0, b2
        LDAA    L00FD		;Current IAC pos
        BEQ     LEC3E		;bra if pos ==0

        DECA 			;Subtract one from A   
        STAA    L00FD		;store as current IAC position
        BRA     LEC3E	        ;Bra to extend the IAC
 ;
LEC2A   ORAB    #$0001		;Set b0, IAC retract
        LDAA    L00FD		;Load IAC steps
        CMPA    LD500		;210, MAX iac steps allowed
        BCC     LEBFE		;Bra if Req. IAC pos is greater, turn off IAC
;
        INC     L00FD		;Add one to curr IAC steps
        LDAA    L0010		;Status word
        BITA    #$0040		;Steps decay in effect?
        BNE     LEC3E		;Bra if so
;
        ORAB    #$0004		;Turn on the IAC
;
;-Set which way IAC is stepped
;
LEC3E   TBA 			;Move status word into A    
        ANDA    #$00C0		;Clr b0-b5
        BEQ     LEC4F		;Bra if now ==0
        CMPA    #$00C0		;Compare to 1100 0000
        BEQ     LEC4F		;Bra if both IAC I/O bits set
;
        BITB    #$0001		;Test retract bit b0
        BNE     LEC53		;if ==1, go toggle b6 of status word E0
;
LEC4B   EORB    #$0080		;Toggle b7, IAC-A IO control
        BRA     LEC55		;Go do the output
;
LEC4F   BITB    #$0001		;Test b0, retract bit
        BNE     LEC4B		;Bra to set IAC-A I/O control
;
LEC53   EORB    #$0040		;IAC-B I/O control
;
;-Set IAC/disable IAC
;
LEC55   STAB    L00E0		;Store status word
        LDAA    L0881		;Load MCU1 I/O
        ANDA    #$00F8		;Clr lower three bits for IAc
        ASLB 			;shift left, b7 to the C bit in the CCR   
        BPL     LEC61		;bra if b6 = iac control for iac-B
;
        ORAA    #$0002		;IAC-B
;	
LEC61   BCC     LEC65		;Bra if carry clear from above ASL op, iac control for iac-A	
;	
        ORAA    #$0001		;IAC-A
;
LEC65   ASLB    		;Shift left again
        BPL     LEC6A		;Bra if IAC disabled
;
        ORAA    #$0004		;Set enable IAC bit
LEC6A   STAA    L0881		;Store for output
        RTS 			;return  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 5* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Set defaults if motor off
;
LEC6E   LDAB    L0001		;Status word
        BMI     LEC80		;Br if motor is running, do HU
;
;-Engine off, set defaults
;
        LDAA    L0020		;Cool temp, inv., A/D counts
        STAA    L0021		;Startup cool temp, A/D counts
;
        CLRB    		; 
;
        LDAA    LD1D7		;599 mV
        STD     L003A		;Init. 02, minor loop filtered
        STD     L003C		;Init. 02, RTS filtered
        STAA    L0039		;Init. 02, A/D filtered
LEC80   JMP     LFE1D		;Go do HU
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 16* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Handles misc. non time critical lookups for the minor loops
;-Run 5 times/sec
;
LEC83   LDAA    L0066		;RTS counter
        BITA    #$0010		;Test b4
        BEQ     LEC8A		;Bra if ==0,
;
        RTS 			;...return if ==1   
;
;-Time to run the loop
;
LEC8A   CLRB   			; 
        LDAA    L000E		;Status word
        BMI     LECB1		;Bra if in closed loop
;
;-In open loop
;
        LDAA    L0003		;Status word
        BITA    #$0040		;b6, engine cool <= -5 dec C
        BNE     LECAE		;Bra if ==1
;
;-Engine temp above -5 deg C
;
        LDAA    L00C1		;startup choke decay timer
        BEQ     LEC9C		;Bra if ==0, decay out the choke
;
        DECA  			;-1  
        BRA     LECB6		;Bra to save
;
;-Decay out subtracted startup choke adj. to AFR 
;
LEC9C   LDAA    L0066		;RTS counter
        CMPA    #$008F		;143
        BNE     LECB8		;Bra if one second hasnt passed yet
;
        LDAB    L00C0		;startup choke adj. to AFR
        SUBB    LD24E		;13, decays by 1.3:1 AFR each second
        BCC     LECAA		;Bra if no underflow
;
        CLRB			;Clr underflow
;    
LECAA   STAB    L00C0		;Save it, startup choke adj. AFR
        BRA     LECB8		;bra
;
;-Init the timers 
;
LECAE   LDAB    LD24C		;20, 2.0:1 AFR
LECB1   STAB    L00C0		;Save it, startup choke adj. to AFR
;
        LDAA    LD24D		;0
;	
LECB6   STAA    L00C1		;startup choke decay delay timer
;
LECB8   LDAA    L0003		;Status word
        ANDA    #$00BF		;clr b6,engine cool temp <=5 deg C
        STAA    L0003		;Save it
;
        LDAA    L0041		;Fuel pump volts x 10
        LDX     #LD2E5		;BPW corr. table vs. volts
        JSR     LFB7B		;2D lookup
        STAA    L00B5		;BPW corr. factor vs. pump volts
;
        LDAA    L0020		;Coolant, inv., A/D counts
        COMA 			;Ones comp.   
        STAA    L0050		;tmp storage
        LDX     #LD2F6		;decel enlean factor vs cool table
        JSR     LFB72		;2D lookup with line count
        STAA    L009F		;Save it, decel enlean cool. factor
;
        LDAA    L0050		;Inv. coolant for lookup 
        LDX     #LD2FC		;AE vs cool table
        JSR     LFB7B		;2D lookup 
        STAA    L009C		;AE cool factor
;
        LDAA    L0020		;Coolant, inv, A/D counts
        LDX     #LD2D4		;BPW inv. cool. term
        JSR     LFB7B		;2D lookup
        STAA    L00AD		;Save it
;
        LDAA    L0050		;tmp storage, inv cool. term
        LDAB    L0001		;Bra if engine is running
        BMI     LED35		;Bra if motor running
;
;~~~~~~~~~~~~~~~~
;Engine off here
;~~~~~~~~~~~~~~~~
;
        LDAB    L00DE		;Status word
        BITB    #$0008		;test b3
        BNE     LED1F		;bra if ==1
;
        LDX     #LD317		;Choke AFR corr. vs temp
        JSR     LFB7B		;2D lookup
        LDAB    L00DF		;Status word
        BITB    #$0004		;Test b2, hot restart in effect?
        BEQ     LED04		;Bra if ==0, no hot restart in effect
;
;-lookup choke SA
;
        ADDA    LD220		;50, 5.0 AFR adj. added in on hot restart
;
LED04   STAA    L00E5		;Save it, choke adj. to AFR
;
        LDX     #LD161		;Choke SA vs. temp.
        LDAA    L0050		;Inv. cool temp term
        JSR     LFB72		;2D lookup w/ line count
        STAA    L00E7		;store it, choke SA vs. temp
;
        LDX     #LD167		;Choke SA delay timer table
        LDAA    L0050		;tmp storage, inv cool term
        JSR     LFB72		;2D lookup w/ line count
        STAA    L00E8		;Save it
;
        LDAA    LD21C		;25, 5 secs
        STAA    L00E6		;save it
;
LED1F   LDX     #LD328		;Open loop AFR mult. vs cool temp
        LDAA    L0050		;inv cool term
        JSR     LFB7B		;2D lookup
        STAA    L00B8		;Save it, open loop AFR mult. vs cool temp
;
        LDX     #LD339		;Crank AFR vs. cool temp
        LDAA    L0050		;tmp storage, inv cool. term
        JSR     LFB7B		;2D lookup
        STAA    L00B7		;crank AFR vs. cool temp 
        BRA     LED6F		;Scoot around motor running code
;
;~~~~~~~~~~~~~~~~~~~~
;Engine running here
;~~~~~~~~~~~~~~~~~~~~
;
LED35   LDAA    L00E6		;Choke decay delay timer 
        BNE     LED47		;bra if !=0, continue counting down
;
;Start to decay choke
;
        LDAA    LD21B		;9, 2 sec execution timer
        STAA    L00E6		;Save it
;
        LDAA    L00E5		;Choke AFR adj. 
        LDAB    L00B8		;open loop AFR mult. vs cool temp
        MUL 			;A x B
;
;			C.S.A.C. x O.L.A.M.
;Cool start AFR corr = ---------------------
;			        256
;    
        STAA    L00E5		;choke AFR adj.
        BRA     LED4A		;Bra 
;
;-Continue counting down
;
LED47   DEC     L00E6		;-1
;
LED4A   LDAA    L00E8		;delay timer
        BEQ     LED59		;Bra if ==0
;
        LDAA    L0066		;Load RTS counter
        ANDA    #$00F0		;clr lower 4 bits
        BNE     LED6F		;bra if !=0
;
;-Run once per second, count down delay timer
;
        DEC     L00E8		;-1 from choke SA decay delay timer
        BRA     LED6F		;Bra if !=0
;
LED59   LDAA    L0065		;choke SA decay run delay timer
        BEQ     LED62		;Bra if ==0, go decay choke SA
        DEC     L0065		;-1
        BRA     LED6F		;Bra around choke SA decay
;
LED62   LDAA    LD02C		;2, 2 sec. delay
        STAA    L0065		;Save it,
        LDAA    L00E7		;Choke SA vs. cool. temp
        LDAB    LD02D		;241, choke SA decay mult.
        MUL   			;(A x B)
;
;            Choke added SA vs. cool temp x choke SA decay mult.
;Choke SA = -----------------------------------------------------
;			            256
; 
        STAA    L00E7		;Save choke SA
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Engine both on and off here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LED6F   LDX     #LD355		;Open loop AFR vs. cool	
        LDAA    L0050		;tmp storage
        JSR     LFB7B		;2d lookup
;
        STAA    L00B6		;Added open loop AFR
        LDAA    L0001		;Status word
        BPL     LEDE8		;Bra if motor off
;
;~~~~~~~~~~~~~~~
;Engine on here
;~~~~~~~~~~~~~~~
;
        LDAA    L000A		;Status word
        BITA    #$0002		;test b1,exit closed loop
        BEQ     LED88		;bra if ==0, not exiting closed loop
;
;-Here if exiting closed loop
;
        CLR     L009E		;Exit closed loop timer
        BRA     LEDE8		;Bra to exit closed loop
;
;-Here if not immediatly exiting closed loop
;
LED88   LDAB    L00DE		;Status word
        LDAA    L009E		;Exit closed loop timer
        CMPA    LD1E6		;50, thresh to exit closed loop
        BCC     LED96		;Bra if >
;
        INCA  			;+1  
        STAA    L009E		;Save it
        BRA     LED9A		;
;
;-Exit closed loop timer has timed out
;
LED96   ANDB    #$00FE		;Clr b0, no closed loop
        STAB    L00DE		;Save it
;
LED9A   BITB    #$0001		;Test b0, closed loop ok'd
        BEQ     LEDE8		;Bra if ==0, exit closed loop
;
        LDAA    L0002		;Status word
        ANDA    #$0030		;Clr all but b4=in field service mode, b5=in ALDL mode
        BNE     LEDC6		;Bra if in either mode
;
;-Not in field service/ALDL mode
;
        LDAB    L00DE		;Status word
        BITB    #$0002		;Test b1, time thresh for closed loop met
        BNE     LEDC6		;Bra if ==1
;
        LDD     L00EB		;Engine run timer
;
        LSRD    		;/2	
        LDAA    L0021		;Startup coolant, A/D counts
        CMPA    LD1E2		;20 deg C
        BLS     LEDBB		;Bra if cool temp on startup was greater
;
;-Startup temp was < then 20 deg C
;
        CMPB    LD1E4		;engine run time, 400 secs
        BCC     LEDC0		;bra if engine running longer
;
        BRA     LEDE8		;Bra if engine run time is less
;
;-Startup temp >= 20 deg C
;
LEDBB   CMPB    LD1E3		;Engine run time, 30 secs.
        BCS     LEDE8		;Bra if engine run time is less
;
;-Enough time has passed for closed loop
;
LEDC0   LDAA    L00DE		;Status word
        ORAA    #$0002		;Set b1, time thresh for closed loop met
        STAA    L00DE		;Save status word
;
LEDC6   LDAA    L0020		;Cool temp, inv, A/D counts
        CMPA    LD1E5		;40 deg C, min temp for closed loop
        BCC     LEDE8		;Bra if cool temp is less, exit closed loop
;
        LDAB    L000E		;Status word
        LDAA    L0000		;Status word
        BITA    #$0002		;Test b1
        BEQ     LEDDC		;Bra if ==0
;
        LDAA    L040D		;HU ram
        ANDA    #$0003		;Clr b0, b1
        BNE     LEDE8		;Bra if !=0, exit closed loop 
;
LEDDC   LDAA    L0003		;Status word
        BITA    #$0001		;Test b0, forced to open loop
        BNE     LEDE4		;Bra if ==1, forced to open loop
;
;-Here to enter closed loop
;
        ORAB    #$0080		;Set b7, in closed loop
;
LEDE4   ORAB    #$0001		;Set b0, 
        BRA     LEDEC		;Bra 
;
;-Here to exit closed loop
;
LEDE8   LDAB    L000E		;Status word
        ANDB    #$007E		;Clr b7, in closed loop bit
;
LEDEC   STAB    L000E		;Save status word
        BPL     LEE20		;Bra if in open loop
;
;-Entering closed loop, check to see if learn ok
;
        LDAA    L0008		;Status word
        ANDA    #$00C0		;Clr all but b6 and b7, MAP errors
        BNE     LEE20		;Bra if map errors
;
        LDAA    L0020		;Coolant temp
        CMPA    LD1E7		;25 deg C, min temp for learn enable
        BCC     LEE20		;Bra if cool temp is less
;
        CMPA    LD1E8		;0=140+ deg C, max temp for learn enable
        BCS     LEE20		;Bra if cool temp is greater
;
        LDAA    L00A6		;Desired AFR
        CMPA    LD1EC		;14.7 AFR
        BNE     LEE20		;Bra if desired AFR is not set to stoich
;
        LDAA    L0024		;SD MAP
        CMPA    LD1EA		;99.6 kPa, max SD MAP for learn enable
        BHI     LEE20		;Bra if SD MAP is higher
;
        CMPA    LD1E9		;22 kPa, min SD MAP for learn enable
        BCS     LEE20		;Bra if SD MAP is less
;
        LDAA    L001B		;RPM/25
        CMPA    LD1EB		;6000 rpm, max rpm for learn enable	
        BCC     LEE20		;Bra if rpms are greater
;
        ORAB    #$0002		;Set b1, learn enabled
        BRA     LEE22		;Bra
;
;-Here to clear learn enable bit
;
LEE20   ANDB    #$00FD		;Clr b1, disable learn
;
LEE22   STAB    L000E		;Save status word
        RTS    			;Return  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 6* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Emissions handling
;

LEE25   LDX     L003C		;RTS O2, slow filtered
        LDAB    LD466		;1, filter coeff
        LDAA    L0039		;A/D 02
        JSR     LFB44		;Lag filter routine
        STD     L003C		;Save it
;
        LDAA    L0020		;Coolant temp, inv, A/D counts
        CMPA    LD46E		;20 deg C, cool temp thresh for AIR
        BHI     LEE3D		;Bra if cool temp is less, turn off air
;
        LDAA    L000A		;Status word
        ASRA   			;Shift right, test b0 
        BCC     LEE40		;Bra if ==0
;
LEE3D   JMP     LEF3E		;Jump to turn off air
 ;
LEE40   LDAA    L0003		;Status word
        BITA    #$0001		;Test b0
        BNE     LEE9B		;Bra if ==1
;
        LDAA    L000F		;Load status word
        BITA    #$0010		;Test b4, 
        BNE     LEE3D		;Bra if ==1
;
        LDAB    L0007		;Status word
        LDAA    L000E		;Status word
        BPL     LEE60		;Bra if not in closed loop
;
;-In closed loop here
;
        ORAB    #$0080		;Set b7, time to direct air to the cat
        STAB    L0007		;Save status word
        CLR     L0078		;Clr hard accel timer
        LDAA    LD46F		;50, 5 secs, forced to open loop timer
        STAA    L0079		;Save, forced to open loop timer
        BRA     LEE83		;Bra past closed loop stuff
;
;-In open loop here
;
LEE60   TSTB  			;Test b7 of L0007  
        BPL     LEE6A		;Bra if ==0, in open loop previously
;
        LDAA    L0079		;Forced to open loop timer
        BEQ     LEE3D		;Bra if ==0, Jump to turn off AIR
;
        DECA    		;-1
        STAA    L0079		;Save forced to open loop timer
;
LEE6A   LDAB    L0078		;Hard accel timer
        LDAA    L0077		;SD MAP, one delayed
        SUBA    L0024		;SD map
        BLS     LEE7A		;Bra if MAP is falling
;
        CMPA    LD46D		;Delta SD MAP, 45 kPa
        BLS     LEE7A		;Bra if delta map is less
;
        LDAB    LD46B		;20, 2 sec time delay after hard accel for air to be routed as desired 	
;
LEE7A   TSTB			;Test hard accel timer    
        BEQ     LEE83		;Bra if ==0, no hard accel previously
;
        DECB   			;-1 
        STAB    L0078		;Save hard accel timer
        JMP     LEF38		;Jump, force air to cat.
;
LEE83   LDAB    L0066		;RTS timer
        ANDB    #$00F0		;Mask out upper 4 bits
        STAB    L004E		;Store it, tmp storage
        LDAA    L000D		;Status word
        BPL     LEE9E		;Bra if not in PE
;
;-In PE here
;
        LDAB    L007A		;In PE timer
        CMPB    LD470		;0, one second delay if in PE to turn off air
        BHI     LEEE0		;Bra if >0, turn off air
;
        LDAB    L004E		;Stored RTS timer
        BNE     LEE9B		;Bra if != 0
;
        INC     L007A		;+1, one second
LEE9B   JMP     LEF30		;Jump, direct air to manifolds
;
;-Here if not in PE
;
LEE9E   CLR     L007A		;Clr in PE timer
        LDAB    L001A		;Load scaled rpms (same addr. as 7747, mistake? rpm/25 instead?)	
        CMPB    LD46A		;2050 rpm, max RPM for AIR
        BLS     LEEB5		;Bra if rpms are <=
;
        LDAB    L0074		;RPMs over timer
        CMPB    LD465		;2
        BHI     LEEE0		;Bra if >, turn off AIR
;
        INCB   			;+1, RPMs over timer
        BNE     LEEB6		;Bra if no rollover
;
        DECB 			;Roll timer back   
        BRA     LEEB6		;Bra
 ;
LEEB5   CLRB			;Clr timer   
; 
LEEB6   STAB    L0074		;Save it
        LDAB    L003C		;Load RTS O2
;
        CMPB    LD467		;698 mV
        BLS     LEECF		;Bra if O2 is less
;
        LDAB    L0075		;Rich O2 timer	
        CMPB    LD469		;50, 50 secs
        BCC     LEEDC		;Bra if >=, set O2 rich bit and cut AIR		
        LDAB    L004E		;Stored RTS timer
        BNE     LEEE6		;Bra if != 0
;
        INC     L0075		;+1, 1 second
        BRA     LEEE6		;Bra 
;
;-Here if o2 < 700 mV
;
LEECF   LDAB    L0075		;Load timer
        BEQ     LEEE2		;Bra if ==0
        LDAB    L004E		;Stored RTS timer
        BNE     LEEE6		;Bra if !=0
;
        DEC     L0075		;-1
        BRA     LEEE6		;Bra
;
;-50 sec timer exceeded, set O2 rich bit
;
LEEDC   ORAA    #$0001		;Set b0, O2 still rich
        STAA    L000D		;Store it
;
LEEE0   BRA     LEF3E		;Bra to turn off air
;
LEEE2   ANDA    #$00FE		;Clr b0
        STAA    L000D		;Save it, O2 is within limits
;
;-Here if O2 is overly rich but timer has not elapsed
;
LEEE6   BITA    #$0001		;Test b0
        BNE     LEF3E		;Bra if ==1, turn off air
;
        CLRA    		;
        LDAB    L003C		;Load RTS O2
        CMPB    LD468		;282 mV
        BCC     LEF02		;Bra if O2 is greater
;
;-O2 is lean here
;
        LDAB    L000E		;Status word
        BPL     LEF02		;Bra if not in closed loop
;
;-In closed loop, O2 is lean
;
	LDAA    L0076		;Lean O2 timer
        CMPA    LD469		;50, 50 secs
        BHI     LEF3E		;Bra if >, turn off AIR
;
        LDAB    L004E		;Load stored RTS timer
        BNE     LEF04		;Bra if !=0
;
        INCA 			;+1, 1 sec
;
;-Not in closed loop jumps here
;   
LEF02   STAA    L0076		;Save O2 lean timer
LEF04   LDAA    L0024		;SD MAP
        CMPA    LD46C		;22.5 kPa
        BCS     LEF3E		;Bra if SD MAP less, turn off AIR
;
        CMPA    LD472		;99.6 kPa
        BHI     LEF2C		;Bra if SD MAP is higher
;
        LDAA    L0020		;Load CTS
        CMPA    LD471		;80 deg C
        BCC     LEF2C		;bra if cool temp is less, turn on air to cat
;
        LDAA    L0030		;MPH
        LDAB    LD005		;Opt byte
        BITB    #$0001		;Test b0, use rpm/mph
        BNE     LEF22		;Bra if ==1, use MPH
;
        LDAA    L001B		;RPM/25
;
LEF22   CMPA    LD473		;20 MPH, MPH thresh to turn on AIR
        BHI     LEF2C		;Bra if speed is higher, turn on the air to manifolds/cat
;
        CMPA    LD474		;35 MPH, MPH thresh to turn off AIR 		
        BCC     LEF3E		;Bra if speed is greater, turn off air
;
LEF2C   LDAA    L0007		;Status word
        BMI     LEF38		;bra if b7==1, direct air to cat
;
;-Direct air to manifolds
;
LEF30   LDAB    L0007		;Load status word
        ANDB    #$00FE		;Clr b0 = Turn on AIR divert 
        ORAB    #$0004		;Set b2 = Turn on air select
        BRA     LEF44		;Bra
;
;-Direct air to cat
;
LEF38   LDAB    L0007		;Load status word
        ANDB    #$00FA		;clr b0=Turn on AIR divert, b2=Turn off AIR select
        BRA     LEF44		;BRa to save
;
;-Turn off air to manifolds and divert air flow to atmosphere
;
LEF3E   LDAB    L0007		;Satus word
        ORAB    #$0001		;Set b0 = Turn off AIR divert 
        ANDB    #$00FB		;Clr b2 = Turn off AIR select
;
LEF44   STAB    L0007		;Save status word
        LDAA    L0024		;Load SD MAP
        STAA    L0077		;Save it, SD MAP, one delayed
;
        CLRB    		;Pre clear B
        LDAA    L0040		;Load batt volts
        CMPA    #0171		;Comp. to 17.1 volts
        LDAA    L0002		;Load status word
        BCS     LEF5B		;Bra if batt volts were less
;
        BITA    #$0040		;Test b6, batt volts high
        BNE     LEF6F		;Bra if high batt volts flagged
;
        ORAA    #$0040		;Set b6, high batt volts.
        BRA     LEF5D		;Bra
;
LEF5B   ANDA    #$00BF		;Clr b6, batt volts within limits
;
LEF5D   STAA    L0002		;Save status word
        LDAA    L0001		;Status word
        BMI     LEF72		;Bra if motor is running
;
;-Engine off here
;
        LDAA    L000A		;Status word
        BMI     LEF6B		;Bra if b7==1, field service mode in effect
;
        CLRA  			;Clr, save for output 
        DECB    		;Clr b0 in 
        BRA     LEF9D
;
LEF6B   LDAA    #$00FD		;11111011, all on for field service mode
        BRA     LEF9D		;Bra
;
LEF6F   PSHB    		;B ----> Stack
        BRA     LEFA4		;Bra

LEF72   CLRA			;Clear A    
        LDAB    L0005		;Status word
        BPL     LEF79		;Bra if TCC unlocked/SL off
;
        ORAA    #$0008		;Set b3, turn on shiftlight
;
LEF79   BITB    #$0001		;Test b0, EGR passed quals.
        BEQ     LEF85		;Bra if no EGR
;
        LDAB    L000B		;Status word
        BITB    #$0004		;Test b2, EGR active
        BNE     LEF85		;Bra if 
;
        ORAA    #$0001		;Set b0
;
LEF85   LDAB    L0007		;Status word
        BITB    #$0004		;Test b4, Air select
        BEQ     LEF8D		;Bra if ==0, leave air select off
;
        ORAA    #$0010		;Set b4, turn on air divert solenoid
;
LEF8D   BITB    #$0001		;Test b0, Air divert 
        BNE     LEF93		;bra if ==1, leave air divert off
;
        ORAA    #$0020		;Turn on Air divert
;
LEF93   LDAB    L000E		;Status word
        BITB    #$0008		;Test b3, post downshift TCC lock delay in effect
        BEQ     LEF9B		;Bra if no downshift
;
        ANDA    #$00F7		;Clr b3, unlock TCC 
;
LEF9B   LDAB    L0080		;
;
LEF9D   PSHA			;A ----> stack, save for output
;
;-CCP purge
;    
        TST     LD008		;Opt byte
        BEQ     LEFA4		;Bra if b7==0
;
        COMB   			;Ones comp.
; 
LEFA4   CLRA			;Clr for output    
        ASLD    		;x2
        ASLD  			;x2  
        BEQ     LEFAB		;	
        ORAB    #$0003		;
;
LEFAB   ORAA    #$00D0		;
        STD     LBC18		;Save, CCP
;
; MCU2 I/O 
;
; In:
;   b7 = A/C Request
;   b6 = P/S Request
;   b5 = High Gear
;   b4 = Park/Neutral
; 
; Out:
;   b3 = TCC/Shift Light
;   b2 = A/C Drive
;   b1 = Air Divert (port soln.)
;   b0 = Air Select (Converter soln.) 
;
        LDAB    L0801		;MCU2 I/O
        ANDB    #$00F0		;Mask out upper 4 bits
;
        PULA    		;Retrieve for output
;
        BITA    #$0004		;Test b2, A/C on
        BEQ     LEFBC		;Bra if ==0
;
        ORAB    #$0004		;Turn on A/C drive output (non-existent)
;
LEFBC   BITA    #$0008		;Test b3, TCC/SL
        BEQ     LEFC2		;Bra if ==0
;
        ORAB    #$0008		;Turn on TCC/SL
;	
LEFC2   BITA    #$0010		;Test b4, Air select 
        BEQ     LEFC8		;Bra if ==0
;
        ORAB    #$0001		;Set b0, tun on Air select
;
LEFC8   BITA    #$0020		;Test b5, Air divert
        BEQ     LEFCE		;Bra if ==0
;
        ORAB    #$0002		;Turn on air divert solenoid
;
LEFCE   STAB    L0801		;Save to MCU2
;
;-Do EGR output
;
        ASRA    		;Test b0, EGR active
        BCC     LEFF1		;BRa if no EGR
;
        LDD     LBC16		;EGR
        TST     LD005		;Test option byte (==0)
        BPL     LEFE5		;Bra if b7==0
;
        SUBD    LD1D1		;$4FF
        CMPA    #$00D0		;
        BLS     LEFF6		;Bra if <=
;
        BRA     LEFF9		;Bra to sore
;
LEFE5   ADDD    LD1D1		;$4FF
        CMPA    #$00D3		;
        BLS     LEFF9		;Bra if <=

LEFEC   LDD     #$D3FF		;1101 0011 1111 1111
        BRA     LEFF9		;
;		
LEFF1   TST     LD005		;Test opt. byte
        BMI     LEFEC		;Bra if b7==0
;
LEFF6   LDD     #$D000		;
LEFF9   STD     LBC16		;Save it, EGR
        RTS   			;  
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 12* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; -TCC/SL routine
;
LEFFD   LDAA    L0000		;Status word
        BITA    #$0010		;Test b4, engine shutdown in effect
        BNE     LF009		;Bra if shutting down
;
        LDAA    #0159		;159		
        CMPA    L0032		;VSS interval counter
        BHI     LF00D		;Bra if >
;
;-Vehicle stopped here		
;
LF009   CLRA   			; 
        CLRB  			;  
        BRA     LF02D		;
;
;-Calculate current speed
;
LF00D   LDD     L0035		;VSS, one delayed
        SUBD    L0033		;- current VSS
        STD     L0049		;Tmp storage
;
        LDD     L0037		;VSS, two delayed
        SUBD    L0035		;-VSS, one delayed
        ADDD    L0049		;Add in (VSS, one delayed - VSS)
        RORA    		;
        RORB    		; 
        STD     L004B		;tmp storage
;
        STD     L004F		;tmp storage
        LDD     #$01CC		;min value for VSS 
        JSR     LFBE5		;Div. routine
;
        LDX     L0030		;Load mph
        LDAB    LD491		;253, Filter coeff.	
        JSR     LFB44		;Lag filter routine
LF02D   STD     L0030		;Save it, mph
;
;		    (14 x VSS value)
;RPM/drive ratio = ------------------ x (rpm/25)
;	                65536
;
        LDAA    L001B		;rpm/25
        LDX     #L004F		;VSS value
        JSR     LFC0C		;(A x X*)/256
        STD     L004F		;Save it to tmp storage
        LDAA    #0014		;
        JSR     LFC0C		;(A x X*)/256
        TSTA  			;Test to see if A==0  
        BEQ     LF043		;Bra if ==0
;
        LDAB    #$00FF		;Load max value
;
LF043   STAB    L007D		;Save it, rpm/drive ratio
        LDAA    LD007		;Load opt. byte
        BPL     LF04D		;Bra if TCC selected
;
        JMP     LF13C		;Bra to do shift light
;
;~~~~~~~~~~
;-TCC here
;~~~~~~~~~~
;
LF04D   LDAB    L0801		;Load in MCU2 I/O
        ANDB    #$0020		;Clr all but b5, high gear
        STAB    L0050		;Save to tmp storage
        LDAA    L0020		;Load cool temp.
        CMPA    LD48A		;60 deg C, min cool temp for TCC lockup
        BLS     LF05E		;Bra if cool temp is greater
;
LF05B   JMP     LF121		;Bra to unlock the TCC
;
LF05E   LDAA    LD005		;Opt byte
        BITA    #$0002		;test b1, unlock the tCC when in DFCO
        BEQ     LF06B		;Bra if ==0
;
        LDAA    L0007		;Load status word
        BITA    #$0008		;Test b3, DFCO 
        BNE     LF05B		;Bra if in DFCO, unlock the TCC
;
LF06B   LDX     #LD48B		;Start addr of quals
        LDAA    L0005		;Status word
        LDAB    $0001,X		;5 mph
        BITA    #$0010		;Test b4,
	BNE     LF07A		;Bra if ==1
;
        ADDB    #0005		;+5 mph
        BCS     LF07E		;Bra if overflow
;
LF07A   CMPB    L0030		;mph
        BLS     LF084		;Bra if less then current speed
;
LF07E   ANDA    #$00EF		;Clr b4, 
        LDAB    $0002,X		;10, 3.92% TPS
        BRA     LF088		;
;
LF084   ORAA    #$0010		;Set b4, 
        LDAB    $0003,X		;10, 3.92% TPS 
LF088   STAA    L0005		;Save status word
        BPL     LF091		;Bra if b7==0, TCC not commanded to lock
;
        SUBB    $0004,X		;- 5,  2.0% TPS
        BCC     LF091		;bra if no underflow
;
        CLRB    		;Clr underflow
;
LF091   PSHB 			; ----> stack   
        JSR     LFA7E		;Jump to get SD MAP/TPS	
        LDAB    LD48B		;3, use TPS/addr. offset for TCC load limits lookup
        CMPB    #$0003		;
        BNE     LF09F		;Bra if !=3, using SD MAP instead
;
;-Use %TPS for min thresh to lock
;
        JSR     LFBC4		;Go do baro adjust of TPS
;
LF09F   PULB   			;Get %TPS val off the stack 
        CBA   			;Compare %TPS to val.  
        BCS     LF05B		;Bra if %TPS is less
;
        LDX     #LD4AF		;Start addr. of high gear TCC tresh
        LDAA    L0050		;Get high gear status from tmp storage
        BEQ     LF0AD		;Bra if in high gear
;
        LDX     #LD495		;Low gear TCC thresh
;
LF0AD   LDAB    #0014		;Addr offset to skip to TCC unlocked limit
        LDAA    L0005		;Status word
        BPL     LF0B7		;Bra if b7==0, TCC not locked
;
;-TCC locked here
;
        INX     		;+1
        INX     		;+1
        LDAB    #$0001		;Addr offset for TCC load limits lookup
;
;-Bra here if TCC not locked
;
LF0B7   LDAA    L0030		;Load mph
        CMPA    $0000,X		;MPH threshold 
        BCS     LF121		;Bra if mph are less, unlock TCC
;
        INX  			;current addr +1   
        CMPA    $0000,X		;Max speed for TCC to lock 
        BCC     LF121		;Bra if speed is >=, unlock TCC
;
        ABX  			;Add in addr offset to X, start of load limit tables   
        LDAA    L0005		;Status word
        BPL     LF0D9		;Bra if b7==0, TCC not locked
;
;-TCC locked here
;
        LDAA    LD006		;Status word
        BITA    #$0002		;Test b1, use mph instead of RPM for lookup
        BEQ     LF0D9		;Bra if ==0
;
        LDAB    #$0060		;2400 rpm offset
        LDAA    L001A		;scaled rpm	
        ASLA   			;x2 
        BCC     LF0D7		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
LF0D7   BRA     LF0E9		;Bra to do lookup
;
;-Jump here if TCC not locked here
;
LF0D9   LDD     L0030		;Load mph
        ASLD   			;x2 
        BCS     LF0E5		;Bra if no overflow
;
        ASLD  			;x2  
        BCS     LF0E5		;
;
        CMPA    #0240		;MPH x4, 60 mph 	
        BCS     LF0E7		;Bra if less
;
LF0E5   LDAA    #0240		;Load max, 60 mph
;
LF0E7   LDAB    #0080		;20 mph offset
LF0E9   JSR     LFB77		;2D lookup with SBA
;
        BEQ     LF121		;Bra if ==0
;
        PSHA    		;Push thresh to stack
        JSR     LFBC4		;Do baro adjust of tps
;
        PULB   			;Get thresh off stack 
        CBA   			;Compare %TPS to thresh   
        BHI     LF121		;Bra if %TPS is greater, go unlock the TCC
;
        LDAB    L000E		;Load status word
        BITB    #$0008		;Test b3, post downshift TCC lock delay in effect 
        BEQ     LF105		;Bra if no delay in effect
;
        DEC     L007C		;post downshift TCC lock delay timer
        BNE     LF114		;Bra if !=0
;
        ANDB    #$00F7		;Clr TCC lock delay in effect
        BRA     LF114		;Bra
;
LF105   LDAA    L0050		;tmp storage, high/low gear status bit
        BEQ     LF114		;Bra if in high gear
;
        BITB    #$0020		;Test b5, high/low gear status on last pass	
        BNE     LF114		;Bra if still in low hear
;
        ORAB    #$0008		;Set b3, post downshift TCC lockup delay in effect
        LDAA    LD492		;1.5 secs
        STAA    L007C		;Save it, post downshift lockup delay timer
;
LF114   LDAA    L007B		;TCC relock delay timer
        BEQ     LF11B		;Bra if ==0, lock TCC
        DECA    		;-1
        BRA     LF126		;Bra to save
;
;-Here to set b7 in L0005 to command the TCC to lock
;
LF11B   LDAA    L0005		;Status word
        ORAA    #$0080		;Lock TCC
        BRA     LF133		;Bra 
;
;-Here to unlock TCC
;
LF121   LDAB    L000E		;Status word
        LDAA    LD493		;TCC relock delay timer
LF126   STAA    L007B		;Save it, 
        LDAA    L0030		;mph
        CMPA    LD494		;255 mph, mand lockup speed for TCC
        BCC     LF11B		;Bra if >=, lock the TCC
;
        LDAA    L0005		;Status word	
        ANDA    #$007F		;Clr b7, dont lock TCC
LF133   ANDB    #$00DF		;Clr b5, in high/low gear on last pass
;
        ORAB    L0050		;Set b5=low gear if low gear was flagged
        STAB    L000E		;Save status word
LF139   STAA    L0005		;Save status word
        RTS    			;Return 
;
;~~~~~~~~~~~~~~~~~~~
;-Shift light stuff
;~~~~~~~~~~~~~~~~~~~
;
LF13C   LDX     #LD4CD		;Start addr. of shiftlight stuff
        LDAA    L0020		;Cool temp
        CMPA    $0010,X		;15 deg C, min temp for shiftlight
        BCC     LF177		;Bra if cool temp is less
;
        LDAA    $0011,X		;12.5% tps, min tps for shiftlight
        LDAB    L007C		;Gear #
        CMPB    #0002		;2nd gear
        BLS     LF14F		;Bra if timer is less
;
        LDAA    $0012,X		;14.9% tps, min tps for shiftlight in higher gears
;
LF14F   CMPA    L0043		;%TPS
        BHI     LF177		;Bra if %TPS is less, turn of the shiftlight
;
        LDAA    L0030		;mph
        CMPA    #0005		;5 mph
        BCS     LF177		;Bra if mph less, turn off shiftlight
;
        LDAA    L001B		;Load rpm/25
        CMPA    $0013,X		;4200 rpm, mand rpm to activate shift light
        BHI     LF18B		;Bra if rpms greater, turn on the shift light
;
        CMPA    #0040		;1000 rpm mand. speed to turn off shift light
        BCS     LF177		;Bra if rpm/25 is less
;
;-Figure out what gear the trans is in
;
        LDAB    L007D		;rpm/drive ratio
        CLRA 			;   
LF166   INCA  			;+1  
        STAA    L007C		;Gear #
        CMPB    $0000,X		;UL for gear
        BHI     LF171		;Bra if greater, advance to next addr. and repeat
;
        CMPB    $0004,X		;LL for gear
        BHI     LF191		;Bra if greater, continue with S/L routine
;
LF171   INX 			;addr. +1   
        CPX     #$D4D0		;Last addr of limits
        BLS     LF166		;Loop if <=
;
;-Here to turn off the shift light and return
;
LF177   LDAA    LD4E1		;0, delay value for low gear
        LDAB    L007C		;Gear #
        CMPB    #0002		;2nd gear	
        BLS     LF183		;bra if less, save and  return
;
        LDAA    LD4E2		;0, delay value for higher gears
;
LF183   STAA    L007B		;Delay timer to turn on shiftlight
        LDAA    L0005		;Status word
        ANDA    #$007F		;Clr b7, turn off shift light
        BRA     LF18F		;Bra
;
;-Turn on the shift light and return
;
LF18B   LDAA    L0005		;Status word
        ORAA    #$0080		;Set b7, turn on shift light
LF18F   BRA     LF139		;Bra to return
;
LF191   LDAA    L001B		;Load rpm/25
        CMPA    $0008,X		;table of zero's
        BLS     LF177		;Bra if rpms are <=, turn off shift light
;
        PSHX    		;Curr addr ----> stack
        JSR     LFBC4		;Do baro ajdust of TPS
        PULX  			;Get addr back off the stack  
        LDAB    $000C,X		;
        MUL    			;(TPS x value)		 
        ASLD   			;x2 
        BCS     LF1A7		;Bra if overflow
        ADDD    #0128		;+128, round up 
        BCC     LF1A9		;Bra if no overflow
;
LF1A7   LDAA    #$00FF		;Clr overflow
;
LF1A9   PSHA  			;  
        LDX     #LD499		;Table for low gear	
        LDAB    L007C		;Gear #
        CMPB    #0002		;2nd gear
        BLS     LF1B6		;Bra if in first
;
        LDX     #LD4B3		;Table for higher gears
;
LF1B6   LDAB    #0011		;Addr offset
        LDAA    L0005		;Status word
        BMI     LF1BD		;Bra if S/L already on
;
        ABX     		;Add in offset, 
;
LF1BD   LDAB    #0040		;1000 rpm offset
        LDAA    L001B		;RPM/25
        CMPA    #0200		;5000 rpm, max value
        BCS     LF1C7		;Bra if rpms less
;
        LDAA    #0200		;Load in max value
;
LF1C7   JSR     LFB77		;2D lookup with SBA
        PULB    		;Get value from tps calc
        CBA  			;Compare looked up value vs rpm to tps value
        BCS     LF177		;bra if value from lookup vs rpm is less, turn off shiftlight 
;
        LDAA    L007B		;delay timer to turn on shiftlight
        BEQ     LF18B		;bra to turn on shiftlight
;
        DECA  			;-1  
        BRA     LF183		;Bra to return
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 10* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-CCP control
;
LF1D5   LDAA    L0002		;Status word
        BITA    #$0020		;Test b5, in ALDL mode
        BNE     LF20A		;Bra if ==1, in ALDL mode
;
        LDAA    L0007		;Load status word
        BITA    #$0008		;Test b3, DFCO flag
        BNE     LF20A		;Bra if ==1, DFCO active
;
;-No DFCO or ALDL mode here
;
        LDX     #LD476		;Addr of quals 
        LDAA    L0080        	;CCP
        BEQ     LF1EB		;Bra if ==0
;
        LDX     #LD477		;Alternate addr. of quals for CCP active
;
LF1EB   LDAB    L0030		;MPH
        CMPB    $0000,X		;2, 1 MPH
        BLS     LF208		;Bra if speed is less
;
        LDAB    L0043		;Load %TPS
        CMPB    $0002,X		;6.3%, 2.0%
        BHI     LF21A		;Bra if %TPS is greater
;
        LDAB    LD006		;Opt byte
        BITB    #$0004		;Test b4
        BNE     LF208		;Bra if ==1
;
        LDAB    L00DE		;Status word
        BITB    #$0040		;Test b6, VSS err
        BNE     LF208		;Bra if ==1, VSS err.
;
        BITB    #$0010		;Test b4 of L00DE
        BNE     LF20A		;Bra if ==1, turn off CCP
;
LF208   BSR     LF210		;
;
;-Here to disable CCP
;
LF20A   CLRA    		;
        STAA    L0082		;Clr 
        JMP     LF293		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;> Routine to set b4 of L00DE and clr L0081
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF210   CLR     L0081		;
        LDAB    L00DE		;Status word
        ANDB    #$00EF		;Clr b4
        STAB    L00DE		;Save status word
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF21A   LDAB    L00DE		;Status word
        BITB    #$0010		;Test b4, 
        BEQ     LF222		;Bra if ==0
;
        LDAA    L0081		;
;
LF222   LDAB    L002D		;Load vacuum
        CMPB    LD47A		;16 kPa
        BHI     LF24C		;Bra if vacuum is less
;
        LDAB    L0082		;
        CMPB    LD475		;1
        INCB    		;+1
        BCS     LF288		;Bra if < 1
;
        LDAB    L00A5		;INT
        CMPB    LD47B		;120
        BCC     LF245		;Bra if INT >=
;
        CMPB    LD47C		;100
        BCC     LF24C		;Bra if int >=
;
;-Here if INT < 100
;
        SUBA    LD47E		;2
        BHI     LF24C		;Bra if > 2
;
        CLRA    		;Clr
        BRA     LF24C		;Bra
;
;-Here if INT is >= 120
;
LF245   ADDA    LD47D		;8
        BCC     LF24C		;bra if no underflow
;
        LDAA    #$00FF		;Clr underflow
;
;-Here if INT is >= 100
;
LF24C   LDAB    L000E		;Status word
        BMI     LF257		;Bra if in closed loop
;
;-Not in closed loop here
;
        LDAB    LD005		;Opt byte
        BITB    #$0008		;Test b3, CCP in progress
        BEQ     LF20A		;Bra if ==0, not presently purging CCP
;
;-In closed loop here
;
LF257   CMPA    LD1EE		;166
        BLS     LF274		;Bra if <=
;	
        LDAB    L0030		;MPH
        CMPB    LD47F		;20 MPH
        BLS     LF274		;Bra if speed <= 20 MPH
;
        LDAB    L00A4		;BLM
        CMPB    LD480		;112
        BLS     LF274		;Bra if BLM <= 112
;
;-Speed > 20 mph, BLM > 112
;
        STAA    L0081		;Save value
;
        LDAB    L00DE		;Status word
        ORAB    #$0010		;Set b4, 
        STAB    L00DE		;Save it
        BRA     LF288		;Bra
;
;-Here if speed <= 20 MPH / BLM <= 112
;
LF274   BSR     LF210		;clr L0081, clr b4 in L00DE
        PSHA    		;
        LDAA    L002D		;Load Vacuum
        LSRA    		;/2
        LDX     #LD481		;table of Values to be used for CCP
        JSR     LFB7B		;Go do 2D lookup
;
        PULA    		;Get CCP value back
        CMPA    L0049		;tmp storage, value from lookup
        BLS     LF287		;Bra if <=
;
        LDAA    L0049		;Tmp storage
;
LF287   CLRB  			;Clr
;
;
;  
LF288   STAB    L0082		;
;
;~~~~~~~~~~
;-Do HU
;~~~~~~~~~~
;
        LDAB    L0000		;Status word
        BITB    #$0002		;Test b1, do HU
        BEQ     LF293		;Bra if ==0, no HU
        JSR     L5806		;Go do HU
;
;
;
LF293   LDAB    L0005		;Status word
        ANDB    #$00F7		;Clr b3, CCP in progress bit
        STAA    L0080		;Store/clr L0080, used in CCP	
        BEQ     LF29D		;Bra if ==0
;
        ORAB    #$0008		;Set b3, CCP in progress
;
LF29D   CMPB    L0005		;Compare to status word
        BEQ     LF2A3		;Bra to save if b3 already set
;
        ORAB    #$0002		;Set b1, CCP has changed state 
;
LF2A3   STAB    L0005		;Save status word
        RTS   			;Return
;	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 8* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-IAC and idle control
;
LF2A6   LDAA    L0066		;RTS counter
        BITA    #$0010		;Test b5 of the counter
        BEQ     LF2AD		;Bra if ==0, time to run the routine
;
        RTS     		;Else, return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF2AD   LDAA    L0030		;MPH
        CMPA    LD513		;5, 5 mph
        BCS     LF2B7		;Bra if mph are less
;
        CLR     L00CD		;Clr IAC trim (-)
;
LF2B7   LDAA    L0010		;Status word
        LDAB    L0002		;Status word
        BITB    #$0020		;Test b5, idling in ALDL mode
        BEQ     LF2C6		;Bra if not in aldl mode
;
;-In aldl mode here
;
        LDAB    LD4FE		;80, 1000 rpm, ALDL target idle speed 
        STAB    L00D0		;Save, target idle speed
        BRA     LF2D2		;Bra
;
LF2C6   LDAB    LD4FF		;58, 725, target idle speed, no A/C
        BITA    #$0008		;Test b3 of L0010
        BEQ     LF2D0		;Bra if A/C not requested
;
        LDAB    LD4FD		;60, 750 rpm, target idle speed, A/C req.
;
LF2D0   STAB    L00D0		;Save it, target idle speed 
LF2D2   BITA    #$0040		;Test b6 of L0010
        BEQ     LF338		;Bra if  ==0, not decaying out steps
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;Time to decay out some IAC steps
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Load low mph T/F decay coeff
;
        LDAA    LD506		;48, T/F decay coeff for low mph
        LDAB    L0030		;mph
        CMPB    LD50B		;5 mph, compare mph to threshold
        BCS     LF2EB		;Bra if mph less
;
;-Load mid mph T/F decay coeff
;
        LDAA    LD507		;48, decay coeff for mid mph
        CMPB    LD50C		;20 mph, compare mph to threshold
        BCS     LF2EB		;Bra if mph are less
;
;-Load high mph T/F decay coeff
;
        LDAA    LD508		;
;
LF2EB   STAA    L004F		;Tmp storage
        LDAA    L00C9		;T/F steps
        CMPA    L00C7		;T/F steps, filtered
        BHI     LF30A		;Bra if T/F steps > fitered T/F steps 
;
;-T/F steps decreasing here
;
        LDAA    LD50D		;4, min T/F steps
        CMPB    LD50B		;5 mph, compare current mph to
        BCS     LF2FF		;Bra if mph are less then threshold
;
        CMPA    L00C9		;T/F steps
        BCC     LF301		;Bra if T/F steps are less then 4
;
LF2FF   LDAA    L00C9		;load in T/F steps
;
LF301   LDX     L00C7		;T/F steps, filtered
        LDAB    L004F		;Decay coeff
        JSR     LFB44		;Lag filtered routine
        STD     L00C7		;Save as filtered T/F steps
;
;-Decay IAC steps in L00C3 to zero
;
LF30A   LDX     L00C3		;IAC steps
        LDAB    LD509		;20, decay coeff.
        CLRA    		;Clr A, decay acc. steps to zero
        JSR     LFB44		;Lag filter routine
        STD     L00C3		;Save steps
;
;-Decay out stall saver steps
;
        LDX     L00C5		;Stall saver steps
        LDAB    LD50A		;64, decay coeff
        CLRA    		;clr A
        JSR     LFB44		;Lag filter routine
        STD     L00C5		;Save stall saver steps
;
;-Test if any remaining steps to be decayed out
;
        ORAA    L00C7		;T/F steps, filtered
        ORAA    L00C3		;IAC steps, filtered
        BNE     LF32C		;bra if steps still present
;
        LDAA    L0010		;Status word
        ANDA    #$00BF		;Clr b6, decay IAC steps
        STAA    L0010		;Save status word
;
LF32C   LDAB    L0010		;Status word
        BITB    #$0020		;Test b5, engine speed lower then target idle speed
        BNE     LF34C		;Bra if ==1
;
        LDAA    L00CE		;IAC trim (+)
        BEQ     LF350		;Bra if ==0
        BRA     LF34C		;
;
LF338   LDAA    L0000		;Status word
        BITA    #$0002		;Test b1,
        BEQ     LF34C		;Bra if ==0
;
        LDAA    L0011		;
        ANDA    #$00F0		;Mask out upper 4 bits 
        BEQ     LF34C		;Bra if ==0
;
        CMPA    #$0080		;1000 0000
        BEQ     LF34C		;bra if == 
;
        CMPA    #$0090		;1001 0000
        BNE     LF350		;Bra if !=
;
;-Check if engine is on
;
LF34C   LDAA    L0001		;Status word
        BMI     LF356		;Bra if engine is running
;
;-Engine off/no idle adj here
;
LF350   LDAA    LD4EB		;0
        STAA    L00CA		;Save it, idle adj. delay timer
        RTS     		;Return 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Engine on here
;
LF356   LDAA    L00CA		;Idle adj. delay timer
        BEQ     LF35E 		;Bra if ==0, adjust the idle
;
        DECA    		;-1, idle delay timer
        STAA    L00CA		;Save it
        RTS     		;Return 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;Do idle speed ajustment
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LF35E   LDAA    L0010		;Status word
        BPL     LF36E		;bra if b7==0, stall saver not in effect
;
;-Stall saver in effect here
;	
        LDAA    LD4E6		;625 rpms, stall saver exit threshold	
        ADDA    LD4EE		;+12.5 rpm, margin for no idle adjustment  
        BCC     LF370		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
        BRA     LF370		;Bra
;
;-Stall saver not in effect here
;
LF36E   LDAA    L00D0		;Target idle speed
;
LF370   STAA    L00D1		;Target idle speed, idle logic	
        LDX     #LD4E8		;Table of timer values
;
        SUBA    L001D		;Subtract rpm/12.5 from desired idle speed
        BHI     LF382		;Bra if rpms are lower then desired idle speed
;
;-RPMs higher then desired idle speed
;
        NEGA    		;2s comp		
        CMPA    LD4EC		;50 rpm, delta rpm thresh for fast idle adjust. 
        BLS     LF38A		;Bra if delta rpms are less
;
        INX     		;+1, adv. to next addr.
        BRA     LF38A		;Bra
;
;-RPMs lower then desired idle speed
;
LF382   INX 			;+1    
        INX  			;+1   
        CMPA    LD4ED		;50 rpm, thresh. for fast idle adj.
        BLS     LF38A		;Bra if delta rpms <=
        INX  			;+1
;  
;-Load delay timer and check if in drive/park,neut.
; 
LF38A   LDAB    $0000,X		;Load in idle ajust delay timer val.
        LDAA    L0010		;Status word
        BITA    #$0010		;Test b4, in P/N
        BEQ     LF3A0		;Bra if in drive
;
;-In park/neutral
;
        LDAA    L001D		;rpms/12.5
        CMPA    LD504		;1000 rpm, max idle speed
        BHI     LF3A0		;Bra if idle speed is greater
;
        LDAA    L00CC		;IAC steps added in for A/C on	
        BEQ     LF3A0		;Bra if no added IAC steps
;
        LDAB    LD4F4		;1, delay for idle adjust if A/C turned on
;
;-In drive
;
LF3A0   STAB    L00CA		;Idle adjust delay timer
        LDAA    L00CC		;IAC steps added in for A/C on
        BEQ     LF3A9		;Bra if no steps added in for A/C on
;
        DEC     L00CC		;decay out A/C on steps
;
LF3A9   LDAB    L0003		;Status word
        ANDB    #$007F		;Clr b7,
; 
        LDAA    L00D1		;Load desired idle speed, idle logic
        SUBA    L001D		;rpm/12.5
        BCC     LF3B5		;Bra if rpms are less then desired idle speed
;
;-rpms greater then desired idle speed here
;
        ORAB    #$0080		;Set b7, engine speed too high
;
;-rpms less then or equal to desired idle speed
; 
LF3B5   STAB    L0003		;Save status word
        BPL     LF3BA		;bra if engine speed is <= to desired idle speed
        NEGA    		;2s comp.
;
LF3BA   CMPA    LD4EE		;12.5 rpm, margin for no idle adjsutment
        BHI     LF3C3		;bra if delta rpms are greater, adjust the idle
;
        CLR     L00CC		;Clr
        RTS     		;Return 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF3C3   LDAA    L0030		;mph
        BEQ     LF3CC		;Bra if car is stopped 
;
        LDAA    L0010		;Status word
        BPL     LF411		;bra if b7==0, stall saver not in effect
;
        RTS   			;Return   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Car at dead stop
;
LF3CC   LDAA    L0043		;%TPS
        CMPA    LD4E7		;5, 2.0% tps, max tps for idle adjustment
        BHI     LF411		;Bra if tps is greater
;
        LDAA    L0010		;Status word
        BITA    #$0020		;test b5, engine speed lower then target idle speed 
        BNE     LF423		;bra if ==1, force true idle speed adj.
;
        LDAA    L0002		;Status word	
        BITA    #$0020		;test b5, idling in aldl mode
        BNE     LF423		;bra if ==1, idling in aldl mode
;
        LDAA    L00CF		;IAC steps vs. cool temp (-kickdown steps if it has occured)
        BEQ     LF3F5		;Bra if added IAC steps vs. cool. is ==0
;
        LDAA    L00DF		;Status word
        BITA    #$0010		;Test b4, IAC kickdown occured	
        BEQ     LF410		;Bra if kickdown, return
;
        LDAB    L0020		;Cool temp, inv, A/D counts
        CMPB    LD512		;255, <-40 deg c, min temp to maintain engine speed below max allow speed
        BHI     LF410		;Bra if cool temp is less
;
        LDAA    LD503		;112, 1400 rpm, max cold engine speed
        BRA     LF3FE		;Bra
;
;-No added cool steps + kickdown occured
;
LF3F5   LDAA    L0010		;Status word
        BITA    #$0010		;Test b4, in P/N
        BEQ     LF423		;Bra if in drive, lead in to true idle speed adj.
;
        LDAA    LD504		;1000 rpm, max idle speed
;
LF3FE   LDAB    L0010		;Status word
        BITB    #$0040		;Test b6, decaying out IAC steps
        BNE     LF410		;Bra if ==1
;
        LDAB    L00CD		;IAC trim (-)
        CMPA    L001D		;compare to rpm/12.5
        BCC     LF410		;Bra if thresholds are greater then current engine speed
;
;-Engine speed too great
;
        INCB    		;+1, take out a step to reduce engine speed
        BNE     LF40E		;Bra if no rollover
;
        DECB  			;Roll IAC trim back to 255  
LF40E   STAB    L00CD		;Save IAC trim (-)
LF410   RTS  			;Return     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Car in motion, tps greater then closed thresh, no stall saver, 
; make sure the engine speed doesnt dip too low 
;
LF411   LDAA    L00CE		;IAC trim (+)
        LDAB    L0003		;Status word
        BPL     LF41D		;Bra if engine speed is less then desired idle speed
;
        TSTA    		;
        BEQ     LF420		;Bra if ==0
;
LF41A   DECA   			;-1, decay out IAC trim (+)
        BRA     LF420		;Bra to save
;
LF41D   INCA 			;+1, increase engine speed    
        BEQ     LF41A		;Bra if rollover
;
LF420   STAA    L00CE		;Save it, IAC trim (+)
        RTS    			;Return  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-In aldl mode/in drive, do true idle speed adjustment
;
LF423   CLR     L00CD		;Clr IAC trim (-)
        LDAA    L0010		;Status word
        LDAB    L0003		;Status word
        BPL     LF458		;Bra if engine speed is less then desired idle speed
;
;Engine speed is greater then desired idle speed here
;
        LDAB    L00CE		;IAC trim (+)
        BEQ     LF435		;Bra if ==0
;
        DECB  			;-1, decay it down 
        STAB    L00CE		;Save it, IAC trim (+)
        BRA     LF499		;Bra
;
LF435   BITA    #$0008		;Test b3, A/C req.
        BEQ     LF44E		;Bra if A/C req.
;
        LDAA    L00C2		;IAC steps, compared against L00E4
        LDAB    L00E4		;IAC steps vs. baro, idle control
        CBA     		;Compare IAC steps to IAC steps vs. baro
        BHI     LF446		;Bra if IAC steps are greater
;
        TSTB   			;Test  
        BEQ     LF444		;Bra if IAC steps vs. baro are ==0
;
        DECB   			;-1
; 
LF444   STAB    L00E4		;IAC steps vs. baro
LF446   TSTA    		;Test IAC steps
        BEQ     LF479		;Bra if ==0
;
        DECA  			;-1  
;
        STAA    L00C2		;Store it
        BRA     LF455		;Bra
;
LF44E   LDAA    L00E4		;IAC steps vs. baro
        BEQ     LF479		;Bra if ==0

        DECA   			;-1 
        STAA    L00E4		;Save it
;
LF455   JMP     LF499		;
;
;-Engine speed is less then desired idle speed
;
LF458   BITA    #$0008		;Test b3 of L0010
        BEQ     LF468		;Bra if A/C not req.
;-A/C on here
        LDAA    L00C2		;IAC steps, compared against IAC vs. baro steps
        CMPA    LD501		;70 steps, max IAC steps for idle adjust
        BCC     LF474		;Bra if IAC steps greater
        INCA    		;+1 to increase engine speed
        STAA    L00C2		;Save steps
        BRA     LF49C		;Bra
;
;-A/C off here
;
LF468   LDAA    L00E4		;IAC steps
        CMPA    LD502		;40, max allow base IAC steps
        BCC     LF474		;Bra if steps are greater
;
        INCA    		;+1 step to increase idle speed
        STAA    L00E4		;Save steps
        BRA     LF49C		;
;
;-IAC steps above threshold
;
LF474   DEC     L00FD		;Subtract one step from curr IAC steps if above thresh, force IAC to move 
        BRA     LF491		;bra
;
LF479   INC     L00FD		;+ one step to current IAC steps, force IAC to move
        LDAA    L001D		;Load in rpm/12.5
        SUBA    L00D0		;Sub out desired idle speed
        BCS     LF499		;Bra if rpms are less then desired idle speed
;
        SUBA    LD44B		;6, 75 rpm
        BCS     LF499		;Bra if delta rpms are less
;
        LDAB    L00D2		;
        CMPB    LD44D		;0
        BCC     LF491		;bra if greater
;
        INCB    		;+1
        BRA     LF49A		;Bra to save
;
LF491   LDAA    L0010		;Status word
        ANDA    #$00FC		;clr b0, b1
        STAA    L0010		;Save it
        BRA     LF49C		;
;
LF499   CLRB			;Clr
;    
LF49A   STAB    L00D2		;Save it, 
;
LF49C   LDAA    LD409		;Diag mask
        BITA    #$0001		;Test b0, VSS
        BEQ     LF4C7		;Bra if ==0
;
        LDAA    L00DE		;Status word
        BITA    #$0040		;Test b6, VSS err flagged
        BEQ     LF4C7		;BRa if ==0, return
;
;-VSS malf. here
;
        LDAB    LD4F0		;IAC park pos
        LDAA    L0010		;Status word	
        BITA    #$0008		;Test b3, A/C on 
        BNE     LF4BA		;Bra if ==1
;
        CMPB    L00E4		;Comp. IAC park pos. to IAC steps vs. baro
        BLS     LF4B8		;Bra if IAC park pos is less
;	
        STAB    L00E4		;Store IAC park pos as IAC pos vs. baro
LF4B8   BRA     LF4C7		;Bra
;
LF4BA   ADDB    LD4E3		;+18 steps if A/C is on.
        BCC     LF4C1		;Bra if no overflow
;
        LDAB    #$00FF		;Clr overflow
;
LF4C1   CMPB    L00C2		;Comp. to IAC steps
        BLS     LF4C7		;Bra if less	
;	
        STAB    L00C2		;Save as IAC steps
;
LF4C7   RTS  			;Return   
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 9* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Knock retard recovery lookup and 
;
LF4C8   LDAB    L0066		;RTS counter
        BITB    #$0010		;Test b4
        BNE     LF4F7		;Bra if ==1
;
;-Retard recovery rate lookup, done 5 times/sec
;
        LDAB    L000D		;Status word
        BMI     LF4DB		;Bra if in PE
;
;-Not in PE here
;
        LDX     #LD1A1		;Retard recovery rate vs Vac
        LDAA    L002D		;Load vacuum
        LDAB    #0072		;Load offset
        BRA     LF4E2		;Bra to do lookup
;
;-In PE here
;
LF4DB   LDX     #LD19C		;Retard recovery rate vs. rpm
        LDAA    L001B		;RPM/25
        LDAB    #0016		;Offset
;
LF4E2   LSRA  			;/2 for lookup  
        JSR     LFB69		;2D lookup with UL
;
;		 (Recovery rate x accumulated retard)
;-Recovery SA = --------------------------------------
;				256
;
;
        LDAB    L006E		;Accumulated knock retard
        MUL     		;(Recovery rate x accumulated retard)
        ADCA    #$0000		;round if necessary
        NEGA    		;2s comp, flip sign
        BNE     LF4F0		;Bra if != 0
;
        LDAA    #$00FF		;Load in min signed value
;
LF4F0   ADDA    L006E		;Add add it in
        BCS     LF4F5		;Bra if underflow
;
        CLRA    		;Clr underflow
;
LF4F5   STAA    L006E		;Save accumulated retard
;
;-Here if not doing knock recovery lookup
;
LF4F7   LDX     L007E		;filtered rpm/drive ratio
        LDAA    L007D		;rpm/drive ratio
        LDAB    LD036		;0, Filter coeff
        JSR     LFB44		;Lag filter routine
        STD     L007E		;Save it, filtered rpm/drive ratio
;
        LDAA    L006C		;Timer for knock retard alg.
        BEQ     LF50A		;Bra if ==0
;
        DEC     L006C		;-1, .1 sec
;
LF50A   LDAA    LD40B		;diag. mask
        BPL     LF533		;Bra if b7==0
;	
        LDAA    L006D		;Timer to test for runaway knock
        INCA    		;+1, .1 secs
        CMPA    #0039		;39, 4 secs.
        BCS     LF531		;Bra if <, dont perform test yet
;
        LDD     LBC0A		;Load knock counter
        STAA    L0049		;Save MSB
        LDAB    L0009		;Status word
        SUBA    L006B		;
        CMPA    LD454		;235, thresh for runaway knock 
        BCS     LF528		;Bra if <
;
;-Runaway knock in effect
;
        ORAB    #$0040		;Set b6, runaway knock in effect
        BRA     LF52A		;Bra
;
;-Knock within limits
;
LF528   ANDB    #$00BF		;Clr b6, runaway knock in effect
;
LF52A   STAB    L0009		;Save status word
        LDAA    L0049		;Load knock counts
        STAA    L006B		;Save them, knock counts, one delayed
        CLRA
;    
LF531   STAA    L006D		;Save timer for runaway knock test
LF533   RTS 			;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 14* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Diagnostics and error code handling
;
LF534   LDAB    L0066		;Load RTS timer
        LDAA    L0008		;Load status word
        ANDB    #$00F0		;Clr lower 4 bits
        BNE     LF546		;Bra if upper four bits !=0
;
;-One second has elapsed
;
        ORAA    #$0008		;Set b3 in L0008, one second has elapsed
        LDAB    L00EC		;engine run timer, LSB
        BITB    #$0001		;Test b0 of L00EC
        BNE     LF546		;Bra if ==1, 
;
        ORAA    #$0010		;Set b4 of L0008
;
LF546   STAA    L0008		;Save status word
        LDAA    L0881		;Load MCU1 I/O
        BITA    #$0040		;Test b6, cal12, (NETRES)
        BNE     LF555		;Bra if its present
;
        LDAA    L0014		;Err flag 3
        ORAA    #$0008		;Set b3, NETRES not present
        STAA    L0014		;Save err flag
;
LF555   LDAB    L000A		;Status word
        LDAA    L0002		;Status word
        BITA    #$0010		;Test b4, in field service mode
        BEQ     LF5BA		;Bra if not in field service mode
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-In field service mode here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        ORAB    #$0080		;Set b7 of L000A, field service mode in effect
        STAB    L000A		;Save it
        CLR     L0095		;Clear 
        LDAA    L0001		;Load status word
        BPL     LF5D4		;Bra if engine is off
;
;-Engine is on here
;
        LDAB    L000E		;Status word
        BMI     LF57A		;Bra if in closed loop
;
;-In open loop here
;
LF56C   LDAA    L0006		;
        ANDA    #$00F7		;Clr b3, 
        EORA    #$0040		;Toggle b6, alternate paths
        STAA    L0006		;Save status word
;
        BITA    #$0040		;Test b6
        BNE     LF5AF		;Bra if ==1 this time around
;
        BRA     LF5A5		;Else...
;
;-Here if in closed loop
;
LF57A   LDAA    L0006		;Status word
        BITA    #$0008		;Test b3, 
        BNE     LF595		;Bra if ==1
;
        LDAB    L0008		;Status word
        BITB    #$0008		;Test b3, one second has elapsed
        BEQ     LF56C		;Bra if ==0, one second hasnt elapsed yet
        ORAA    #$0008		;Set b3 of L0006
        STAA    L0006		;Save status word
;
LF58A   LDAB    L000E		;Load status word
        BITB    #$0040		;Test r/l indicator bit
        BEQ     LF5AC		;Bra if going leaner
;
LF590   JSR     LFC47		;SES light on if going richer
        BRA     LF5AF		;Bra 
;
LF595   LDAA    L0008		;Status word
        BITA    #$0008		;Test b3, one second has elapsed
        BEQ     LF5AF		;BRa if ==0, one second hasnt elapsed yet
;
        LDAA    L0006		;Status word
        BITA    #$0010		;Test b4
        BEQ     LF58A		;Bra if ==0
;
        ANDA    #$00EF		;Clr b4
        STAA    L0006		;Save status word
;
LF5A5   LDD     LBC3C		;PWM
        BITB    #$0008		;Test b3, test if SES light is already on 
        BNE     LF590		;Bra if SES light is already on
;
LF5AC   JSR     LFC52		;Going leaner, SES light off
;
LF5AF   CLR     L000C		;Status word, SES
        LDAA    L0006		;Status word
        ORAA    #$0004		;Set b2
        STAA    L0006		;Save it
        BRA     LF5EA		;Bra
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Not in field service mode here
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF5BA   ANDB    #$007F		;Clr b7 in L000A, no longer in field service mode
        STAB    L000A		;Save status word
;
        LDAA    L0006		;Status word
        ANDA    #$00E3		;Clr b2-b4 used in field service mode
        STAA    L0006		;Save status word
;
        CLR     L000C		;Status word
        LDAA    L0014		;Err flag 3
        ANDA    #$0010		;Clr all but b4
        BEQ     LF5D0		;Bra if b4=prom err not set
;
        JMP     LF9DA		;
;
LF5D0   LDAA    L0001		;Status mode
        BMI     LF5EA		;Bra if motor is on
;
;-Engine off 
;
LF5D4   LDAA    L0006		;Status word
        ANDA    #$00E3		;Clr b2-b4, used in field service mode
        STAA    L0006		;Save it
;
;-Clear timers used in diag. routines
;
        CLRA    		;Clear addr and jump
        STAA    L0088		;
        STAA    L0094		;
        STAA    L008C		;
        STAA    L0089		;
        STAA    L008A		;
        STAA    L008E		;
        JMP     LF926		;
;
;-See if stored codes can be reset
;
LF5EA   LDAA    L0008		;
        BITA    #$0002		;Test b1, 
        BNE     LF614		;Bra if ==0
;
        LDAB    L00EC		;engine run time, LSB
        CMPB    #0010		;10 secs
        BCS     LF614		;Bra if less
;
        ORAA    #$0002		;Set b1
        STAA    L0008		;Save status word
;
        INC     L00E9		;+1, # of err free starts
        LDAA    L00E9		;Load # of starts
        CMPA    LD40C		;50, 50 starts, number of clean starts to clear err codes
        BLS     LF614		;Bra if  <=
;
;-Clear malf. flags
;
        CLRA    		;
        STAA    L00E1		;Malf flag 1
        STAA    L00E2		;Malf flag 2
        STAA    L00E3		;Malf flag 3
        STAA    L00E9		;# of clean starts
        STAA    L000C		;Status word
        JSR     LFD2C		;Do checksum on err flags 
        STAA    L00EA		;Save, malf. flag checksum
;
LF614   LDAB    L0008		;Status word
        BITB    #$0024		;Test b2, b5, TPS err bits
        BNE     LF664		;Bra if !=0
;
        LDAA    L000A		;Load status word
        BITA    #$0040		;Test b6, been running for two min.
        BNE     LF62E		;Bra if ==1	
;
        LDD     L00EB		;Engine run timer
        LSRD    		;/2
        CMPB    LD411		;120 secs
        BCS     LF664		;Bra if engine run time is less
;
;-Been running for more then two mins.
;
        LDAA    L000A		;Status word
        ORAA    #$0040		;Set b6, been running for two min.
        STAA    L000A		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 13, O2 sensor failure
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Test O2 window
;
LF62E   LDAB    L0039		;Load in 02, filtered, A/D counts
        CMPB    LD413		;550 mV, upper O2 limit
        BHI     LF664		;Bra if >
;	
        CMPB    LD412		;350 mV, lower O2 limit
        BLS     LF664		;Bra if 02 is <
;
        LDAB    L008B		;O2 window err timer
        CMPB    LD415		;30, value to set err upon
        BHI     LF669		;Bra if >
;
        LDAA    L0008		;Load status word
        BITA    #$0010		;Test b4, 
        BEQ     LF66F		;Bra if ==0
;
        LDAB    L0020		;Load in cool temp
        CMPB    LD416		;70 deg C
        BHI     LF66F		;Bra if cool temp is less
;
        LDAA    L0043		;%TPS
        CMPA    LD414		;5% tps
        BHI     LF65F		;Bra if TPS is greater
;
        TST     L008B		;Test timer
        BEQ     LF66F		;Bra if ==0
;
        DEC     L008B		;-1
        BRA     LF66F		;
;
;-Here if %TPS is greater then 5%, start incrementing timer if O2 doesnt exit window
;
LF65F   INC     L008B		;+1 
	BRA     LF66F		;
;
;-Running for less then two mins./no err.
;
LF664   CLR     L008B		;O2 err timer
        BRA     LF66F		;Bra
;
LF669   LDAA    L0012		;Err flag 1
        ORAA    #$0040		;Set b6, O2 failure
        STAA    L0012		;Save status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 21, TPS high err.
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LF66F   LDAB    L0008		;Status word
        ANDB    #$00FB		;Clr b2,TPS high err
;
        LDAA    L0042		;A/D TPS
        CMPA    LD41C		;2.5 volts
        BLS     LF68D		;Bra if volts are less
;
        LDAA    L0088		;TPS err timer
        CMPA    LD41D		;80
        BHI     LF692		;Bra if >
;
        LDAA    L00FE		;Load in Baro press, A/D counts
        CMPA    LD41E		;51.7 kPa
        BCC     LF68D		;Bra if baro press is >=
;
        INC     L0088		;+1
        BRA     LF69A		;Bra
;
LF68D   CLR     L0088		;Clr TPS err. timer
        BRA     LF69A		;bra
;
;-Set error
;
LF692   LDAA    L0012		;err flag 
        ORAA    #$0008		;Set b3, TPS high
        STAA    L0012		;Save it
        ORAB    #$0004		;Set b2, TPS high err.
;
;~~~~~~~~~~~~~~
;-Code 24, VSS
;~~~~~~~~~~~~~~
;
LF69A   STAB    L0008		;Save status word
        LDAA    L0008		;Load status word
        LDAB    L00DE		;Status word
        BITA    #$00C0		;Test b6, b7, VSS/??? errors flagged.
        BNE     LF6CB		;Bra if VSS/??? err. flagged
;
        LDAA    L0030		;MPH
        CMPA    LD426		;5 mph, 
        BHI     LF6CB		;Bra if speed is higher
;
        LDAA    L0094		;VSS err timer
        CMPA    LD42A		;3 seconds, thresh to set err.
        BHI     LF6DD		;Bra if higher, set err.
;
        LDAA    L0027		;Raw MAP, A/D counts
        CMPA    LD429		;25.2 kPa, MAP threshold to set VSS error
        BCC     LF6CB		;bra if MAP is greater
;
        LDAA    L0010		;Status word
        BITA    #$0010		;Test b4, in P/N
        BNE     LF6CB		;Bra if in P/N
;
        LDAA    L001A		;Load scaled rpms
        CMPA    LD427		;800 rpm, RPM thresh to set err. 
        BLS     LF6CB		;Bra if rpms less
;
        CMPA    LD428		;4400 rpm
        BLS     LF6D2		;bra if rpms less, adv. err timer
;
;-Here to clear the timer
;
LF6CB   CLR     L0094		;VSS err timer
        ANDB    #$00BF		;Clr b6 of L00DE
        BRA     LF6E5		;Bra to save
;
LF6D2   LDAA    L0008		;Status word
        BITA    #$0008		;test b3, one second has elapsed
        BEQ     LF6E7		;Bra if ==0
;
        INC     L0094		;+1
        BRA     LF6E7		;Bra
;
;-Set error.
;
LF6DD   LDAA    L0012		;Err flag 1
        ORAA    #$0001		;Set b1, MAP output low
        STAA    L0012		;Save err flag
        ORAB    #$0040		;Set b6, VSS err.
LF6E5   STAB    L00DE		;Save status word
;
;~~~~~~~~~~~~~~~~~~~~~~
;-Code 32, EGR failure
;~~~~~~~~~~~~~~~~~~~~~~
;
LF6E7   LDAB    L000B		;Status word
        LDX     #LD40A		;Diag. mask
        LDAA    $0000,X		;Load it in
        BITA    #$0020		;test b5, EGR malf.
        BEQ     LF73B		;Bra if not flagging error
;
        BITB    #$0008		;Test b3, 
        BNE     LF73B		;bra if ==1
;
        BITB    #$0010		;Test b4, err timer has elapsed
        BNE     LF705		;Bra if ==1
;
        LDAA    L008E		;Err timer
        CMPA    $0022,X		;10
        BCS     LF748		;Bra if less
;
        ORAB    #$0010		;Set b4, timer has elapsed
        CLR     L008E		;Clr timer
;
LF705   LDAA    L0005		;Status word
        ASRA    		;Shift right, test b0, vac thresh for egr met
        BCC     LF73B		;Bra if ==0, dont perform test
;
        LDAA    L002D		;Load vacuum
        CMPA    $0023,X		;55 kPa, vac thresh to perform egr test
        BLS     LF73B		;Bra if vacuum is greater
;
        CMPA    $0024,X		;35 kPa, vac thresh to perform egr test
        BHI     LF73B		;Bra if vacuum is less
;
        LDAA    L0043		;Load %TPS
        CMPA    $0025,X		;9% tps, min tps for test
        BLS     LF73B		;Bra if %TPS is <=
;
        CMPA    $0026,X		;20% tps, max tps for test
        BHI     LF73B		;Bra if TPS is >
;
        SUBA    L0045		;- slow filtered %TPS
        BCC     LF723		;Bra if no underflow
;
        NEGA  			;2s comp, switch sign
;  
LF723   CMPA    $0029,X		;.4% delta TPS
        BHI     LF73B		;Bra if TPS is greater
;
        LDAA    L0030		;Load mph	
        CMPA    $002C,X		;50 mph, min speed for egr test
        BCS     LF73B		;bra if speed is less
;
        TST     LD007		;Test b7 in opt byte
        BMI     LF753		;Bra if shift light selected
;
        LDAA    L0801		;Load MCU2 I/O
        ANDA    #$0028		;Clr all but b3=TCC/SL, b5=high gear switch
        CMPA    #$0008		;Compare to 0000 0100, in OD, TCC locked 
        BEQ     LF753		;Bra if ==
;
;-Here to skip/exit egr test quals
;
LF73B   BITB    #$0004		;b2 in L000B
        BEQ     LF741		;Bra if ==0
;
LF73F   ANDB    #$00EF		;Clr b4, err timer elapsed
; 
LF741   ANDB    #$00FB		;Clr b2,
;
LF743   CLR     L008E		;Clr timer
LF746   BRA     LF7A2		;Bra 
;
;-Here if timer is less then thresh
;
LF748   LDAA    L0008		;Status word
        BITA    #$0008		;Test b3, one second has elapsed 
        BEQ     LF746		;Bra if ==0
;
;-Here to advance err. timer
;
LF74E   INC     L008E		;+1
        BRA     LF746		;Bra to skip code below if timer has not elapsed
;
LF753   LDAA    L007D		;rpm/drive ratio
        CMPA    $0032,X		;19
        BLS     LF73B		;Bra if less
;
        CMPA    $0031,X		;40
        BCC     LF73B		;Bra if drive ratio is greater
;
        LDAA    L002D		;Load vacuum in
        NEGA   			;2s comp., now rep. of manifold press. 
        BITB    #$0004		;Test b2 of L000B
        BNE     LF770		;Bra if ==1, vacuum val already saved
;
        STAA    L0091		;Save value
        LDAA    L008E		;Load timer in
        CMPA    $0027,X		;10 seconds
        BLS     LF74E		;Bra if timer is less
;
        ORAB    #$0004		;Set b2 of L000B
        BRA     LF743		;Bra to clear timer
;
LF770   SUBA    L0091		;Vacuum val. - delayed val.
        BCS     LF778		;Bra if < 0 
;
        CMPA    $002B,X		;2.5 kPa, delta pressure change  
        BCC     LF78D		;Bra if pressure change is greater
;		
LF778   LDAA    L008E		;Load timer	
        CMPA    $002A,X		;25 seconds
        BCS     LF74E		;Bra if timer is less
;
        LDAA    L0092		;timer
        INCA    		;+1
        CMPA    $0028,X		;2
        BCS     LF789		;Bra if less
;
        ORAB    #$0001		;Set b1 of L000B, egr test failed
        LDAA    $0028,X		;Load default value
;
LF789   STAA    L0092		;Save it
        BRA     LF73F		;Bra to clr status bits, timer, and set code if appl.
;
;-Here if egr passed
;
LF78D   LDAA    L0092		;timer
        SUBA    $002D,X		;-1
        BHI     LF789		;Bra if > 0
;
        CLRA    		;
        ANDB    #$00FE		;Clr b0 of L000B
        STAA    L0092		;clr timer
        LDAA    LD006		;Opt byte
        ASRA    		;Shift right
        BCC     LF73F		;Bra if b0==0
;
        ORAB    #$0008		;Set b3 of L000B
        BRA     LF73F		;Bra 
;
;-Here to set code 32, EGR failure
;
LF7A2   STAB    L000B		;Save status word
        BITB    #$0001		;Test b0, test failed
        BEQ     LF7B4		;BRa if b0==0, bra if ok
;
        LDAA    L0013		;Err flag 2
        ORAA    #$0020		;Set b5, EGR failure
        STAA    L0013		;Save it
;
        LDAA    L00DF		;Load status word
        ORAA    #$0020		;Set b5, EGR failure
        STAA    L00DF		;Save it
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 33, MAP sens high
;~~~~~~~~~~~~~~~~~~~~~~~~
;
LF7B4   LDAB    L0008		;Status word
        ANDB    #$00BF		;Clr b6
        BITB    #$0024		;Test b2, b4
        BNE     LF7DC		;bra if ==1
;
        LDAA    LD43E		;68 kPa, min baro value
        CMPA    L00FE		;Baro pressure
        BLS     LF7C5		;Bra if baro press is less
;
        LDAA    L00FE		;Load in baro pressure
;
LF7C5   CMPA    L0029		;A/D map
        BCC     LF7DC		;Bra if map is less
;
	LDAA    L008C		;err timer
        CMPA    LD43F		;50, timer thresh to set err.
        BHI     LF7E1		;Bra if err timer is greater
;
        LDAA    L0043		;Load %TPS
        SUBA    LD43D		;3.9% tps
        BCC     LF7DC		;Bra if tps is less
;
        INC     L008C		;+1
        BRA     LF7E9		;Bra 
 ;
LF7DC   CLR     L008C		;Clr timer
        BRA     LF7E9		;Bra 
;
;-Here to set code 33, MAP sensor high
;
LF7E1   LDAA    L0013		;Err flag 2
        ORAA    #$0010		;Set b4, map high
        STAA    L0013		;Save it
        ORAB    #$0040		;Set b6, map sens high
;
LF7E9   STAB    L0008		;Save status word
;
;~~~~~~~~~~~~~~~
;-Code 42, EST
;~~~~~~~~~~~~~~~
;
        LDAA    L0002		;Status word
        BITA    #$0008		;Test b3, In backup mode
        BNE     LF827		;Bra if in backup mode
;
        LDAA    L0066		;RTS timer
        BITA    #$0010		;
        BNE     LF827		;Bra if not time yet
;
        LDAA    L0001		;Status word
        BITA    #$0040		;Test b6, 
        BEQ     LF827		;Bra if ==1
;
        CLRB   			; 
        LDX     LBC06		;EST circuit
        LDAA    L0881		;MCU1 I/O 
        BITA    #$0020		;Test b5, cranking
        BEQ     LF823		;Bra if not in crank
;
        LDAA    L001A		;Load rpm/12.5
        CMPA    LD44E		;50 rpm
        BLS     LF823		;Bra if rpms are less
        CPX     L0096		;EST circuit data
        BNE     LF823		;Bra if !=
;
        LDAB    L0098		;EST err counter
        CMPB    LD451		;4
        BHI     LF81D		;BRa if greater
        INCB   			;+1 
        BRA     LF823		;Bra to save
;
;-Set err. here
;
LF81D   LDAA    L00DE		;Status word
        ORAA    #$0080		;Set b7, EST failure
        STAA    L00DE		;Save it
;
LF823   STAB    L0098		;Save EST err timer
        STX     L0096		;Save EST err data
;
;~~~~~~~~~~~~~~
;-Code 43, ESC 
;~~~~~~~~~~~~~~
;
LF827   LDAA    LD40B		;diag. mask
        BPL     LF899		;Bra if b7=0, not recognising ESC failure
;
        LDX     L00EB		;Engine run timer
        CPX     LD452		;50 secs
        BLS     LF899		;Bra if less
;
        LDAB    L0009		;Status word
        BPL     LF83B		;Bra if no knock detected
;
;-Knock detected here
;
        ANDB    #$00DF		;Clr b5, ESC failure
        BRA     LF897		;Bra
;
;-No knock detected here
;
LF83B   BITB    #$0020		;Test b6 of L0009, runaway knock in progress
        BNE     LF899		;Bra if true
;		
        LDAA    L0002		;Status word
        BITA    #$0038		;test b3-b5, ALDL status
        BNE     LF899		;Bra if in one of the three modes
;
        BITB    #$0010		;Test b4 of L0009, in PE, add PE SA to force knock 
        BEQ     LF857		;Bra if ==0
;
        BITA    #$0002		;Test b1 of L0002, cleared to perform ESC diag. routine
        BNE     LF857		;Bra if ==1
;
        LDAB    L000D		;Load status word
        BMI     LF899		;Bra if b7==1, in PE, dont set ESC error
;
;-Not in PE
;
        ORAA    #$0002		;Set b1, go do ESC test
        STAA    L0002		;Save 
        BRA     LF899		;Bra
;
;-Do ESC err. quals
;
LF857   LDAA    L000D		;Status word
        BPL     LF899		;Bra if not in PE
;
        LDAA    L0008		;Status word
        BITA    #$00C0		;Test b6, b7, MAP errs.
        BNE     LF899		;Bra if error(s) flagged
;
        LDAA    L0000		;Load status word
        ORAA    L00DE		;
        BMI     LF899		;Bra if EST err flagged
;
        LDAA    L000A		;Status word
        BITA    #$0008		;Test b3, CTS failure
        BNE     LF899		;Bra if CTS failure 
;
        LDAA    L001B		;RPM/25
        CMPA    LD458		;5625 rpm, max RPM to set ESC error.
        BHI     LF899		;Bra if rpms are greater
;
        LDAA    L0024		;Load SD map
        CMPA    LD459		;81.25 kPa, min map thresh to set ESC error
        BLS     LF899		;Bra if MAP is less
;
        LDAA    L0020		;Load cool temp, inv, A/D counts
        CMPA    LD456		;80 deg C, min temp to set ESC error
        BCC     LF899		;Bra if cool temp is less
;
        CMPA    LD457		;150 dec C, max temp to set ESC error
        BLS     LF899		;Bra if cool temp is greater
;
        LDAA    L0093		;ESC counter
        INCA    		;+1
        CMPA    LD455		;2, 3 passes for knock to be detected
        BLS     LF89A		;Bra if ESC timer is less
;
        BITB    #$0010		;Test b4 of L0009, 
        BEQ     LF895		;Bra ==0
;
        ORAB    #$0020		;Set b5, ESC failure
;
;-Last ditch effort to force knock
;
LF895   ORAB    #$0010		;Set b4, add in addl SA to force knock
;	
LF897   STAB    L0009		;Save status word
;
;-Here to exit/skip ESC diags.
;
LF899   CLRA  			;Clr ESC timer
;  
LF89A   STAA    L0093		;Save ESC counter
        LDAA    L0009		;Load status word
        BITA    #$0060		;Test b5, ESC failure, b6, runaway knock in progress
        BEQ     LF8A8		;Bra if ==0
;
;-Set code 43, ESC failure
;
        LDAA    L0014		;Err flag 3
        ORAA    #$0080		;Set b7, ESC failure
        STAA    L0014		;Save err flag
;
;~~~~~~~~~~~~~~~~~~
;-Code 44, O2 lean
;~~~~~~~~~~~~~~~~~~
;
LF8A8   LDAB    L000A		;Load status word
        ANDB    #$00FD		;Clr b1, O2 err
        LDAA    LD45D		;200 mV 
        CMPA    L003C		;RTS O2
        BLS     LF8CD		;Bra if O2>
;
        LDAA    L0089		;O2 lean err timer
        CMPA    LD45E		;50 secs
        BHI     LF8D2		;Bra if timer is greater
;
        LDAA    L000E		;Status word
        BPL     LF8CD		;Bra if not in closed loop
;
;-In closed loop
;
        BITB    #$0004		;Test b2, O2 rich test performed 
        BNE     LF8CD		;bra if ==1
;
        LDAA    L0008		;Status word
        BITA    #$0008		;Test b3, one second has elapsed
        BEQ     LF8DA		;Bra if ==0
;
        INC     L0089		;+1, O2 err. timer
        BRA     LF8DA		;Bra
;
;-Here if not in closed loop, dont set err.
;
LF8CD   CLR     L0089		;Clr O2 lean err timer
        BRA     LF8DA		;Bra
;
;-Here to set O2 lean error
;
LF8D2   LDAA    L0014		;Err flag 3
        ORAA    #$0040		;Set b6, O2 lean
        STAA    L0014		;Save it
        ORAB    #$0002		;Set b1 of L000A, O2 err.
;
;~~~~~~~~~~~~~~~~~~~~
;-Code 44, O2 rich
;~~~~~~~~~~~~~~~~~~~~
;
LF8DA   LDAA    L003C		;RTS O2
        CMPA    LD45F		;750 mV
        BLS     LF907		;Bra if less
;
        LDAA    L008A		;O2 rich err timer
        CMPA    LD460		;30 seconds
        BHI     LF90C		;bra if O2 rich err timer is greater
;
        LDAA    L000E		;Status word
        BPL     LF907		;Bra if not in closed loop
;
        BITB    #$0004		;Test b2 of L000A,
        BNE     LF907		;Bra if ==1
;
        LDAA    L0043		;%TPS
        CMPA    LD461		;20% TPS, min high tps to set err code
        BHI     LF8FC		;bra if tps is greater
;
        CMPA    LD462		;2.0% tps, max low tps to set err code
        BCC     LF907		;Bra if tps is >=
;
LF8FC   LDAA    L0008		;Status word
        BITA    #$0008		;Test b3, one second has elapsed
        BEQ     LF914		;Bra if ==0
;
        INC     L008A		;+1, O2 rich err timer
        BRA     LF914		;Bra 
;
;-Here to clr timer
;
LF907   CLR     L008A		;Clr timer
        BRA     LF914		;Bra
;
;-Set O2 rich err.
;
LF90C   LDAA    L0014		;Err flag 3
        ORAA    #$0020		;Set b5, O2 rich
        STAA    L0014		;Save it
        ORAB    #$0002		;Set b1, O2 err
;
LF914   ANDB    #$00FB		;Clr b2 of L000A
        STAB    L000A		;Save it
;
;-Set code 54, fuel pump relay if appl.
;
        LDAA    L0009		;status word
        ANDA    #$0002		;Clr all but b1, fuel pump relay malf.
        ORAA    L0014		;Set err if applicable
        STAA    L0014		;Save err flag 3.
;
        LDAA    L0006		;Status word
        BITA    #$0004		;Test b2,
        BNE     LF933		;Bra if ==1, skip rest of diags.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Misc. diagnostics and field service routines
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LF926   LDAA    L000A		;Status word
        BPL     LF92D		;Bra if b7==0, not in field service mode
;
	JMP     LF9EE		;Jump to blink out err codes
;
LF92D   LDAA    L0000		;Status word
        BITA    #$0010		;Test b4, engine shutdown in effect
        BEQ     LF936		;Bra if not shutting down
;
LF933   JMP     LF9DD		;Jump if shutting down
;
LF936   JSR     LFCDD		;Get diag masks into tmp storave
        LDAA    L0015		;Start addr. of stored err flags
        ORAA    L0016		;Checksum from fact. diags, MSB
        ORAA    L0017		;Checksum from fact. diags, LSB
        BNE     LF960		;Bra if !=0
;
        LDD     L0012		;Err flag 1 and err flag 2
        ANDA    L0049		;diag mask at LD409
        ANDB    L004A		;diag mask at LD40A
;	
        STD     L0015		;Save at L0015 + L0016
;
        LDAA    L0014		;Load err flag 3
        ANDA    L004B		;diag mask at LD40B
        STAA    L0017		;Save at L0017 
;
        LDAA    L0095		;
        BEQ     LF958		;Bra if ==0
;
        DEC     L0095		;-1
        BRA     LF9B9		;
;
LF958   LDAA    L000A		;Status word
        ANDA    #$00FE		;Clr b0
        STAA    L000A		;Save it
        BRA     LF9B9		;Bra
;
LF960   LDX     #$0003		;addr offset for err flags
        CLRA    		;
LF964   LDAB    $0011,X		;Err flag 3,2,1
        ANDB    $0014,X		;Stored masked err flag 
        ANDB    $0048,X		;Stored diag mask
        STAB    $0014,X		;Store it
        BEQ     LF96F		;Bra
        INCA  			;+1  
LF96F   DEX 			;curr addr. -1    
        BNE     LF964		;Bra if !=0, repeat
;
	INC     L0095		;+1
        LDAB    L000A		;Load status word
        TSTA   			;Test b7,field service mode 
        BNE     LF98B		;Bra if in field service mode
;
;-Not in field service mode
;
        ASRB 			;Test b0 of L000A   
        LDAB    LD40D		;10
        BCC     LF983		;Bra if b0==0
;
        LDAB    LD40F		;100
;
LF983   CMPB    L0095		;
        BHI     LF9B9		;
;
        STAB    L0095		;
        BRA     LF9B9
;
;-In field service mode
;
LF98B   ASRB    		;Test b0 of L000A
        LDAB    LD40E		;20
        BCC     LF994		;Bra if b0==0
;
        LDAB    LD410		;120
LF994   CMPB    L0095		;
        BHI     LF9B9		;
;
        LDAA    LD40F		;100
        STAA    L0095		;Save it
        LDAA    L000A		;Status word
        ORAA    #$0001		;Set b0
        STAA    L000A		;Save it
;
        CLRB    		;Clr 
        LDX     #$0003		;Addr offset 
LF9A7   LDAA    $00E0,X		;Load in malf. flags 1,2,3
        ORAA    $0014,X		;Stored err. flags
        STAA    $00E0,X		;Save the malf. flag
        STAB    $0014,X		;Clr stored masked err flag
        DEX    			;curr. address-1 
        BNE     LF9A7		;Bra if !=0, repeat
;
        STAB    L00E9		;Reset # of clean starts
        JSR     LFD2C		;Go do chksum on malf. flags
        STAA    L00EA		;Store it, malf flag checksum
;
;-Here if not in field service mode
;
LF9B9   LDAA    L0001		;Load in status word
        BMI     LF9C5		;Bra if motor is running
;
;-Engine off
;
        BITA    #$0002		;Test b1, 
        BNE     LF9DA		;BRa if ==1
;
        ORAA    #$0002		;Set b1
        BRA     LF9C7		;		
;
;-Here if engine on
;
LF9C5   ANDA    #$00FD		;Clr b1
;	
LF9C7   STAA    L0001		;Save
        LDAA    L0002		;Status word
        BITA    #$0008		;Test b3, in backup mode
        BNE     LF9DA		;Bra if ==1, in backup mode
;
        LDAA    L000A		;Load status word
        BITA    #$0001		;Test b0, 
        BNE     LF9DA		;Bra if ==1
;
;-Here to turn off SES light
;
LF9D5   JSR     LFC52		;PWM control routine, turn off SES
        BRA     LF9DD		;
;
;-here to turn on SES
;
LF9DA   JSR     LFC47		;PWM control routine, turn on SES
;
;-Here on shutdown/prom err/SES 
;
LF9DD   LDAA    L0008		;Status word
        ANDA    #$00E7		;Clr b3=one second has elapsed, b4=
        STAA    L0008		;Save status word
        CLRA   			; 
        CLRB    		;
        STD     L0012		;Clr err flags 1,2
        LDAA    L0014		;Err flag 3
        ANDA    #$0010		;Clr b4, prom error
        STAA    L0014		;Save it
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~
;-Blink out err codes
;~~~~~~~~~~~~~~~~~~~~~
;
LF9EE   LDAA    L000C		;Status word
        BITA    #$0040		;Test b6, currently xmitting err code
        BEQ     LFA3F		;Bra if ==0
;
        DEC     L0087		;-1, timer to change state of SES
        BNE     LF9DD		;Bra if !=0
;
        BITA    #$0010		;Test b4, turning off SES light
        BEQ     LFA07		;Bra if ==0, not turning off SES
;
        ANDA    #$00EF		;Clr b4, SES turned off
        LDAB    #0004		;.2 secs, delay to change state of SES
;
LFA01   STAA    L000C		;Status word
;
LFA03   STAB    L0087		;Save delay timer to change state of SES
        BRA     LF9D5		;Bra to turn off SES and return
;
LFA07   BITA    #$0020		;Test b5, xmit out 1's portion of code 
        BNE     LFA15		;bra if ==1
;
        LDAB    L0083		;10's counter
        BNE     LFA1E		;Bra if !=0, not done flashing out 10's portion of err code
;		
        LDAB    #0008		;.8 sec. delay to flash 1's next
        ORAA    #$0020		;Set b5 of L000C, flash out 1's on next pass
        BRA     LFA01		;bra to save and turn off SES
;
LFA15   LDAB    L0084		;1's counter
        BEQ     LFA2B		;Bra if ==0
;
        DEC     L0084		;-1, 1's counter, # of blinks for 1's
        BRA     LFA21		;Bra to turn on SES light
;
LFA1E   DEC     L0083		;-1, 10's counter # of blinks for 10's 
;
LFA21   ORAA    #$0010		;Set b4, turn off SES next pass
        STAA    L000C		;Save status word
        LDAA    #0004		;.2 secs to turn off SES
        STAA    L0087		;Save it, delay timer to change state of SES
        BRA     LF9DA		;Bra to turn on SES
;
LFA2B   LDAB    L0085		;cycle counter
        BITA    #$0003		;Test b0, b1
        BEQ     LFA35		;Bra if ==0, 
;
        SUBA    #$0021		;Clr b5, b0
        BRA     LFA6C		;
;
LFA35   LDAA    L0086		;Stored malf flag
;
;-Bra here if bit from err flag ==0, cycle to find next set bit.
;
LFA37   INCB    		;+1
        CMPB    #0026		;24 cycles (24 bits/3 bytes) 
        BCS     LFA41		;Bra if less, still bits to be checked
        CLRA    		;Clr L000C
        BRA     LFA01		;Bra to save and exit
;
;-Entry point to setup for xmit
;
LFA3F   LDAB    #0002		;Automatically skip to setup to xmit code 12
;
LFA41   CMPB    #0002		;Counter val to load malf flag 1
        BNE     LFA4D		;Bra if !=2
;
;-Load malf. flag 1
;
        LDAA    L00E1		;Malf flag 1
        ANDA    LD409		;Diag mask 
        ROLA    		;Rotate left
        BRA     LFA66
;
LFA4D   CMPB    #0010		;Counter val, first malf flag completed
        BNE     LFA58		;Bra if !=
;
;-Load malf flag 2
;
        LDAA    L00E2		;malf. flag 2
        ANDA    LD40A		;Diag mask
        BRA     LFA63		;
;
LFA58   CMPB    #0018		;Counter val, first two malf flags completed
        BNE     LFA63		;Bra if !=
;
;-Load malf flag 3
;
        LDAA    LD40B		;Diag mask 
        ORAA    #$0010		;Set b4, clr prom err.
        ANDA    L00E3		;malf flag 3
;
LFA63   ROLA  			;Rotate left  
        BCC     LFA37		;Bra if carry not set, cycle to see if any other bits set
;
;-error bit form malf flag !=0
;
LFA66   STAA    L0086		;Store malf. flag value
        STAB    L0085		;save cycle counter
        LDAA    #$0042		;Set b1=, b6=xmitting err code via SES
LFA6C   STAA    L000C		;Save it
        CLRA   			;
; 
LFA6F   INCA 			;+1, 10's counter   
        SUBB    #0005		;-step size for 1's counter
        BHI     LFA6F		;Bra if >0
;
        ADDB    #0005		;add step back in
        STAA    L0083		;save 10's counter
        STAB    L0084		;save 1's counter
        LDAB    #0028		;2.8 + .2, 3 sec delay to flash SES
        BRA     LFA03		;Bra to save and turn off SES
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Alternate entry point for RTS 12
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFA7E   LDAA    $0000,X		;3
        CMPA    #$0003		;
        BNE     LFA88		;Bra if !=3, go get Vac
;
        LDAA    L0043		;%TPS
        BRA     LFA92		;Bra to return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>MAP/Vac lookup
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFA88   LDAA    $0000,X		;Load in MAP/Vac flag
        BNE     LFA90		;Bra if ==1, go get map
;
        LDAA    L002D		;Vacuum
        BRA     LFA92		;Bra to adv addr. and return
;
LFA90   LDAA    L0024		;Get SD map
LFA92   INX     		;addr. +1
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Do default MAP if errors
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFA94   LDAA    L0029		;Load map A/D counts
        LDAB    L0008		;Status word
        BITB    #$00C0		;1100 0000, MAP errs? 
        BEQ     LFAC4		;Bra if Ok
;
;-Uh oh, MAP is broken, create MAP value from tps and RPM
;
	
        LDAB    L0001		;Status word
        BPL     LFAC1		;Bra if engine running
;
        LDAA    LD445		;146
        LDAB    L0043		;%TPS
        MUL 			;Const. x %TPS
;  
        ASLD			;x2    
        BCS     LFAC1		;Bra if overflow set
;
        ASLD 			;x2				   
        BCS     LFAC1		;Bra if overflow
;
; A = (146 x %TPS) / 64
;
        PSHA 			;A ----> stack			   
        LDAA    L001B		;RPM /25
        LSRA  			;/2
;  
        LDX     #LD446		;Go load in table addr.
        LDAB    #$0010		;Load in offset
        JSR     LFB69		;Go do lookup
;
        PULB			;Get converted tps val off the stack    
        ABA 			;Add to MAP bias from lookup
;    
        BCS     LFAC1		;Bra if overflow
        CMPA    LD444		;Default baro
        BLS     LFAC4		;Bra if <= to
;
LFAC1   LDAA    LD444		;204, default baro
; 
LFAC4   LDAB    LD00C		;240, Map filter coeff
        LDX     L0027		;Raw MAP
        BSR     LFB44		;Go filter it
	STD     L0027		;Save it
;
;-Construct map term for gms/sec, BPW
;
;        (A/D MAP x 189 + 5426)  
;L002A = -----------------------  
;                  256
;
;
        LDX     #L0027		;RAW filtered map
        LDAA    #0189		;189		
        JSR     LFC0C		;(A x X*)/256

        ADDD    #5426		;
        STAA    L002A		;MAP term for grms/sec & BPW calc
;
;~~~~~~~~~~~~~~~~~~~~~~
; Do ALDL transmission
;~~~~~~~~~~~~~~~~~~~~~~
;
LFADA   LDD     #$011F		;0000 0001 0001 1111
        STD     LBC12		;ALDL serial data
        LDAA    L0071		;ALDL bits
        BNE     LFB27		;bra if !=0
;				
        LDAA    #$0008		;8, number of bits to xmit
        STAA    L0071		;Save, ALDL bits
        LDAA    L0006		;Status word
        ASRA    		;shift right, test b0
        BCC     LFB12		;Bra if fact. diags. bit ==0
;
;-Factory diags req.
;
        LDX     #LFE62		;
        LDAB    #$000C		;12
        LDAA    L001A		;Scaled rpms
        BEQ     LFB3D		;Bra if rpms ==0
;
LFAF6   ABX     		;Add acc. B to X
        SUBA    #$0010		;Subtract 16
        BHI     LFAF6		;Bra if >0
;
        LDAB    L0072		;# of aldl bytes to be transmitted
        CMPB    #$000B		;11
        BCC     LFB1F		;Bra if ALDL bytes to be xmited >
;
        LSRB    		;shift left
        BCC     LFB08		;Bra if b0 ==1
        LDAA    L0022		;
        BRA     LFB38		;Bra
;				
LFB08   ASLB    		;Shift left holding b7 const.
        ABX     		;Add to addr in X
        LDX     $0000,X		;Load item into acc. X
        LDD     $0000,X		;Load item into Acc AB
        STAB    L0022		;Save it
        BRA     LFB38		;Bra, save as ALDL byte count
;
;-Bra here if in normal mode
;				
LFB12   LDAA    L0002		;Status word
        LDAB    L0072		;# of ALDL bytes to be xmited
        BEQ     LFB38		;Bra if ==0
;
        LDX     #LD3E3		;Location of addr. to be xmitted
        CMPB    #$0014		;20 bytes
        BCS     LFB31		;Bra if less
;
;-Through transmission, reset
;
LFB1F   CLRA    		;Clr
        STAA    L0072		;Store as num of aldl bytes to be xmitted
        DECA    		;-1
        STAA    L0073		;ALDL byte count
        BRA     LFB43		;Bra to exit
;
;-Still have bits to output, see if its time to change the state of the ALDL output
;			
LFB27   DEC     L0071		;-1, ALDL bits
        ASL     L0073		;shift left,
        BCC     LFB3D		;Bra if b7==0
;
        BRA     LFB43		;Bra to exit
;
;-All finished xmitting byte, move down to the next byte
;
LFB31   DECB    		;-1 from ALDL bytes to be xmitted
        ASLB    		;x2, for 16 bit addressing
        ABX     		;Add to X, use as offset
        LDX     $0000,X		;Load in current item into X
        LDAA    $0000,X		;Load in current item into A
;
LFB38   STAA    L0073		;Save it, ALDL byte count
        INC     L0072		;Increment ALDL byte count
;
LFB3D   LDD     #$0017		;0000 0000 0001 0111, bit == 0
        STD     LBC12		;Save it, ALDL serial data
LFB43   RTS  			;return 
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Lag filter subroutine
;>
;>In: 
;>X = old val., A = new value, B = filter coeff
;>
;>Out:
;>                   A x B     X x (256 - B) 
;>filtered output = ------- + --------------- 
;>	              256	    256
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFB44   STX     L004B		;tmp storage, old value
        STAB    L0049		;tmp storage, filter coeff
        BNE     LFB4E		;bra if B!=0, else return old value	
;
        LDD     L004B		;tmp storage, old value
        BRA     LFB67		;RTS, filter coeff == 0
;
LFB4E   MUL			;new value x filter coeff		     
        STD     L004D		;tmp storage
;
        LDAA    L0049		;load lag filter coeff.
	NEGA  			;twos comp., now 256-filt. coeff  
        LDAB    L004C		;LSB of old value
        MUL			;(mod. filt. coeff.) x LSB old value     
        ADCA    #$0000		;add carry, round A up
        STAA    L004A		;tmp storage
;
        LDAA    L0049		;load filter coeff.
        NEGA 			;twos comp.,   
        LDAB    L004B		;load MSB of old value
        MUL			;(mod filt. coeff) x MSB of old value     
        ADDB    L004A		;add in filtered LSB of old val
        ADCA    #$0000		;add carry, round up A
        ADDD    L004D		;add in new value x filter coeff to old value x (256-filter coeff)
;
LFB67   RTS			;return AB = filtered value 
;    
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Entry point for 2D lookup
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFB68   CLRB  
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>2D lookup with upper limit
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
LFB69   CMPA    $0000,X		;Upper lim
        BLS     LFB6F		;Bra if less
;
        LDAA    $0000,X		;Load upper lim
;
LFB6F   INX			;addr. +1     
        BRA     LFB77		;Go subtract offset and do lookup
;
;~~~~~~~~~~~~~~~~~~~~~~
;>
;>2D lookup w/ line count
;>
;~~~~~~~~~~~~~~~~~~~~~~
;
LFB72   LDAB    $0000,X		;Load in line count	
        INX     		;addr. +1
        BRA     LFB7D		;Go do lookup
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>2D lookup with SBA
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFB77   SBA 			;Sub. offset in B from A    
        BCC     LFB7B		;
        CLRA 			;Clear A if less then B   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>2D lookup
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LFB7B   LDAB    #$0010		;#16
LFB7D   MUL   			;A x addr. offset  
        PSHB    		;Push leftovers to the stack
        TAB  			;A ----> B   
        ABX			;Calc. offset     
        LDD     $0000,X		;Get contents of addr. + next
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Entry from 3D lookup rtn
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFB83   STAA    L0049		;tmp storage
;
;-Now interpolate to smooth it out
;
        SBA			;make delta value out of looked up data     
        PULB 			;Get leftovers back   
        BCS     LFB92		;Value ahead is greater then current if carry set, bra
;
;-interpolate down
;   
        MUL  			;delta val. x leftovers 
        NEGA    		;twos comp., (-value)
        ADDA    L0049		;add stored val into A
        ASLB    		;x2
        SBCA    #$0000		;round A down
        BRA     LFB96		;bra to store and exit
;
;-interpolate up
;
LFB92   NEGA    		;twos comp. (-value)
        MUL     		;delta val. x leftovers
        ADCA    L0049		;Add in stored val. with carry
LFB96   STAA    L0049		;tmp storage	
        RTS  			;return 
;   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>3D lookup routine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFB99   SUBA    $0000,X		;Subtract row offset from A
        BCC     LFB9E		;Bra if > offset
;
        CLRA 			;Clr A 
;  
LFB9E   SUBB    $0001,X		;Subtract column offset from B
;
        BCC     LFBA3		;Bra if > offset
;
        CLRB			;Clr B
;    
LFBA3   STAB    L004B		;tmp storage
        LDAB    #$0010		;
        MUL  			;Calc column offset   
        PSHB			;Push the leftovers to the stack
;    
        LDAB    $0002,X		;Load in # of cols. into B
        PSHB  			;Push that to the stack too  
        MUL 			;Offset in A x # cols.      
        ABX 			;Add in offset to X
;   
        INX			;Addr +1     
        INX 			; "    
        INX 			; "   
        PSHX 			;Addr of column ----> stack   
        LDAA    L004B		;Load row offset into A
        BSR     LFB7B		;Go do 2D lookup
;
        STAA    L004A		;tmp storage
        LDAA    L004B		;load row offset into B
        PULX    		;Get column address off the stack
        PULB  			;Get # of columns from stack  
        ABX 			;Add # of columns to X, go over one row    
        BSR     LFB7B		;2D lookup, get value next to it
        TAB			;Value ----> B     
        LDAA    L004A		;Get that value back into A
        BRA     LFB83		;Go interpolate it and return
;	
;~~~~~~~~~~~~~~~~~~~~~~
;>
;>Do baro adj. of %TPS
;>
;~~~~~~~~~~~~~~~~~~~~~~
;
LFBC4   LDX     #LD4C9		;
;
LFBC7   BSR     LFBD1		;Go get baro
        BSR     LFB77		;2D lookup with SBA
        LDAB    L0043		;%TPS
        MUL     		;A = (looked up val x %TPS)/256
        ADCA    #$0000		;Round if needed	
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Baro read in and conversion routine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFBD1   LDAA    L00FE		;Baro, A/D counts
;
;-Convert it over for scaled read
;
        SUBA    #$000D		;- 13
        LDAB    #$0097		; 151		
        MUL  			;A = ((Baro, A/D counts -13) x 151)/256   
	ADCA    #$0000		;Round up A
;
        CMPA    #$008F		;Max value for table read
        BLS     LFBE0		;Bra if less 
        LDAA    #$008F		;Load in max allowed value for table read
LFBE0   LDAB    #$0060		;lower limit for lookup,
        STAA    L0049		;Converted baro A/D counts to tmp storage
        RTS  			;return
;   
;~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>16 bit division routine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Acc. D contains the 32 bit value/256
;
;-L004B, L004C contain the value to divide by 
;
LFBE5   LDX     #$FFFF		;1111 1111 1111 1111
        STX     L0049		;tmp storage
        SUBD    L004B		;min value - value
        BCS     LFBF4		;Bra if value greater then min value
;
        BRA     LFC09		;Bra, load max result of $FFFF and return
;
;-Start dividing here
;
LFBF0   SUBD    L004B		; - value 
        BCC     LFBF9		;Bra if carry clear
;
LFBF4   ADDD    L004B		;add value back in
        CLC     		;clr C bit
        BRA     LFBFA		;Bra
;
LFBF9   SEC     		;Set C bit
;
LFBFA   ROL     L004A		;Rotate left LSB
        ROL     L0049		;Rotate left MSB
        BCC     LFC09		;Bra if C bit ==0, return result
;
        ASLD    		;Shift left
        BCC     LFBF0		;bra if no overflow
;
        SUBD    L004B		; - value
        BRA     LFBF9		;bra to repeat
;
;-Finished dividing, return the result...
;
LFC09   LDD     L0049		;Load in the result of the divide op.
        RTS  		  	;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>8 x 16 multiply routine
;>
;> (A x X*)/256
;> * X points to addr.
;>
;>  A = 8 bit val, X = addr. of 16 bit value
;> AB = result
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFC0C   STAA    L0049		;tmp storage
;
        LDAB    $0001,X		;LSB
        MUL			;A x B     
        ASLB 			;x2   
        ADCA    #$0000		;Round up
        STAA    L004A		;tmp storage
;
        LDAA    $0000,X		;MSB	
        LDAB    L0049		;Get 8 bit val.
        MUL    			;A x B 
        STAA    L0049		;tmp storage
;
        CLRA    
        ADDD    L0049		;Add in results of both calcs
        RTS  			;return
;   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>A/D routine w/ wait for data
;> In:  A = channel to read
;>	B = 0,1, 1=return imm
;> Out: A, B = data
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; $00 = Fuel pump volts
; $01 = ??
; $02 = batt.
; $03 = 02
; $04 = CTS
; $05 = MAP
; $0A = IAT
; $0B = TPS
; $0C = ALDL Diag.
; $0D = ground
; $0E = ground
; $0F = ground
;
LFC21   PSHB    		;B ----> stack
        TAB     		;A ----> B, chanel to read
        ORAB    L0067		;Bit for A/D hardware, init to $80
        LDAA    #$0001		;
        STD     LC002		;Store it 	
;
        PULB  			;Stack ----> B		  
        TSTB    		;
        BNE     LFC46		;bra if !=0, return
;
;-Entry to receve data
;
LFC2E   LDX     #$0019		;#25, counter 
LFC31   LDAA    LC000		;A/D conv.
        BMI     LFC42		;test b7
        DEX     		;-1
        BNE     LFC31		;try again if >0
;
        LDAA    L0014		;Error flag 3
        ORAA    #$0001		;A/D error
        STAA    L0014		;Store it
        CLRA    		;
        BRA     LFC46		;return
;
LFC42   LDD     LC000		;Load in raw data
        TBA     		;Transfer to A as well
LFC46   RTS 			;Return
;    
;~~~~~~~~~~~~~~~~~~~~~~~
;>
;>SES light/PWM control
;>
;~~~~~~~~~~~~~~~~~~~~~~~
; 
;-SES light on entry point
;
LFC47   LDAA    #$00F7		;1111 0111, ses on
LFC49   LDX     LBC3C		;PWM
        STX     L004F		;tmp storage
        ANDA    L0050		;clr bit for SES/misc.
        BRA     LFC5B		;Go do the work
;
;-SES light off entry point
;
LFC52   LDAA    #$0008		;0000 1000, ses off
LFC54   LDX     LBC3C		;PWM
        STX     L004F		;tmp storage 
        ORAA    L0050		;set bit for SES/misc. 
; 
;-Do the work
;
LFC5B   ANDA    #$00FE		;1111 1110	
        ORAA    #$0022		;0010 0010 
        STAA    L0050		;store it, LSB
        LDAA    L004F		;Load MSB
        ANDA    #$00FB		;1111 1011 
        ORAA    #$00F9		;1111 1001		
        STAA    L004F		;tmp storage
        LDX     L004F		;tmp storage, MSB + LSB
        STX     LBC3C		;PWM
        RTS			;return    
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Entry point for multiply routine
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFC6F   BCC     LFC73		;Check for carry set
;
        CLRA 			;Clr A  	
;		 
        RTS			;Return
;     
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Multiply subroutine
;> A = (A x B)/128
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFC73   MUL  		        ;A * B   
        ASLD 		        ;x2   
        BCS     LFC7D		;Carry set?
        TSTB    		;b7=1, round up needed
        BPL     LFC7F		;Return w/ data
        INCA    		;Round A up
        BNE     LFC7F		;Check for overflow
LFC7D   LDAA    #$00FF		;Clear overflow
LFC7F   RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Continuation of RTS 2
;>
;~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Pseudo-baro stuff
;
LFC80   CLRA			;    
        LDAB    L0000		;Status word
        BITB    #$0010		;Test b4, engine shutdown in effect
        BNE     LFCB7		;Bra if shutting down
;
	LDAB    L0027		;Raw MAP
        CMPB    L00FE		;Baro, A/D counts	
        BHI     LFCB7		;Bra if MAP is higher
;
;-MAP is less then baro here
;
        LDAA    L001A		;Scaled rpms (opps... supppsed to be rpms/25) 
        CMPA    LD01B		;200, 5000 rpms, max rpms for pseudo-baro read
        BHI     LFCC7		;Bra if scaled rpms are greater
;
        LDAA    L0043		;%TPS
        CMPA    LD01C		;50% tps, max for pseudo-baro
        BLS     LFCC7		;Go lookup %VE correction vs. baro and return
;
;%TPS > 50%
;
        SUBA    L0045		;%TPS, slow filtered		
        BCC     LFCA0		;bra if no underfow
;
        NEGA    		;2s comp

LFCA0   CMPA    LD01D		;3.9% tps, max delta tps for pseudo baro	
        BHI     LFCC7		;Bra if greater, go do baro lookup
;
;		       (factor x (rpm/25 - 16)	
;Added baro counts = -------------------------
;		               256			
;
        LDAA    L0043		;%TPS
        LDX     #LD1C0		;Factor
        JSR     LFB72		;2D lookup with line count
        LDAB    L001B		;RPMS/25
        SUBB    #0016		; - 400 rpm
        BCC     LFCB4		;Bra if no underflow
;
        CLRB    		;Clr underflow
;
LFCB4   MUL     		;Correction factor x (rpm/25 -16)
        ADCA    #$0000		;Round if needed
;
;-Map is greater or less then Baro here
;
LFCB7   ADDA    L0027		;Add in MAP to pseudo - baro 
        BCC     LFCBD		;Bra if no overflow
;
        LDAA    #$00FF		;Clr overflow
;
LFCBD   LDAB    LD01E		;192, baro filter coeff
        LDX     L00FE		;Baro
        JSR     LFB44		;Lag filter routine
        BRA     LFCCF		;Bra to save
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Baro and lookup for Baro %VE lookup
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFCC7   LDAA    L00FE		;Baro pressure
        BNE     LFCD1		;bra if !=0
;
;-init baro to default value
;
        LDAA    LD444		;init to 218
        CLRB    		;
LFCCF   STD     L00FE		;Store @ $FE, Baro pressure	
;	
LFCD1   LSRA    		;/2
        LDX     #LFE57		;table addr
        LDAB    #$0040		;#64
        JSR     LFB77		;Lookup with SBA
        STAA    L002F		;Store factor
        RTS     		;Return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Get diagnostics mask into tmp storage
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFCDD   LDD     LD409		;diag mask
        ORAA    #$0080		;Set b7, code 12, no drps manditory
        STD     L0049		;Save to tmp storage
        LDAA    LD40B		;Load diag word
        ORAA    #$0010		;Set b4, Code 51, eprom error manditory
        STAA    L004B		;Save to tmp storage
        RTS     
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>TPS subroutine, filter and convert to %TPS
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFCEC   LDAA    L0043		;% TPS from idle
        STAA    L0044		;Store it, one delayed
        LDAA    L0042		;Load tps A/D counts
;
        LDAB    L0008		;Status word
        BITB    #$0024		;test b2 & b5
        BEQ     LFCFB		;Diag bits clear, continue
;
        LDAA    LD420		;80, default value on err.
;
LFCFB   PSHA  			;A ----> stack  
        LDAB    L0047		;idle tps MSB	
        CBA 			;    
        BHI     LFD0B		;bra if tps counts are greater then min tps setting
;
        LDX     L0047		;idle tps 
        LDAB    LD1D5		;1, filter coeff.
        JSR     LFB44		;lag filter it
        STD     L0047		;Store it
;
LFD0B   LDD     L0047		;idle TPS
        TSTB   			;test b7 
        BPL     LFD11		;no round needed
        INCA    		;round up A
LFD11   TAB     		;MSB of idle TPS
        PULA    		;get TPS
        SBA			;subtract min tps from TPS, now TPS-idle TPS     
        BCC     LFD17		;Bra if tps less then idle tps
;			
        CLRA    		;clear TPS, now 0% tps
;
;-Convert to %TPS
;
LFD17   LDAB    LD1D3		;117, scaler for tps conv.		
        MUL 			;TPS x scaler   
        ASLD 			;shift left   
        BCS     LFD27		;clr overflow if carry set
;
        ASLD    		;shift left
        BCS     LFD27		;
;
        TSTB    		;b7		
        BPL     LFD29		;b7 == 0, no roundup
        INCA   			;roundup 
        BNE     LFD29		;!=0, go save it, else clr overflow
;
LFD27   LDAA    #$00FF		;$FF, clear overflow
;
LFD29   STAA    L0043		;now %TPS
;
;-Common delay location
;		
LFD2B   RTS   			;return
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Malf. flags checksum subroutine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LFD2C   LDX     #$0003		;3 byte offset
        CLRA    		;
LFD30   ADDA    $00E0,X		;Add addr in
        ASLA    		;x2
        ADCA    #$0000		;add in C bit
        DEX     		;-1
        BNE     LFD30		;X>0, repeat
        RTS    			;return
; 		
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>CTS init. and diag. subroutine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFD39   LDAA    #$0004		;CTS channel
        CLRB    		;0, read in data
        JSR     LFC21		;A/D routine w/ wait for data
        STAA    L0022		;A/D coolant counts
        PSHA   			;A ----> stack 		
        LDAA    L000A		;Status word
        BITA    #$0020		;test b5
        BNE     LFD54		;bra if ==1		
;
        LDD     L00EB		;Engine run time
        LSRD    		;/2
        LDAA    L000A		;Status word
        CMPB    LD417		;1, two seconds
        BLS     LFD54		;bra if <=1, No diags. yet.
        ORAA    #$0020		;set b5, perform diags.
LFD54   ANDA    #$00F7		;clr b3
        STAA    L000A		;store status word
;
;~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 14, CTS high test
;~~~~~~~~~~~~~~~~~~~~~~~~
;
        PULA  			;get coolant counts off stack  
        CMPA    LD418		;counts, 18
        BCC     LFD7B		;cool. counts >=, bra
        LDAB    L000A		;Load status word
        BITB    #$0020		;test b5, diag bit
        BNE     LFD6C		;if ==1, set error
;
        LDAB    L00E1		;Malf. flag
        BITB    #$0020		;test b5, CTS error
        BEQ     LFD7B		;==0
        BRA     LFD72		;Go set CTS temp high error and load default val.
 ;
LFD6C   LDAB    L0012		;error flag 1
        ORAB    #$0020		;set b5, CTS temp high error
        STAB    L0012		;store it
;				
LFD72   LDAB    L000A		;Status word
        ORAB    #$0008		;Set b3, CTS err.
        STAB    L000A		;Store it
;
        LDAA    LD41B		;100, default counts for failure
LFD7B   PSHA    		;A ----> stack
        LDAA    L000A		;Status word
        BITA    #$0010		;test b4, diag bit
        BNE     LFD90		;Go do CTS low test
;
        LDD     L00EB		;Engine run time
        LSRD    		;/2
        CMPB    LD419		;15, 30 secs.	
        BLS     LFD90		;Bra if
;			 
        LDAA    L000A		;Status word
        ORAA    #$0010		;Flag to run diags on next pass
        STAA    L000A		;store it
;
;-CTS low test
;
LFD90   PULA   			;Get A/D cool counts off stack 
        CMPA    LD41A		;Max counts, 252
        BLS     LFDB9		;Bra if less, store coolant counts and return
;		
        LDAB    L000A		;Status word	
        BITB    #$0010		;b4, CTS high
        BNE     LFDAA		;if ==1, go set err imm.
;
        LDAB    L00E1		;Malf flag
        BITB    #$0010		;Test b5, cts error
        BNE     LFDB0		;if ==1, set CTS malf. bit imm.
;
        LDAB    L0008		;Status word
        BITB    #$0001		;
        BEQ     LFDB9		;if ==1, save and exit
        BRA     LFDB0		;Set CTS error bit
 ;
LFDAA   LDAB    L0012		;Err flag 1
        ORAB    #$0010		;Set b4, CTS temp. low err
        STAB    L0012		;Store it
;
LFDB0   LDAB    L000A		;Status word
        ORAB    #$0008		;Set b3, CTS error
        STAB    L000A		;Store it
;
        LDAA    LD41B		;load default value
LFDB9   STAA    L0020		;Store it 
        RTS     		;return
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;> 
;>IAT lookup + diag. subroutine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFDBC   LDAA    #$000A		;IAT channel		
	CLRB			;Clr B, do lookup    
        JSR     LFC21		;A/D conv. routine w/ wait for data
        STAA    L0023		;Store raw val at L0023
;
        LDAB    L000B		;Status word
        LDX     L00EB		;Engine run time
        CPX     LD422		;1 sec
        BLS     LFE0C		;Bra if less or same, not time for diag yet
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 23, IAT temp low test
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
        CMPA    LD421		;245 counts, max allow. counts
        BLS     LFDDF		;Bra if lower
        BITB    #$0020		;Test b5, diag bit
        BNE     LFE01		;Bra if ==1, set error
;
        ORAB    #$0020		;Set b5, diag bit
        LDAA    L0030		;MPH, filtered, MSB	
        CMPA    LD424		;20 mph
        BLS     LFDE1		;Bra if below thresh. to clear b5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Code 25, IAT temp high test
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFDDF   ANDB    #$00DF		;clear b5, diag. bit
LFDE1   LDAA    L0023		;load IAT back in
        CMPA    LD42B		;30, min allow counts.
        BHI     LFDF5		;Bra if IAT counts are higher
;
        BITB    #$0040		;Test b6, IAT error bit
        BNE     LFDF9		;b6==1, Set error			
        ORAB    #$0040		;set b6
;
        LDAA    L0030		;mph, filtered MSB
        CMPA    LD424		;20 mph
        BHI     LFE0C		;above threshold to clear diag bit
LFDF5   ANDB    #$00BF		;clear b6
        BRA     LFE0C		;bra to save current vals.
;
LFDF9   LDAA    L0013		;Err. flag 2
        ORAA    #$0080		;set b7, IAT temp high
        STAA    L0013		;store it
;
        BRA     LFE07		;Go set default IAT value
;
LFE01   LDAA    L0012		;Err. flag 1
        ORAA    #$0002		;b1, IAT temp. low error
        STAA    L0012		;Store it

LFE07   LDAA    LD425		;Load in default IAT counts, 152 = 40 C, used upon error		
        STAA    L0023		;Store default IAT counts
;
LFE0C   STAB    L000B		;Store status word
        RTS 			;Return
;    
;~~~~~~~~~~~~~~~~~~~~~~
;
;-Reset BLM cells
;
;~~~~~~~~~~~~~~~~~~~~~~
;
LFE0F	 LDX     #L00ED		;Start of BLMs in memory
         LDAA    #$0080		;128
LFE14    STAA    $0000,X	;Reset address with 128
         INX			;+1     
         CPX     #$00FC		;Last address to reset
         BLS     LFE14		;X <= $00FC, repeat
         RTS			;Return  
;   
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Go do HU if needed/ RTS 7
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFE1D   LDAA    L0000		;Status word
        BITA    #$0002		;Test b1
        BEQ     LFE26		;bra if ==0, no HU
        JSR     L5809		;Go do HU
LFE26   RTS 			;Return    
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 11* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFE27   LDAA    L00D3		;Stack check word
        BEQ     LFE31		;Bra if ==0, no stack overflow
;
        LDAA    L0000		;Status word
        ORAA    #$0004		;Set b2, stack overflow err
        STAA    L0000		;Save status word
;
LFE31   LDX     #$0199		;
        STX     LBC0C		;
        LDAB    #$0010		;
        LDX     #$0000		;
        BRA     LFE48		;Bra to do ram refresh
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 13* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFE3E   LDX     #L0040		;
        BRA     LFE46		;Go do ram refresh
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;  
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>   *Real time service routine 15* 
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;-Refresh RAM
;
LFE43   LDX     #L00A0		;
;
;-Alternate entry point
;
LFE46   LDAB    #$0018		;memory addr. to and
;
;-Alternate entry point
;
LFE48   STS     L0049		;Save current stack pointer
        TXS     		;Transfer to stack pointer
LFE4B   PULX    		;Get addr. into the stack
        PSHX    		;Push it back to memory
        PULX 			;   
        PULX    		;Get the addr. into X
        PSHX    		;Push it back to memory
LFE50   PULX    		;
        DECB 			;Move to next addr   
        BNE     LFE4B		;Bra if !=0
;
        LDS     L0049		;Restore stack pointer
        RTS  			;Return   
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Map const mult. vs baro table
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;           
;               		;kPa
;		
LFE57   FCB   135		; 65
        FCB   109 		; 75
        FCB   93                ; 85    
        FCB   81                ; 95
        FCB   72                ;105
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~
;-Inverse AFR lookup table
;~~~~~~~~~~~~~~~~~~~~~~~~~
;	         
LFE5C   FCB   16		;16 lines  
;
;            AFR         	;afr  
;  
LFE5D   FCB  255 		; 0.0	
LFE5E   FCB  255 		; 1.6
LFE5F	FCB  255                ; 3.2
LFE60   FCB  255 		; 4.8
LFE61	FCB  255 		; 6.4
LFE62	FCB  205                ; 8.0 
LFE63   FCB  171 		; 9.6
LFE64   FCB  146                ;11.2    	   
LFE65   FCB  128 		;12.8
LFE66   FCB  114                ;14.4     	 
LFE67   FCB  102 		;16.0
LFE68	FCB   93                ;17.6   	
LFE69   FCB   85                ;19.2          
LFE6A   FCB   79                ;20.8             
LFE6B   FCB   73                ;22.4            
LFE6C   FCB   68                ;24.0            
LFE6D   FCB   64                ;25.5
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;-Factory aldl diags xmit list
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFE6E 	FDB   L0028		; 
LFE70 	FDB   L002A		; 
LFE72 	FDB   L0030		; 
LFE74 	FDB   L0032		; 
LFE76 	FDB   L0034		; 
LFE78 	FDB   L0026		; 
LFE7A 	FDB   L001C		; 
LFE7C 	FDB   L0012		; 
LFE7E 	FDB   L0014		; 
LFE80 	FDB   L0016		; 
LFE82 	FDB   LD002		; 
LFE84 	FDB   L0066		; 
LFE86	FDB   $BC00		; 
LFE88 	FDB   $BC02		; 
LFE8A 	FDB   $BC04		; 
LFE8C 	FDB   $BC06		; 
LFE8E 	FDB   $BC0A		; 
LFE90 	FDB   L0020		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Factory Diags
;>                            
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFE92   JSR     LFF2C		;
LFF95   BCC     LFF95		;
        LDX     LBC3C    	;
        STX     L0018		;
        JSR     LFF25		;
        CLRB    		;
        CMPA    #$0028		;
        BLS     LFEC1		;
        LDAB    L0023		;
        BEQ     LFEC2		;
        CMPA    #$005A		;
        BCS     LFEC2		;
        CLRB    		;
        LDAA    L0881		;
        ANDA    #$0030		;
        CMPA    L001A		;
        BEQ     LFEC2		;
        STAA    L001A		;
        STAB    L0071		;
        STAB    L0066		;
LFEBC   STAB    L001B		;
        DECB    		;
        STAB    L0072		;
LFEC1   INCB    		;
LFEC2   STAB    L0023		;
        JSR     LFADA		;
        LDD     L0018		;
        EORB    #$0004		;
        STD     LBC3C		;
        LDAA    L001A		;
        BEQ     LFEF8		;
        LDAB    L0881		;
        EORB    #$0008		;
        STAB    L0881		;
        CMPA    #$0020		;
        BNE     LFF3A		;
				;
        CLRA    		;
        LDAB    #$00C5		;
        STD     LBC14		;
        LDX     #$0100		;
        STX     L004D		;
        LDX     #L00DD		;
        JSR     LE32B		;
        STD     L001C		;
        LDD     L0018		;
        ORAB    #$0080		;
        STD     LBC3C		;
LFEF8   LDD     L0018		;
        ANDA    #$00F7		;
        ANDB    #$006F		;
        ORAB    #$0008		;
        CLR     L0881		;
        STD     LBC3C		;
        CLR     L0801		;
        LDX     #$BC0E		;
        CLRA    		;
        CLRB    		;
        STD     $0000,X		;
        BSR     LFF2B		;
        STD     $0006,X		;
        LDAA    #$00F0		;
        BSR     LFF2B		;
        STD     $0008,X		;
        BSR     LFF2B		;
        STD     $000A,X		;
        BSR     LFF2B		;
        STD     $000C,X		;
        JMP     LFFED		;
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>Read Batt. volts channel
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFF25   LDAA    #$0002		;
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>-Used in conj with A/D routine
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;              
LFF27   CLRB  			;clear B, read data.  
        JSR     LFC21		;Go do A/D routine
LFF2B   RTS  			;return
;   
;~~~~~~~~~~~~~~~~~~~~~~~
;>
;>ALDL channel read 
;>
;~~~~~~~~~~~~~~~~~~~~~~~
;
LFF2C   LDAA    #$000C		;ALDL diag channel
        BSR     LFF27		;A/D routine
        CMPA    #0040		;Counts, ALDL shorted if less, field service mode
        BCS     LFF38		;bra to clear carry
;
        CMPA    #0100		;ALDL not shorted, either in backup or ALDL mode
        BCS     LFF39		;Bra to return
;
LFF38   CLC  			;Clear carry bit   
LFF39   RTS 			;Return   
; 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;>
;>More fact. diags/test stuff
;>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
LFF3A   LDAA    L0801		;
        LSRB    		;
        LSRB    		;
        LSRB    		;
        LSRB    		;
        ANDA    #$00F0		;
        ABA     		;
        STAA    L0020		;
        LDAA    L0066		;
        ANDA    #$000F		;
        PSHA   			; 
        BSR     LFF27		;
        LDX     #L0026		;
        PULB    		;
        ABX    			; 
        STAA    $0000,X		;
        TSTB    		;
        BNE     LFFA5		;
;
        LDAB    #$0080		;
        LDAA    L001B		;
        BNE     LFF5F		;
;
        LDAA    #$0003		;
LFF5F   DECA    		;
        STAA    L001B		;
        BEQ     LFF6C		;
        LDAB    #$001A		;
        CMPA    #$0002		;
        BNE     LFF6C		;
;
        LDAB    #$00E6		;
LFF6C   LDX     #$F000		;
        ABX     		;
        STX     LBC16		;
        LDAA    L0801		;
        ANDA    #$000F		;
        BNE     LFF7C		;
;
        LDAA    #$0010		;
LFF7C   LSRA    		;
        STX     LBC18		;
        STAA    L0801		;
        LDD     L0018		;
        ORAB    #$0018		;
        BCC     LFF8B		;
        ANDB    #$00F7		;
LFF8B   STD     LBC3C		;
        LDAA    L0021		;
        ASLA    		;
        ADCA    #$0000		;
        STAA    L0021		;	
        ANDA    #$0003		;
        STX     LBC1A		;
        LDAB    L0881		;
        ANDB    #$00FC		;
        ORAB    #$0004		;
        ABA     		;
        STAA    L0881		;
LFFA5   LDX     LBC00		;
        JSR     LFF2B		;
        LDD     LBC00		;
        LSRD    		;
        LSRD    		;
        STD     L001E		;
        LDD     #$028F		;
        CPX     #$028F		;
        BHI     LFFCB		;
        CPX     #$0148		;
        BCS     LFFD5		;
        LSRD    		;
        STD     LBC0E		;
        LDAB    #$0006		;
        STD     L004B		;
        CLRA    		;
        CLRB    		;
        BRA     LFFE2		;
;			
LFFCB   STD     LBC0E		;
LFFCD   LSRD    		;
        STD     L004B		;
        LDD     L001E		;
        BRA     LFFE2		;
;				
LFFD5   CLRA    		;
        LDAB    #$0042		;
        STD     LBC0E		;
        LDAB    #$00C5		;
        STD     L004B		;
        CLRB    		;
        SUBD    L001E		;
LFFE2   LDX     L004B		;
        STX     LBC1C		;
        JSR     LFD2B		;
        STD     LBC36		;
LFFED   JSR     LFE31		;
        JMP     LE49E		;
;			
;~~~~~~~~~~~~~~~~~~~~
;>
;>Vector table
;> 
;~~~~~~~~~~~~~~~~~~~~
;
 	ORG 	$FFF3
;
LFFF3   FCB       $7E 
;
LFFF4   FDB     LDF8F       	;            
LFFF6   FDB     LE356           ;RTI            
LFFF8   FDB     LE34F		;Vector handler
LFFFA   FDB     LE356 		;RTI
LFFFC   FDB     LE170		;Reset Vector
LFFFE   FDB     LE170		;Reset Vector
                      
